// CAM_Options.cpp : t@C
//

#include "stdafx.h"
#include "FreePcb.h"
#include "CAM_Options.h"


// CCAM_Options

IMPLEMENT_SERIAL(CCAM_Options,CObject,1)

/*=============================================================================

=============================================================================*/

CCAM_Options::CCAM_Options()
{
	Reset();
}

CCAM_Options::~CCAM_Options()
{
}


// CCAM_Options o֐


void CCAM_Options::Reset()
{
	m_cam_flags                 = GERBER_BOARD_OUTLINE|GERBER_NO_CLEARANCE_SMCUTOUTS;
	m_cam_units                 = MIL;									/*														*/
	m_fill_clearance            = 10*NM_PER_MIL;						/*														*/
	m_mask_clearance            =  8*NM_PER_MIL;						/*														*/
	m_paste_shrink              =  0;									/*														*/
	m_thermal_width             = 10*NM_PER_MIL;						/*														*/
	m_min_silkscreen_stroke_wid =  5*NM_PER_MIL;						/*														*/
	m_pilot_diameter            = 10*NM_PER_MIL;						/*														*/
	m_outline_width             =  5*NM_PER_MIL;						/*														*/
	m_hole_clearance            = 15*NM_PER_MIL;						/*														*/
	m_cam_layers                = 0xf00fff;								/* default layers										*/
	m_cam_drill_file            =  1;									/*														*/
	m_annular_ring_pins         =  7*NM_PER_MIL;						/*														*/
	m_annular_ring_vias         =  5*NM_PER_MIL;						/*														*/
	m_n_x                      =1;										/* # of PCBs to panelize in Horizontal					*/
	m_n_y                      =1;										/* # of PCBs to panelize in Vertical					*/
	m_space_x                  =0;										/* Horizontal space to panelize, between board-edge.	*/
	m_space_y                  =0;										/* Vertical space to panelize, between board-edge.		*/
}

const CCAM_Options& CCAM_Options::operator=(const CCAM_Options& objSrc)
{
	m_cam_flags                =objSrc.m_cam_flags;						/*														*/
	m_cam_units                =objSrc.m_cam_units;						/*														*/
	m_fill_clearance           =objSrc.m_fill_clearance; 				/*														*/
	m_mask_clearance           =objSrc.m_mask_clearance;				/*														*/
	m_paste_shrink             =objSrc.m_paste_shrink;					/*														*/
	m_thermal_width            =objSrc.m_thermal_width;					/*														*/
	m_min_silkscreen_stroke_wid=objSrc.m_min_silkscreen_stroke_wid;		/*														*/
	m_pilot_diameter           =objSrc.m_pilot_diameter;				/*														*/
	m_outline_width            =objSrc.m_outline_width;					/*														*/
	m_hole_clearance           =objSrc.m_hole_clearance;				/*														*/
	m_cam_layers               =objSrc.m_cam_layers;					/*														*/
	m_cam_drill_file           =objSrc.m_cam_drill_file;				/*														*/
	m_annular_ring_pins        =objSrc.m_annular_ring_pins;				/*														*/
	m_annular_ring_vias        =objSrc.m_annular_ring_vias;				/*														*/
	m_n_x                      =objSrc.m_n_x;							/* # of PCBs to panelize in Horizontal					*/
	m_n_y                      =objSrc.m_n_y;							/* # of PCBs to panelize in Vertical					*/
	m_space_x                  =objSrc.m_space_x;						/* Horizontal space to panelize, between board-edge.	*/
	m_space_y                  =objSrc.m_space_y;						/* Vertical space to panelize, between board-edge.		*/

	return *this;
}
