#pragma once

#include "Gerber.h"


// CCAM_Options R}h ^[Qbg

class CCAM_Options : public CObject
{
	DECLARE_SERIAL( CCAM_Options )
//--------------------------------------
//--------------------------------------
public:
	CCAM_Options();
	CCAM_Options(const CCAM_Options &objSrc) { *this=objSrc; }
	virtual ~CCAM_Options();
//----------------------------------------
// 
//----------------------------------------
	virtual void Reset();
	const CCAM_Options& operator=(const CCAM_Options& objSrc);

//----------------------------------------
// 
//----------------------------------------
	BOOL	IsOutputBoardOutline() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_BOARD_OUTLINE); }				/**< O`ǉ						*/
	BOOL	IsOutputAutoMoiris() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_AUTO_MOIRES); }					/**< tBʒu킹}[Nǉ			*/
	BOOL	IsOutputLayerNameText() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_LAYER_TEXT); }					/**< o̓Cŵǉ			*/
	BOOL	IsOutputPilotHoles() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_PILOT_HOLES); }					/**< pbhɃhp̃KChǉ		*/
	BOOL	IsOutputPinThermals() const				{ ASSERT_KINDOF(CCAM_Options,this); return(!(m_cam_flags & GERBER_NO_PIN_THERMALS)); }			/**< [hĩX[sT[}ɂȂ	*/
	BOOL	IsOutputViaThermals() const				{ ASSERT_KINDOF(CCAM_Options,this); return(!(m_cam_flags & GERBER_NO_VIA_THERMALS)); }			/**< rAT[}hɂȂ				*/
	BOOL	IsOutputSolerMaskedVia() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_MASK_VIAS); }					/**< \_WXgɃrÂ蔲쐬Ȃ	*/
	BOOL	IsOutput90degreeThermals() const		{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_90_THERMALS); }					/**< ۃpbhp̃T[}90x]			*/
	BOOL	IsOutputRenderImageFiles() const		{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_RENDER_ALL); }					/**< K[oPNG`摜t@Cŏo͂		*/
	BOOL	IsOutputRenderTopBottom() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_RENDER_TOP_BOTTOM); }			/**< K[ȍ㉺𔽓](T|[g???)		*/
	BOOL	IsOutputMirroredBottomLayers() const	{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_MIRROR_BOTTOM_PNG); }			/**< ʂ̃CPNGo͂ۂɔ]	*/
	BOOL	IsOutputSMTThermals() const				{ ASSERT_KINDOF(CCAM_Options,this); return(!(m_cam_flags & GERBER_NO_SMT_THERMALS)); }			/**< \ʎ(SMT)pbhT[}ɂȂ		*/
	BOOL	IsOutputNoClearanceSmcutouts() const	{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_NO_CLEARANCE_SMCUTOUTS); }		/**< \_}XN̔pbhƓlɈȂ	*/
	BOOL	IsOutputPlotInnerNegative()	const		{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags & GERBER_PLOT_INNER_NEGATIVE); }			/**< wC(L1`L14)lKo͂			*/

	int		GetCAM_Flags() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_flags); }								/**<													*/
	int		GetCAM_Units() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_units); }								/**<													*/
	int		GetFillClearance() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_fill_clearance); } 						/**<													*/
	int		GetMaskClearance() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_mask_clearance); }							/**<													*/
	int		GetPasteShrink() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_paste_shrink); }							/**<													*/
	int		GetThermalWidth() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_thermal_width); }							/**<													*/
	int		GetMminSilkscreenStrokeWidth() const	{ ASSERT_KINDOF(CCAM_Options,this); return(m_min_silkscreen_stroke_wid); }				/**<													*/
	int		GetpilotHoleDiameter() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_pilot_diameter); }							/**<													*/
	int		GetOutlineWidth() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_outline_width); }							/**<													*/
	int		GetHoleClearance() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_hole_clearance); }							/**<													*/
	int		GetCAM_Layers() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_layers); }								/**<													*/
	int		GetCamDrillFile() const					{ ASSERT_KINDOF(CCAM_Options,this); return(m_cam_drill_file); }							/**<													*/
	int		GetAnnularRingPins() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_annular_ring_pins); }						/**<													*/
	int		GetAnnularRingVias() const				{ ASSERT_KINDOF(CCAM_Options,this); return(m_annular_ring_vias); }						/**<													*/
	int		GetPanelizeBoardCount_x() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_n_x); }									/**< # of PCBs to panelize in Horizontal				*/
	int		GetPanelizeBoardCount_y() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_n_y); }									/**< # of PCBs to panelize in Vertical					*/
	int		GetPanelizeBoardSpace_x() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_space_x); }								/**< Horizontal space to panelize, between board-edge.	*/
	int		GetPanelizeBoardSpace_y() const			{ ASSERT_KINDOF(CCAM_Options,this); return(m_space_y); }								/**< Vertical space to panelize, between board-edge.	*/
//----------------------------------------
// CAM flags and parameters
//----------------------------------------
protected:
	int		m_cam_flags;						/**<													*/
	int		m_cam_units;						/**<													*/
	int		m_fill_clearance; 					/**<													*/
	int		m_mask_clearance;					/**<													*/
	int		m_paste_shrink;						/**<													*/
	int		m_thermal_width;					/**<													*/
	int		m_min_silkscreen_stroke_wid;		/**<													*/
	int		m_pilot_diameter;					/**<													*/
	int		m_outline_width;					/**<													*/
	int		m_hole_clearance;					/**<													*/
	int		m_cam_layers;						/**<													*/
	int		m_cam_drill_file;					/**<													*/
	int		m_annular_ring_pins;				/**<													*/
	int		m_annular_ring_vias;				/**<													*/
	int		m_n_x;								/**< # of PCBs to panelize in Horizontal				*/
	int		m_n_y;								/**< # of PCBs to panelize in Vertical					*/
	int		m_space_x;							/**< Horizontal space to panelize, between board-edge.	*/
	int		m_space_y;							/**< Vertical space to panelize, between board-edge.	*/
};


