//
#pragma once

/*=============================================================================

=============================================================================*/

struct DesignRules
{
	BOOL bCheckUnrouted;					/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int trace_width; 						/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int pad_pad;							/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int pad_trace;							/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int trace_trace; 						/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int hole_copper; 						/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int annular_ring_pins;					/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int annular_ring_vias;					/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int board_edge_copper;					/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int board_edge_hole;					/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int hole_hole;							/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
	int copper_copper;						/**< ToDo:Describe short comment, about this member variable for Doxygen	*/
};

/*=============================================================================

=============================================================================*/

class DRError
{
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	DRError();
	~DRError();
	enum								// subtypes of errors 
	{
		 PAD_PAD = 0					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,PAD_PADHOLE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,PADHOLE_PADHOLE				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,SEG_PAD						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,SEG_PADHOLE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIA_PAD						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIA_PADHOLE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIAHOLE_PAD					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIAHOLE_PADHOLE				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,SEG_SEG						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,SEG_VIA						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,SEG_VIAHOLE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIA_VIA						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIA_VIAHOLE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,VIAHOLE_VIAHOLE				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,TRACE_WIDTH					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,RING_PAD						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,RING_VIA						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,BOARDEDGE_PAD					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,BOARDEDGE_PADHOLE				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,BOARDEDGE_VIA					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,BOARDEDGE_VIAHOLE				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,BOARDEDGE_TRACE				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,BOARDEDGE_COPPERAREA			/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,COPPERAREA_COPPERAREA			/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,COPPERAREA_INSIDE_COPPERAREA	/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,UNROUTED						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	};
//--------------------------------------
// f[^o(ϐ)
//--------------------------------------
	int			layer;					/**< layer (if pad error)						*/
	id			m_id;					/**< id, using subtypes above					*/
	CString		str;					/**< descriptive string							*/
	CString		name1, name2;			/**< names of nets or parts tested				*/
	id			id1, id2;				/**< ids of items tested						*/
	int			x, y;					/**< position of error							*/
	dl_element	* dl_el;				/**< DRC graphic								*/
	dl_element	* dl_sel;				/**< DRC graphic selector						*/
};

/*=============================================================================

=============================================================================*/

class DRErrorList
{
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	DRErrorList();
	~DRErrorList();
	void SetLists( CPartList * pl, CNetList * nl, CDisplayList * dl );
	void Clear();
	DRError * Add( long index, int st, CString * str, 
		CString * name1, CString * name2, id id1, id id2,
		int x1, int y1, int x2, int y2, int w, int layer );
	void Remove( DRError * dre );
	void HighLight( DRError * dre );
	void MakeSolidCircles();
	void MakeHollowCircles();
//--------------------------------------
// f[^o(ϐ)
//--------------------------------------
public:
	CPartList		*m_plist;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CNetList		*m_nlist;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CDisplayList	*m_dlist;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CPtrList		list;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DesignRules.h
-----------------------------------------------------------------------------*/
