// DlgAddArea.cpp : implementation file
//

#include	"stdafx.h"
#include	"FreePcb.h"
#include	"DlgAddArea.h"

// globals
int gHatch = CPolyLine::NO_HATCH;

// CDlgAddArea dialog

IMPLEMENT_DYNAMIC(CDlgAddArea, CDialog)

/*=============================================================================
						CDlgAddArea NX̍\z
=============================================================================*/

CDlgAddArea::CDlgAddArea(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAddArea::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAddArea)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgAddArea NX̏
=============================================================================*/

CDlgAddArea::~CDlgAddArea()
{
}

/*=============================================================================
		  CDlgAddArea _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgAddArea::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAddArea)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_COMBO_NET, m_wndNetComboBox);
	DDX_Control(pDX, IDC_LIST_LAYER, m_wndLayerListBox);
	DDX_Control(pDX, IDC_RADIO_NONE, m_wndNoneBtn);
	DDX_Control(pDX, IDC_RADIO_FULL, m_wndFillBtn);
	DDX_Control(pDX, IDC_RADIO_EDGE, m_wndEdgeBtn);

	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming, initialize net list
		cnet * net = m_nlist->GetFirstNet();
		while( net )
		{
			m_wndNetComboBox.AddString( net->name );
			net = m_nlist->GetNextNet();
		}
		if( m_net )
		{
			bNewArea = FALSE;
			int i = m_wndNetComboBox.SelectString( -1, m_net->name );
			if( i == CB_ERR )
				ASSERT(FALSE);
		}
		else
			bNewArea = TRUE;

		// initialize layers
		m_num_layers = m_num_layers-LAY_TOP_COPPER;
		for( int il=0; il<m_num_layers; il++ )
		{
			m_wndLayerListBox.InsertString( il,CFreePcbApp::GetBoardLayerName(il+LAY_TOP_COPPER));
		}
		m_wndLayerListBox.SetCurSel( m_layer - LAY_TOP_COPPER );
		if( m_hatch == -1 )
			m_hatch = gHatch;	
		if( m_hatch == CPolyLine::NO_HATCH )
			m_wndNoneBtn.SetCheck(BST_CHECKED);
		else if( m_hatch == CPolyLine::DIAGONAL_EDGE )
			m_wndEdgeBtn.SetCheck(BST_CHECKED);
		else if( m_hatch == CPolyLine::DIAGONAL_FULL )
			m_wndFillBtn.SetCheck(BST_CHECKED);
	}
	else
	{
		// outgoing
		m_layer = m_wndLayerListBox.GetCurSel() + LAY_TOP_COPPER;
		m_wndNetComboBox.GetWindowText( m_strNetName );

		POSITION pos;
		CString name;
		void * ptr;
		m_net = m_nlist->GetNetPtrByName( &m_strNetName );
		if( !m_net )
		{
			AfxMessageBox(_T("Illegal net name"));
			pDX->Fail();
		}
		if( m_wndNoneBtn.GetCheck()==BST_CHECKED )
			m_hatch = CPolyLine::NO_HATCH;
		else if( m_wndFillBtn.GetCheck()==BST_CHECKED )
			m_hatch = CPolyLine::DIAGONAL_FULL;
		else if( m_wndEdgeBtn.GetCheck()==BST_CHECKED )
			m_hatch = CPolyLine::DIAGONAL_EDGE;
		else 
			ASSERT(FALSE);
		if( bNewArea )
			gHatch = m_hatch;
	}
}

/*=============================================================================
					CDlgAddArea NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgAddArea, CDialog)
	//{{AFX_MSG_MAP(CDlgAddArea)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDlgAddArea message handlers

/*=============================================================================

=============================================================================*/

void CDlgAddArea::Initialize(CNetList * nl					/**< ToDo:Add Comment for Doxygen			*/
							,int nlayers					/**< ToDo:Add Comment for Doxygen			*/
							,cnet * net						/**< ToDo:Add Comment for Doxygen			*/
							,int layer						/**< ToDo:Add Comment for Doxygen			*/
							,int hatch						/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_nlist = nl;
	m_num_layers = nlayers;
	m_net = net;
	m_layer = layer;
	m_hatch = hatch;
}

/*-----------------------------------------------------------------------------
							end of DlgAddArea.cpp
-----------------------------------------------------------------------------*/
