// DlgAddPin.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgAddPin.h"

/*=============================================================================

=============================================================================*/

double GetNameValue( CString * name )
{
	double value = 0.0;
	for( int ic=0; ic<name->GetLength(); ic++ ) 
	{
		TCHAR	c = name->GetAt( ic );
		int v = 0;
		if( c >= _T('0') && c <= ('9'))
			v = c - _T('0');
		else if( c >= _T('a') && c <= _T('z'))
			v = c - _T('a') + 10;
		else if( c >= _T('A') && c <= _T('Z'))
			v = c - _T('A') + 10;
		else v = 39;
		value = value*40.0 + v;
	}
	return value;
}

/*=============================================================================

=============================================================================*/

void SortByName( CArray<CString> * names ) 
{
	// bubble sort
	int n = names->GetSize();
	for( int is=0; is<n-1; is++ )
	{
		// swap name[is] with lowest value following in array
		double vmin = GetNameValue( &(*names)[is] );
		int imin = is;
		for( int it=is+1; it<n; it++ )
		{
			double vtest = GetNameValue( &(*names)[it] );
			if( vtest < vmin )
			{
				imin = it;
				vmin = vtest;
			}
		}
		if( imin != is )
		{
			// swap name[is] with name[imin]
			CString temp = (*names)[is];
			(*names)[is] = (*names)[imin];
			(*names)[imin] = temp;
		}
	}
}

// CDlgAddPin dialog

IMPLEMENT_DYNAMIC(CDlgAddPin, CDialog)

/*=============================================================================
						CDlgAddPin NX̍\z
=============================================================================*/

CDlgAddPin::CDlgAddPin(CWnd* pParent /*=NULL*/)
: CDialog(CDlgAddPin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAddPin)
	//}}AFX_DATA_INIT

	// init params
	m_units = MIL;
	m_padstack_type = 0;
	m_hole_diam = 0;
	m_top_shape = 0;
	m_top_width = 0;
	m_top_length = 0;
	m_top_radius = 0;
	m_top_mask_shape = 0;
	m_top_mask_width = 0;
	m_top_mask_length = 0;
	m_top_mask_radius = 0;
	m_top_paste_shape = 0;
	m_top_paste_width = 0;
	m_top_paste_length = 0;
	m_top_paste_radius = 0;
	m_top_flags = 0;
	m_inner_shape = 0;
	m_inner_width = 0;
	m_inner_length = 0;
	m_inner_radius = 0;
	m_inner_flags = 0;
	m_bottom_shape = 0;
	m_bottom_width = 0;
	m_bottom_length = 0;
	m_bottom_radius = 0;
	m_bottom_mask_shape = 0;
	m_bottom_mask_width = 0;
	m_bottom_mask_length = 0;
	m_bottom_mask_radius = 0;
	m_bottom_paste_shape = 0;
	m_bottom_paste_width = 0;
	m_bottom_paste_length = 0;
	m_bottom_paste_radius = 0;
	m_bottom_flags = 0;
	m_x = 0;
	m_y = 0;
	m_x_edge = 1;
	m_y_edge = 1;
	m_row_spacing = 0;
}

/*=============================================================================
						CDlgAddPin NX̏
=============================================================================*/

CDlgAddPin::~CDlgAddPin()
{
}

/*=============================================================================
			CDlgAddPin _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgAddPin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAddPin)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO_ADD_PIN, m_wndRadioBtn_add_pin);
	DDX_Control(pDX, IDC_RADIO_ADD_ROW, m_wndRadioBtn_add_row);
	DDX_Control(pDX, IDC_COMBO_PIN_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_CHECK_SAME_AS, m_wndCheckBtn_same_as_pin);
	DDX_Control(pDX, IDC_RADIO_SMT, m_wndRadioBtn_smt);
	DDX_Control(pDX, IDC_RADIO_SMT_BOTTOM, m_wndRadioBtn_smt_bottom);
	DDX_Control(pDX, IDC_RADIO_TH, m_wndRadioBtn_th);
	DDX_Control(pDX, IDC_COMBO_SAME_AS_PIN, m_wndComboBox_same_as_pin);
	DDX_Control(pDX, IDC_EDIT_PIN_NAME, m_wndEditCtrl_pin_name);
	DDX_Control(pDX, IDC_EDIT_NUM_PINS, m_wndEditCtrl_num_pins);
	DDX_Control(pDX, IDC_EDIT_INCREMENT, m_wndEditCtrl_increment);
	DDX_Control(pDX, IDC_EDIT_HOLE_DIAM, m_wndEditCtrl_hole_diam);
	DDX_Control(pDX, IDC_RADIO_DRAG_PIN, m_wndRadioBtn_drag);
	DDX_Control(pDX, IDC_EDIT_PIN_X, m_wndEditCtrl_pin_x);
	DDX_Control(pDX, IDC_EDIT_PIN_Y, m_wndEditCtrl_pin_y);

	// Top layer pad

	DDX_Control(pDX, IDC_COMBO_TOP_PAD_SHAPE, m_wndComboBox_top_shape);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_W, m_wndEditCtrl_top_width);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_L, m_wndEditCtrl_top_length);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_RAD, m_wndEditCtrl_top_radius);
	DDX_Control(pDX, IDC_COMBO_TOP_PAD_SHAPE2, m_wndComboBox_top_shape2);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_W2, m_wndEditCtrl_top_width2);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_L2, m_wndEditCtrl_top_length2);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_RAD2, m_wndEditCtrl_top_radius2);
	DDX_Control(pDX, IDC_COMBO_TOP_PAD_SHAPE3, m_wndComboBox_top_shape3);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_W3, m_wndEditCtrl_top_width3);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_L3, m_wndEditCtrl_top_length3);
	DDX_Control(pDX, IDC_EDIT_TOP_PAD_RAD3, m_wndEditCtrl_top_radius3);

	// Inner layer pad

	DDX_Control(pDX, IDC_COMBO_INNER_PAD_SHAPE, m_wndComboBox_inner_shape);
	DDX_Control(pDX, IDC_EDIT_INNER_PAD_W, m_wndEditCtrl_inner_width);
	DDX_Control(pDX, IDC_EDIT_INNER_PAD_L, m_wndEditCtrl_inner_length);
	DDX_Control(pDX, IDC_EDIT_INNER_PAD_RAD, m_wndEditCtrl_inner_radius);

	// Bottom layer pad

	DDX_Control(pDX, IDC_CHECK_BOTTOM_SAME_AS, m_wndCheckBtn_bottom_same_as);
	DDX_Control(pDX, IDC_COMBO_BOTTOM_PAD_SHAPE, m_wndComboBox_bottom_shape);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_W, m_wndEditCtrl_bottom_width);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_L, m_wndEditCtrl_bottom_length);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_RAD, m_wndEditCtrl_bottom_radius);
	DDX_Control(pDX, IDC_COMBO_BOTTOM_PAD_SHAPE2, m_wndComboBox_bottom_shape2);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_W2, m_wndEditCtrl_bottom_width2);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_L2, m_wndEditCtrl_bottom_length2);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_RAD2, m_wndEditCtrl_bottom_radius2);
	DDX_Control(pDX, IDC_COMBO_BOTTOM_PAD_SHAPE3, m_wndComboBox_bottom_shape3);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_W3, m_wndEditCtrl_bottom_width3);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_L3, m_wndEditCtrl_bottom_length3);
	DDX_Control(pDX, IDC_EDIT_BOTTOM_PAD_RAD3, m_wndEditCtrl_bottom_radius3);

	DDX_Control(pDX, IDC_COMBO_ROW_ORIENT, m_wndComboBox_row_orient);
	DDX_Control(pDX, IDC_EDIT_ROW_SPACING, m_wndEditCtrl_row_spacing);
	DDX_Control(pDX, IDC_COMBO_PAD_ORIENT, m_wndComboBox_pad_orient);
	DDX_Control(pDX, IDC_RADIO_SET_PIN_POS, m_wndRadioBtn_set_pos);
	DDX_Control(pDX, IDC_LIST_PINS, m_wndListBoxPins);
	DDX_Control(pDX, IDC_RADIO_1_1, m_wndRadioBtn_connect[0][0] );
	DDX_Control(pDX, IDC_RADIO_1_2, m_wndRadioBtn_connect[0][1] );
	DDX_Control(pDX, IDC_RADIO_1_3, m_wndRadioBtn_connect[0][2] );
	DDX_Control(pDX, IDC_RADIO_1_4, m_wndRadioBtn_connect[0][3] );
	DDX_Control(pDX, IDC_RADIO_2_1, m_wndRadioBtn_connect[1][0] );
	DDX_Control(pDX, IDC_RADIO_2_2, m_wndRadioBtn_connect[1][1] );
	DDX_Control(pDX, IDC_RADIO_2_3, m_wndRadioBtn_connect[1][2] );
	DDX_Control(pDX, IDC_RADIO_2_4, m_wndRadioBtn_connect[1][3] );
	DDX_Control(pDX, IDC_RADIO_3_1, m_wndRadioBtn_connect[2][0] );
	DDX_Control(pDX, IDC_RADIO_3_2, m_wndRadioBtn_connect[2][1] );
	DDX_Control(pDX, IDC_RADIO_3_3, m_wndRadioBtn_connect[2][2] );
	DDX_Control(pDX, IDC_RADIO_3_4, m_wndRadioBtn_connect[2][3] );
	DDX_Control(pDX, IDC_COMBO_X_EDGE, m_wndComboBox_x_edge);
	DDX_Control(pDX, IDC_COMBO_Y_EDGE, m_wndComboBox_y_edge);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		CString str;
		for( int i=0; i<7; i++ ) 
		{
			CComboBox * cbox;
			BOOL bMask;
			switch(i) {
				case 0: cbox = &m_wndComboBox_top_shape; bMask = FALSE; break;
				case 1: cbox = &m_wndComboBox_top_shape2; bMask = TRUE; break;
				case 2: cbox = &m_wndComboBox_top_shape3; bMask = TRUE; break;
				case 3: cbox = &m_wndComboBox_inner_shape; bMask = FALSE; break;
				case 4: cbox = &m_wndComboBox_bottom_shape; bMask = FALSE; break;
				case 5: cbox = &m_wndComboBox_bottom_shape2; bMask = TRUE; break;
				case 6: cbox = &m_wndComboBox_bottom_shape3; bMask = TRUE; break;
			}
			if( bMask == FALSE )
			{
				cbox->InsertString( PAD_NONE,_T("none"));
				cbox->InsertString( PAD_ROUND,_T("round"));
				cbox->InsertString( PAD_SQUARE,_T("square"));
				cbox->InsertString( PAD_RECT,_T("rect"));
				cbox->InsertString( PAD_RRECT,_T("rounded-rect"));
				cbox->InsertString( PAD_OVAL,_T("oval"));
				cbox->InsertString( PAD_OCTAGON,_T("octagon"));
				cbox->SetCurSel( 0 );
			}
			else
			{
				cbox->InsertString( 0,_T("<default>"));
				cbox->InsertString( PAD_NONE+1,_T("none"));
				cbox->InsertString( PAD_ROUND+1,_T("round"));
				cbox->InsertString( PAD_SQUARE+1,_T("square"));
				cbox->InsertString( PAD_RECT+1,_T("rect"));
				cbox->InsertString( PAD_RRECT+1,_T("rounded-rect"));
				cbox->InsertString( PAD_OVAL+1,_T("oval"));
				cbox->InsertString( PAD_OCTAGON+1,_T("octagon"));
				cbox->SetCurSel( 0 );
			}
		}
		m_wndRadioBtn_add_pin.SetCheck(BST_CHECKED);
		OnBnClickedRadioAddPin();
		m_wndComboBox_units.AddString(_T("mil"));
		m_wndComboBox_units.AddString(_T("mm"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );

		m_wndComboBox_x_edge.AddString(_T("left"));
		m_wndComboBox_x_edge.AddString(_T("center"));
		m_wndComboBox_x_edge.AddString(_T("right"));
		m_wndComboBox_x_edge.SetCurSel(1);

		m_wndComboBox_y_edge.AddString(_T("top"));
		m_wndComboBox_y_edge.AddString(_T("middle"));
		m_wndComboBox_y_edge.AddString(_T("bottom"));
		m_wndComboBox_y_edge.SetCurSel(1);

		m_wndComboBox_row_orient.InsertString( 0,_T("horiz"));
		m_wndComboBox_row_orient.InsertString( 1,_T("vert"));
		m_wndComboBox_row_orient.SetCurSel( 0 );
		m_wndComboBox_pad_orient.InsertString( 0,_T("horiz"));
		m_wndComboBox_pad_orient.InsertString( 1,_T("vert"));
		m_wndComboBox_pad_orient.SetCurSel( 0 );
		if( m_fp->GetNumPins() )
		{
			CArray<CString> pin_name;
			pin_name.SetSize( m_fp->GetNumPins() );
			for( int i=0; i<m_fp->GetNumPins(); i++ )
			{
				pin_name[i] = m_fp->m_padstack[i].name;
			}
			::SortByName( &pin_name );
			int ipp = 0; 
			for( int i=0; i<m_fp->GetNumPins(); i++ )
			{
				m_wndComboBox_same_as_pin.InsertString( i, pin_name[i] );
				if( m_mode == ADD || pin_name[i] != m_fp->m_padstack[m_pin_num].name )
					m_wndListBoxPins.InsertString( ipp++, pin_name[i] );
			}
		} 
		if( m_mode == ADD && m_fp->GetNumPins() )
		{
			// add pin, pins already defined
			m_pin_num = m_fp->GetNumPins();
			str.Format(_T("%d"), m_fp->GetNumPins()+1 );
			m_wndEditCtrl_pin_name.SetWindowText( str );
			m_wndComboBox_same_as_pin.SetCurSel( 0 );
			m_wndCheckBtn_same_as_pin.SetCheck(1);
			OnChange();
			m_wndRadioBtn_drag.SetCheck(BST_CHECKED);
			OnBnClickedRadioDragPin();
		}
		else if( m_mode == ADD )
		{
			// add pin, no pins already defined
			m_pin_num = 0;
			m_wndEditCtrl_pin_name.SetWindowText(_T("1"));
			m_wndCheckBtn_same_as_pin.EnableWindow( FALSE );
			m_wndComboBox_same_as_pin.EnableWindow( FALSE );
			m_wndRadioBtn_smt.SetCheck(BST_CHECKED);
			OnChange();
			m_wndRadioBtn_drag.SetCheck(BST_CHECKED);
			OnBnClickedRadioDragPin();
		}
		else if( m_mode == EDIT )
		{
			// edit existing pin
			m_wndEditCtrl_pin_name.SetWindowText( m_fp->GetPinNameByIndex( m_pin_num ) );
			m_wndCheckBtn_same_as_pin.SetCheck(1);
			m_wndComboBox_same_as_pin.SetCurSel( m_pin_num );
			m_wndCheckBtn_same_as_pin.SetCheck(0);
			OnChange();
			m_wndRadioBtn_add_pin.SetCheck(BST_UNCHECKED);
			m_wndRadioBtn_add_pin.EnableWindow( FALSE );
			m_wndRadioBtn_add_row.EnableWindow( FALSE );
			m_wndEditCtrl_num_pins.EnableWindow( FALSE );
			m_wndEditCtrl_increment.EnableWindow( FALSE );
			m_wndRadioBtn_set_pos.SetCheck(BST_CHECKED);
			OnBnClickedRadioSetPinPos();
			GetFields();
			CString flag_str;
			padstack * ps = &m_fp->m_padstack[m_pin_num];
			m_x = ps->x_rel;
			m_y = ps->y_rel;
			m_hole_diam = ps->hole_size;
			if( m_hole_diam != 0 )
				m_padstack_type = 1;
			else
			{
				if( ps->top.shape != PAD_NONE )
					m_padstack_type = 0;
				else
					m_padstack_type = 2;
			}
			m_top_shape = ps->top.shape;
			m_top_width = ps->top.size_h;
			m_top_length = ps->top.size_l*2;
			m_top_radius = ps->top.radius;
			m_top_flags = ps->top.connect_flag;
			m_top_mask_shape = ps->top_mask.shape+1;
			if( m_top_mask_shape == 100 )
				m_top_mask_shape = 0;
			m_top_mask_width = ps->top_mask.size_h;
			m_top_mask_length = ps->top_mask.size_l*2;
			m_top_mask_radius = ps->top_mask.radius;
			m_top_paste_shape = ps->top_paste.shape+1;
			if( m_top_paste_shape == 100 )
				m_top_paste_shape = 0;
			m_top_paste_width = ps->top_paste.size_h;
			m_top_paste_length = ps->top_paste.size_l*2;
			m_top_paste_radius = ps->top_paste.radius;
			m_inner_shape = ps->inner.shape;
			m_inner_width = ps->inner.size_h;
			m_inner_length = ps->inner.size_l*2;
			m_inner_radius = ps->inner.radius;
			m_inner_flags = ps->inner.connect_flag;
			m_bottom_shape = ps->bottom.shape;
			m_bottom_width = ps->bottom.size_h;
			m_bottom_length = ps->bottom.size_l*2;
			m_bottom_radius = ps->bottom.radius;
			m_bottom_flags = ps->bottom.connect_flag;
			m_bottom_mask_shape = ps->bottom_mask.shape+1;
			if( m_bottom_mask_shape == 100 )
				m_bottom_mask_shape = 0;
			m_bottom_mask_width = ps->bottom_mask.size_h;
			m_bottom_mask_length = ps->bottom_mask.size_l*2;
			m_bottom_mask_radius = ps->bottom_mask.radius;
			m_bottom_paste_shape = ps->bottom_paste.shape+1;
			if( m_bottom_paste_shape == 100 )
				m_bottom_paste_shape = 0;
			m_bottom_paste_width = ps->bottom_paste.size_h;
			m_bottom_paste_length = ps->bottom_paste.size_l*2;
			m_bottom_paste_radius = ps->bottom_paste.radius;
			m_bottom_same_as_top = FALSE;
			if( m_hole_diam
				&& ps->top == ps->bottom
				&& ps->top_mask == ps->bottom_mask
				&& ps->top_paste == ps->bottom_paste
				)
			{
				m_bottom_same_as_top = TRUE;
			}
			if( ps->angle == 90 || ps->angle == 270 )
				m_pad_orient = 1;
			else
				m_pad_orient = 0;
		}
		SetFields();
	}
	else
	{
		// outgoing
		CString str; 
		CString astr;
		CString nstr;
		int n;
		BOOL conflict = FALSE;
		// update fields
		GetFields();
		// check for legal pin name
		if( !CheckLegalPinName( &m_pin_name, &astr, &nstr, &n ) )
		{
			str = "Pin name must consist of zero or more letters\n";
			str	+= "Followed by zero or more numbers\n";
			str	+= "The characters \" .,;:/!@#$%^&*(){}[]|<>?\\~\'\" are illegal\n";
			str	+= "For example: 1, 23, A12, SOURCE are legal\n";
			str	+= "while 1A, A2B3, A:3 are not\n";
			AfxMessageBox( str );
			pDX->Fail();
		}
		if( m_mode == ADD )
		{
			if( m_num_pins > 1 && m_row_spacing == 0 )
			{
				AfxMessageBox(_T("illegal row spacing"));
				pDX->Fail();
			}
			if( m_num_pins > 1 && nstr.IsEmpty() )
			{
				AfxMessageBox(_T("Pin name for a row of pins must end in a number"));
				pDX->Fail();
			}
		}
		if( m_padstack_type == 1 && m_hole_diam <= 0 )
		{
			AfxMessageBox(_T("For through-hole pin, hole diameter must be > 0"));
			pDX->Fail();
		}
		if(  (m_padstack_type == 0 || m_padstack_type == 1) && m_top_shape != PAD_NONE && m_top_width <= 0 )
		{
			AfxMessageBox(_T("Illegal top pad width"));
			pDX->Fail();
		}
		if( m_padstack_type == 1 && m_inner_shape != PAD_NONE && m_inner_width <= 0 )
		{
			AfxMessageBox(_T("Illegal inner pad width"));
			pDX->Fail();
		}
		if( (m_padstack_type == 2 || m_padstack_type == 1) && m_bottom_shape != PAD_NONE && m_bottom_width <= 0 )
		{
			AfxMessageBox(_T("Illegal bottom pad width"));
			pDX->Fail();
		}
		if( (m_padstack_type == 0 && m_top_shape == 0)
			|| (m_padstack_type == 2 && m_bottom_shape == 0) )
		{
			AfxMessageBox(_T("SMT pad shape can't be \"none\""));
			pDX->Fail();
		}
		// now check for conflicts
		if( nstr.IsEmpty() )
		{
			// pin name is pure alphabetic string
			// can't make row
			if( m_num_pins > 1 )
			{
				AfxMessageBox(_T("To create a row of pins, the pin name must end in a number"));
				pDX->Fail();
			}
			// check for conflicts
			int npins = m_fp->m_padstack.GetSize();
			for( int i=0; i<npins; i++ )
			{
				if( astr == m_fp->m_padstack[i].name )
				{
					if( (m_mode == EDIT && i != m_pin_num) || m_mode == ADD )
					{
						conflict = TRUE;
						break;
					}
				}
			}
			if( conflict )
			{
				str.Format(_T("Pin name \"%s\" is already in use"), m_pin_name );
				pDX->Fail();
			}
		}
		else
		{
			// pin name ends in a number, allow insertion
			int npins = m_fp->m_padstack.GetSize();
			for( int ip=0; ip<m_num_pins; ip++ )
			{
				CString pin_name;
				pin_name.Format(_T("%s%d"), astr, n+ip*m_increment );
				for( int i=0; i<npins; i++ )
				{
					if( pin_name == m_fp->m_padstack[i].name )
					{
						if( (m_mode == EDIT && i != (m_pin_num)) || m_mode == ADD )
						{
							conflict = TRUE;
							break;
						}
					}
				}
			}
			if( conflict )
			{
				if( m_num_pins == 1 )
					str.Format(_T("Pin name \"%s\" conflicts with an existing pin\nShift the existing pin name up?"), m_pin_name );
				else
					str.Format(_T("Pin names \"%s%d\" through \"%s%d\" conflict with existing pins\nShift existing pin names up?"), 
					astr, n, astr, n+(m_num_pins-1)*m_increment );
				int ret = AfxMessageBox( str, MB_OKCANCEL );
				if( ret != IDOK )
					pDX->Fail();
			}
		}
		// OK, we are ready to go
		m_fp->Undraw();
		// check if we will be dragging
		m_drag_flag = m_wndRadioBtn_drag.GetCheck();
		// now insert padstacks
		padstack ps;
		ps.hole_size = m_hole_diam;
		if( m_padstack_type == 0 || m_padstack_type == 2 )
			ps.hole_size = 0;
		ps.angle = 0;
		if( m_pad_orient == 1 )
			ps.angle = 90;
		if( m_padstack_type == 0 )
		{
			m_inner_shape = PAD_NONE;
			m_bottom_shape = PAD_NONE;
		}
		if( m_padstack_type == 2 )
		{
			m_top_shape = PAD_NONE;
			m_inner_shape = PAD_NONE;
		}
		ps.top.shape = m_top_shape;
		ps.top.size_h = m_top_width;
		ps.top.size_l = m_top_length/2; 
		ps.top.size_r = m_top_length/2;
		ps.top.radius = m_top_radius;
		ps.top.connect_flag = m_top_flags;
		if( m_top_mask_shape == 0 )
			ps.top_mask.shape = 99;
		else
			ps.top_mask.shape = m_top_mask_shape-1;
		ps.top_mask.size_h = m_top_mask_width;
		ps.top_mask.size_l = m_top_mask_length/2; 
		ps.top_mask.size_r = m_top_mask_length/2;
		ps.top_mask.radius = m_top_mask_radius;
		if( m_top_paste_shape == 0 )
			ps.top_paste.shape = 99;
		else
			ps.top_paste.shape = m_top_paste_shape-1;
		ps.top_paste.size_h = m_top_paste_width;
		ps.top_paste.size_l = m_top_paste_length/2; 
		ps.top_paste.size_r = m_top_paste_length/2;
		ps.top_paste.radius = m_top_paste_radius;
		ps.inner.shape = m_inner_shape;
		ps.inner.size_h = m_inner_width;
		ps.inner.size_l = m_inner_length/2; 
		ps.inner.size_r = m_inner_length/2;
		ps.inner.radius = m_inner_radius;
		ps.inner.connect_flag = m_inner_flags;
		ps.bottom.shape = m_bottom_shape;
		ps.bottom.size_h = m_bottom_width;
		ps.bottom.size_l = m_bottom_length/2; 
		ps.bottom.size_r = m_bottom_length/2;
		ps.bottom.radius = m_bottom_radius;
		ps.bottom.connect_flag = m_bottom_flags;
		if( m_bottom_mask_shape == 0 )
			ps.bottom_mask.shape = 99;
		else
			ps.bottom_mask.shape = m_bottom_mask_shape-1;
		ps.bottom_mask.size_h = m_bottom_mask_width;
		ps.bottom_mask.size_l = m_bottom_mask_length/2; 
		ps.bottom_mask.size_r = m_bottom_mask_length/2;
		ps.bottom_mask.radius = m_bottom_mask_radius;
		if( m_bottom_paste_shape == 0 )
			ps.bottom_paste.shape = 99;
		else
			ps.bottom_paste.shape = m_bottom_paste_shape-1;
		ps.bottom_paste.size_h = m_bottom_paste_width;
		ps.bottom_paste.size_l = m_bottom_paste_length/2; 
		ps.bottom_paste.size_r = m_bottom_paste_length/2;
		ps.bottom_paste.radius = m_bottom_paste_radius;
		
		int adj_x;
		switch(m_padstack_type)
		{
			case 0:	adj_x = m_top_length / 2;		break;	// SM_Top 
			case 1: adj_x = 0;						break;	// TH
			case 2: adj_x = m_bottom_length / 2;	break;	// SM_Bottom
		}

		int adj_y;
		switch(m_padstack_type)
		{
			case 0:	adj_y = m_top_width / 2;	break;	// SM_Top
			case 1: adj_y = 0;					break;	// TH
			case 2: adj_y = m_bottom_width / 2;	break;	// SM_Bottom
		}
		if( m_pad_orient )
		{
			int temp = adj_x;
			adj_x = adj_y;
			adj_y = temp;
		}

		switch(m_x_edge)
		{
			case 0: ps.x_rel = m_x + adj_x;	break;
			case 1:	ps.x_rel = m_x;			break;
			case 2: ps.x_rel = m_x - adj_x;	break;
		}

		switch(m_y_edge)
		{
			case 0: ps.y_rel = m_y - adj_y;	break;
			case 1:	ps.y_rel = m_y;			break;
			case 2: ps.y_rel = m_y + adj_y;	break;
		}

		// apply to other pins if requested
		if( m_wndListBoxPins.GetCount() )
		{
			// see if there are existing SMT pads on top and bottom layers
			BOOL bSMTtop = FALSE;
			BOOL bSMTbottom = FALSE;
			BOOL bPreserveLayer = FALSE;
			for( int ip=0; ip<m_wndListBoxPins.GetCount(); ip++ )
			{
				if( m_wndListBoxPins.GetSel( ip ) )
				{
					m_wndListBoxPins.GetText( ip, str );
					int i = m_fp->GetPinIndexByName( str );
					padstack * sel_ps = &m_fp->m_padstack[i];
					if( sel_ps->hole_size == 0 )
					{
						if( sel_ps->top.shape != PAD_NONE )
							bSMTtop = TRUE;
						if( sel_ps->bottom.shape != PAD_NONE )
							bSMTbottom = TRUE;
					}
				}
			}
			if( bSMTtop && bSMTbottom )
			{
				CString mess = _T("You are applying new pad parameters to SMT pads\n");
				mess += _T("on both top and bottom layers.\n\n");
				mess += _T("Click YES to preserve the layers of these pads,\n");
				mess += _T("or NO to set them all to the layer of the new pad");
				int ret = AfxMessageBox( mess, MB_YESNO );
				if( ret == IDYES )
					bPreserveLayer = TRUE;
			}
			for( int ip=0; ip<m_wndListBoxPins.GetCount(); ip++ )
			{
				if( m_wndListBoxPins.GetSel( ip ) )
				{
					m_wndListBoxPins.GetText( ip, str );
					int i = m_fp->GetPinIndexByName( str );
					if( i == -1 )
						ASSERT(FALSE);
					else
					{
						padstack * sel_ps = &m_fp->m_padstack[i];
						sel_ps->angle = ps.angle;
						sel_ps->hole_size = ps.hole_size;
						sel_ps->inner = ps.inner;
						if( ps.hole_size == 0 && sel_ps->hole_size == 0
							&& bPreserveLayer 
							&& (ps.top.shape == PAD_NONE && sel_ps->top.shape != PAD_NONE
							|| ps.bottom.shape == PAD_NONE && sel_ps->bottom.shape != PAD_NONE) )
						{
							// preserve pad layer by reversing assignment
							sel_ps->top = ps.bottom;
							sel_ps->top_mask = ps.bottom_mask;
							sel_ps->top_paste = ps.bottom_paste;
							sel_ps->bottom = ps.top;
							sel_ps->bottom_mask = ps.top_mask;
							sel_ps->bottom_paste = ps.top_paste;
						}
						else
						{
							// just copy pad layer
							sel_ps->top = ps.top;
							sel_ps->top_mask = ps.top_mask;
							sel_ps->top_paste = ps.top_paste;
							sel_ps->bottom = ps.bottom;
							sel_ps->bottom_mask = ps.bottom_mask;
							sel_ps->bottom_paste = ps.bottom_paste;
						}
					}
				}
			}
		}
		// add or replace selected pin
		if( m_mode == EDIT )
		{
			// remove pin
			m_fp->m_padstack.RemoveAt(m_pin_num);
		}
		// add pins to footprint
		int dx = 0;
		int dy = 0;
		if( m_row_orient == 0 )
			dx = m_row_spacing;
		else
			dy = m_row_spacing;
		if( m_num_pins > 1 )
		{
			for( int ip=0; ip<m_num_pins; ip++ )
			{
				ps.name.Format(_T("%s%d"), astr, n+ip*m_increment );
				m_fp->ShiftToInsertPadName( &astr, n+ip*m_increment );
				m_fp->m_padstack.InsertAt(  m_pin_num+ip, ps );
				ps.x_rel += dx;
				ps.y_rel += dy;
			}
		}
		else
		{
			ps.name.Format(_T("%s%s"), astr, nstr );
			m_fp->ShiftToInsertPadName( &astr, n );
			m_fp->m_padstack.InsertAt(  m_pin_num, ps );
		}
	}
}

/*=============================================================================
					CDlgAddPin NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgAddPin, CDialog)
	//{{AFX_MSG_MAP(CDlgAddPin)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_ADD_PIN, OnBnClickedRadioAddPin)
	ON_BN_CLICKED(IDC_RADIO_ADD_ROW, OnBnClickedRadioAddRow)
	ON_BN_CLICKED(IDC_CHECK_SAME_AS, OnChange)
	ON_BN_CLICKED(IDC_RADIO_SMT, OnChange)
	ON_BN_CLICKED(IDC_RADIO_SMT_BOTTOM, OnChange)
	ON_BN_CLICKED(IDC_RADIO_TH, OnChange)
	ON_BN_CLICKED(IDC_RADIO_DRAG_PIN, OnBnClickedRadioDragPin)
	ON_BN_CLICKED(IDC_RADIO_SET_PIN_POS, OnBnClickedRadioSetPinPos)
	ON_BN_CLICKED(IDC_CHECK_INNER_SAME_AS, OnChange)
	ON_BN_CLICKED(IDC_CHECK_BOTTOM_SAME_AS, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_PIN_UNITS, OnCbnSelchangeComboPinUnits)
	ON_CBN_SELCHANGE(IDC_COMBO_ROW_ORIENT, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_TOP_PAD_SHAPE, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_TOP_PAD_SHAPE2, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_TOP_PAD_SHAPE3, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_INNER_PAD_SHAPE, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_BOTTOM_PAD_SHAPE, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_BOTTOM_PAD_SHAPE2, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_BOTTOM_PAD_SHAPE3, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_SAME_AS_PIN, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_PAD_ORIENT, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_X_EDGE, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_Y_EDGE, OnChange)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_W, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_L, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_RAD, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_W2, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_L2, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_RAD2, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_W3, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_L3, OnChangeTopPadParam)
	ON_EN_CHANGE(IDC_EDIT_TOP_PAD_RAD3, OnChangeTopPadParam)

//	ON_CONTROL_RANGE(BN_CLICKED ,IDC_CHECK1 ,IDC_CHECKxx ,OnCheckBtnClicked)
//	ON_CONTROL_RANGE(BN_CLICKED ,IDC_RADIO1 ,IDC_RADIOxx ,OnRadioBtnClicked)
//	ON_CONTROL_RANGE(EN_CHANGE  ,IDC_EDIT1  ,IDC_EDITxx ,OnEditTextChanged)

	ON_NOTIFY_RANGE(UDN_DELTAPOS,IDC_SPIN1  ,IDC_SPIN27 ,OnDeltaPosSpin)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::InitDialog( CEditShape * fp, int mode, int pin_num, int units )
{
	m_units = units;
	m_mode = mode;
	if( m_mode == EDIT)
		m_pin_num = pin_num;
	if( fp )
		m_fp = fp;
	else
		ASSERT(FALSE);
	return;
}

// CDlgAddPin message handlers

/*=============================================================================
						CDlgAddPin _CAȌ
=============================================================================*/

BOOL	CDlgAddPin::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ

	CSpinButtonCtrl	*pSpinCtrl;

	for(UINT nCtrlID=IDC_SPIN1;nCtrlID<=IDC_SPIN27;nCtrlID++)
	{
		pSpinCtrl=(CSpinButtonCtrl *)GetDlgItem(nCtrlID);
		ASSERT(pSpinCtrl);
		if(pSpinCtrl)
		{
			pSpinCtrl->SetRange(-1,1);
			pSpinCtrl->SetPos(0);
		}
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnBnClickedRadioAddPin()
{
	CString str;
	m_wndRadioBtn_add_pin.SetCheck(BST_CHECKED);
	m_wndEditCtrl_num_pins.EnableWindow( FALSE );
	m_wndEditCtrl_increment.EnableWindow( FALSE );
	m_wndEditCtrl_num_pins.SetWindowText(_T("1"));
	m_wndEditCtrl_increment.SetWindowText(_T("1"));
	m_wndComboBox_row_orient.EnableWindow( FALSE );
	m_wndEditCtrl_row_spacing.EnableWindow( FALSE );
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnBnClickedRadioAddRow()
{
	CString str;
	m_wndEditCtrl_num_pins.EnableWindow( TRUE );
	m_wndEditCtrl_num_pins.SetWindowText(_T("1"));
	m_wndEditCtrl_increment.EnableWindow( TRUE );
	m_wndEditCtrl_increment.SetWindowText(_T("1"));
	m_wndComboBox_row_orient.EnableWindow( TRUE );
	m_wndEditCtrl_row_spacing.EnableWindow( TRUE );
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnBnClickedRadioDragPin()
{
	m_wndEditCtrl_pin_x.EnableWindow( FALSE );
	m_wndEditCtrl_pin_y.EnableWindow( FALSE );
	m_wndComboBox_x_edge.EnableWindow(FALSE);
	m_wndComboBox_y_edge.EnableWindow(FALSE);
	m_drag_flag = TRUE;
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnBnClickedRadioSetPinPos()
{
	m_wndEditCtrl_pin_x.EnableWindow( TRUE );
	m_wndEditCtrl_pin_y.EnableWindow( TRUE );
	m_wndComboBox_x_edge.EnableWindow(m_padstack_type != 1);
	m_wndComboBox_y_edge.EnableWindow(m_padstack_type != 1);
	m_drag_flag = FALSE;
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnBnClickedCheckInnerSameAs()
{
	GetFields(); 
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnBnClickedCheckBottomSameAs()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnCbnSelchangeComboPinUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

/*=============================================================================

=============================================================================*/

// Set fields in dialog
//

void	CDlgAddPin::SetFields()
{
	CString str;
	double denom;
	int max_dp;

	if( m_units == MIL )
		max_dp = 0;
	else
		max_dp =4;

	// "same as pin" stuff
	m_same_as_pin_flag = m_wndCheckBtn_same_as_pin.GetCheck(); 
	m_wndComboBox_same_as_pin.EnableWindow( m_same_as_pin_flag ); 

	// padstack
	m_wndEditCtrl_hole_diam.EnableWindow( !m_same_as_pin_flag && m_padstack_type == 1 );
	m_wndRadioBtn_smt.EnableWindow( !m_same_as_pin_flag );
	m_wndRadioBtn_smt_bottom.EnableWindow( !m_same_as_pin_flag );
	m_wndRadioBtn_th.EnableWindow( !m_same_as_pin_flag );
	m_wndComboBox_pad_orient.EnableWindow( !m_same_as_pin_flag );
	::MakeCStringFromDimension( &str, m_hole_diam, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_hole_diam.SetWindowText( str );
	m_wndRadioBtn_smt.SetCheck( m_padstack_type == 0 );
	m_wndRadioBtn_th.SetCheck( m_padstack_type == 1 );
	m_wndRadioBtn_smt_bottom.SetCheck( m_padstack_type == 2 );
	m_wndComboBox_pad_orient.SetCurSel( m_pad_orient );

	// top pad
	BOOL bTopEnable = !m_same_as_pin_flag && m_padstack_type != 2;
	m_wndComboBox_top_shape.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_width.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_length.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_radius.EnableWindow( bTopEnable );
	m_wndComboBox_top_shape2.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_width2.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_length2.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_radius2.EnableWindow( bTopEnable );
	m_wndComboBox_top_shape3.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_width3.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_length3.EnableWindow( bTopEnable );
	m_wndEditCtrl_top_radius3.EnableWindow( bTopEnable );
	m_wndComboBox_top_shape.SetCurSel( m_top_shape ); 
	m_wndComboBox_top_shape2.SetCurSel( m_top_mask_shape ); 
	m_wndComboBox_top_shape3.SetCurSel( m_top_paste_shape ); 
	::MakeCStringFromDimension( &str, m_top_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_width.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_top_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_length.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_top_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_radius.SetWindowText( str );
	m_wndComboBox_top_shape2.SetCurSel( m_top_mask_shape ); 
	::MakeCStringFromDimension( &str, m_top_mask_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_width2.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_top_mask_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_length2.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_top_mask_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_radius2.SetWindowText( str );
	m_wndComboBox_top_shape3.SetCurSel( m_top_paste_shape ); 
	::MakeCStringFromDimension( &str, m_top_paste_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_width3.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_top_paste_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_length3.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_top_paste_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_top_radius3.SetWindowText( str );
	if( bTopEnable )
	{
		m_wndEditCtrl_top_width.EnableWindow( m_top_shape > PAD_NONE ); 
		m_wndEditCtrl_top_length.EnableWindow( m_top_shape >= PAD_RECT && m_top_shape <= PAD_OVAL );
		m_wndEditCtrl_top_radius.EnableWindow( m_top_shape == PAD_RRECT );
		m_wndEditCtrl_top_width2.EnableWindow( m_top_mask_shape-1 > PAD_NONE ); 
		m_wndEditCtrl_top_length2.EnableWindow( m_top_mask_shape-1 >= PAD_RECT && m_top_mask_shape-1 <= PAD_OVAL );
		m_wndEditCtrl_top_radius2.EnableWindow( m_top_mask_shape-1 == PAD_RRECT );
		m_wndEditCtrl_top_width3.EnableWindow( m_top_paste_shape-1 > PAD_NONE ); 
		m_wndEditCtrl_top_length3.EnableWindow( m_top_paste_shape-1 >= PAD_RECT && m_top_paste_shape-1 <= PAD_OVAL );
		m_wndEditCtrl_top_radius3.EnableWindow( m_top_paste_shape-1 == PAD_RRECT );
	}
	for( int i=0; i<4; i++ )
	{
		m_wndRadioBtn_connect[0][i].SetCheck(BST_UNCHECKED);
		m_wndRadioBtn_connect[0][i].EnableWindow( bTopEnable );
	}
	m_wndRadioBtn_connect[0][m_top_flags].SetCheck(BST_CHECKED);


	// inner pad
	BOOL bInnerEnable = !m_same_as_pin_flag && m_padstack_type == 1;
	m_wndComboBox_inner_shape.EnableWindow( bInnerEnable );
	m_wndEditCtrl_inner_width.EnableWindow( bInnerEnable );
	m_wndEditCtrl_inner_length.EnableWindow( bInnerEnable );
	m_wndEditCtrl_inner_radius.EnableWindow( bInnerEnable );
	m_wndComboBox_inner_shape.SetCurSel( m_inner_shape ); 
	::MakeCStringFromDimension( &str, m_inner_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_inner_width.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_inner_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_inner_length.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_inner_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_inner_radius.SetWindowText( str );
	if( bInnerEnable )
	{
		m_wndEditCtrl_inner_width.EnableWindow( m_inner_shape > PAD_NONE ); 
		m_wndEditCtrl_inner_length.EnableWindow( m_inner_shape >= PAD_RECT && m_inner_shape <= PAD_OVAL );
		m_wndEditCtrl_inner_radius.EnableWindow( m_inner_shape == PAD_RRECT );
	}
	for( int i=0; i<4; i++ )
	{
		m_wndRadioBtn_connect[1][i].SetCheck(BST_UNCHECKED);
		m_wndRadioBtn_connect[1][i].EnableWindow( bInnerEnable );
	}
	m_wndRadioBtn_connect[1][m_inner_flags].SetCheck(BST_CHECKED);

	// bottom pad
	BOOL bBottomEnable = !m_same_as_pin_flag && m_padstack_type != 0; 
	m_wndCheckBtn_bottom_same_as.SetCheck( m_bottom_same_as_top ); 
	m_wndCheckBtn_bottom_same_as.EnableWindow( bBottomEnable && m_padstack_type != 2 );
	bBottomEnable &= !m_bottom_same_as_top;
	m_wndComboBox_bottom_shape.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_width.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_length.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_radius.EnableWindow( bBottomEnable );
	m_wndComboBox_bottom_shape2.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_width2.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_length2.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_radius2.EnableWindow( bBottomEnable );
	m_wndComboBox_bottom_shape3.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_width3.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_length3.EnableWindow( bBottomEnable );
	m_wndEditCtrl_bottom_radius3.EnableWindow( bBottomEnable );
	m_wndComboBox_bottom_shape.SetCurSel( m_bottom_shape ); 
	m_wndComboBox_bottom_shape2.SetCurSel( m_bottom_mask_shape ); 
	m_wndComboBox_bottom_shape3.SetCurSel( m_bottom_paste_shape ); 
	::MakeCStringFromDimension( &str, m_bottom_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_width.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_bottom_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_length.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_bottom_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_radius.SetWindowText( str );
	m_wndComboBox_bottom_shape2.SetCurSel( m_bottom_mask_shape ); 
	::MakeCStringFromDimension( &str, m_bottom_mask_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_width2.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_bottom_mask_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_length2.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_bottom_mask_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_radius2.SetWindowText( str );
	m_wndComboBox_bottom_shape3.SetCurSel( m_bottom_paste_shape ); 
	::MakeCStringFromDimension( &str, m_bottom_paste_width, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_width3.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_bottom_paste_length, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_length3.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_bottom_paste_radius, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_bottom_radius3.SetWindowText( str );
	if( bBottomEnable )
	{
		m_wndEditCtrl_bottom_width.EnableWindow( m_bottom_shape > PAD_NONE ); 
		m_wndEditCtrl_bottom_length.EnableWindow( m_bottom_shape >= PAD_RECT && m_bottom_shape <= PAD_OVAL );
		m_wndEditCtrl_bottom_radius.EnableWindow( m_bottom_shape == PAD_RRECT );
		m_wndEditCtrl_bottom_width2.EnableWindow( m_bottom_mask_shape-1 > PAD_NONE ); 
		m_wndEditCtrl_bottom_length2.EnableWindow( m_bottom_mask_shape-1 >= PAD_RECT && m_bottom_mask_shape-1 <= PAD_OVAL );
		m_wndEditCtrl_bottom_radius2.EnableWindow( m_bottom_mask_shape-1 == PAD_RRECT );
		m_wndEditCtrl_bottom_width3.EnableWindow( m_bottom_paste_shape-1 > PAD_NONE ); 
		m_wndEditCtrl_bottom_length3.EnableWindow( m_bottom_paste_shape-1 >= PAD_RECT && m_bottom_paste_shape-1 <= PAD_OVAL );
		m_wndEditCtrl_bottom_radius3.EnableWindow( m_bottom_paste_shape-1 == PAD_RRECT );
	}
	for( int i=0; i<4; i++ )
	{
		m_wndRadioBtn_connect[2][i].SetCheck(BST_UNCHECKED);
		m_wndRadioBtn_connect[2][i].EnableWindow( bBottomEnable );
	}
	m_wndRadioBtn_connect[2][m_bottom_flags].SetCheck(BST_CHECKED);

	// position info
	::MakeCStringFromDimension( &str, m_x, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_pin_x.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_y, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_pin_y.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_row_spacing, m_units, FALSE, FALSE, FALSE, max_dp );
	m_wndEditCtrl_row_spacing.SetWindowText( str );
	
//	Only SM pads have edge alignment:
	if(m_padstack_type != 1)
	{
		m_wndComboBox_x_edge.SetCurSel(m_x_edge);
		m_wndComboBox_y_edge.SetCurSel(m_y_edge);
	} else {
		m_wndComboBox_x_edge.SetCurSel(1);
		m_wndComboBox_y_edge.SetCurSel(1);
	}

	m_wndComboBox_x_edge.EnableWindow(!m_drag_flag && (m_padstack_type != 1));
	m_wndComboBox_y_edge.EnableWindow(!m_drag_flag && (m_padstack_type != 1));
}

/*=============================================================================

=============================================================================*/
// Get data from dialog
//
void	CDlgAddPin::GetFields()
{
	CString str;
	int val;
	double mult = NM_PER_MIL;
	if( m_units == MM )
		mult = 1000000.0;

	// get pin name
	m_wndEditCtrl_pin_name.GetWindowText( m_pin_name );
	// "same as pin" data
	m_same_as_pin_flag = m_wndCheckBtn_same_as_pin.GetCheck();
	if( m_same_as_pin_flag ) 
	{
		// set all parameters to be the same as another pin
		m_wndComboBox_same_as_pin.GetWindowText( m_same_as_pin_name );
		int ip = m_fp->GetPinIndexByName( m_same_as_pin_name );
		padstack * copy_ps = &m_fp->m_padstack[ip];
		m_pad_orient = 0;
		if( copy_ps->hole_size )
			m_padstack_type = 1;
		else if( copy_ps->top.shape != PAD_NONE )
			m_padstack_type = 0;
		else
			m_padstack_type = 2;
		if( copy_ps->angle == 90 || copy_ps->angle == 270 )
			m_pad_orient = 1;
		m_hole_diam = copy_ps->hole_size;
		m_top_shape = copy_ps->top.shape;
		m_top_width = copy_ps->top.size_h;
		m_top_length = copy_ps->top.size_l*2;
		m_top_radius = copy_ps->top.radius;
		m_top_mask_shape = copy_ps->top_mask.shape;
		m_top_mask_width = copy_ps->top_mask.size_h;
		m_top_mask_length = copy_ps->top_mask.size_l*2;
		m_top_mask_radius = copy_ps->top_mask.radius;
		m_top_paste_shape = copy_ps->top_paste.shape;
		m_top_paste_width = copy_ps->top_paste.size_h;
		m_top_paste_length = copy_ps->top_paste.size_l*2;
		m_top_paste_radius = copy_ps->top_paste.radius;
		m_top_flags = copy_ps->top.connect_flag;
		m_inner_shape = copy_ps->inner.shape;
		m_inner_width = copy_ps->inner.size_h;
		m_inner_length = copy_ps->inner.size_l*2;
		m_inner_radius = copy_ps->inner.radius;
		m_inner_flags = copy_ps->inner.connect_flag;
		m_bottom_shape = copy_ps->bottom.shape;
		m_bottom_width = copy_ps->bottom.size_h;
		m_bottom_length = copy_ps->bottom.size_l*2;
		m_bottom_radius = copy_ps->bottom.radius;
		m_bottom_mask_shape = copy_ps->bottom_mask.shape;
		m_bottom_mask_width = copy_ps->bottom_mask.size_h;
		m_bottom_mask_length = copy_ps->bottom_mask.size_l*2;
		m_bottom_mask_radius = copy_ps->bottom_mask.radius;
		m_bottom_paste_shape = copy_ps->bottom_paste.shape;
		m_bottom_paste_width = copy_ps->bottom_paste.size_h;
		m_bottom_paste_length = copy_ps->bottom_paste.size_l*2;
		m_bottom_paste_radius = copy_ps->bottom_paste.radius;
		m_bottom_flags = copy_ps->bottom.connect_flag;
	}
	else
	{
		m_wndEditCtrl_hole_diam.GetWindowText( str );
		m_hole_diam = mult*_tstof( str );
		if( m_wndRadioBtn_smt.GetCheck() )
			m_padstack_type = 0;
		else if( m_wndRadioBtn_th.GetCheck() )
			m_padstack_type = 1;
		else
			m_padstack_type = 2;

		// top pad
		m_top_shape = m_wndComboBox_top_shape.GetCurSel();
		m_wndEditCtrl_top_width.GetWindowText( str );
		m_top_width = mult*_tstof( str );
		m_wndEditCtrl_top_length.GetWindowText( str );
		m_top_length = mult*_tstof( str );
		m_wndEditCtrl_top_radius.GetWindowText( str );
		m_top_radius = mult*_tstof( str );
		m_top_mask_shape = m_wndComboBox_top_shape2.GetCurSel();
		m_wndEditCtrl_top_width2.GetWindowText( str );
		m_top_mask_width = mult*_tstof( str );
		m_wndEditCtrl_top_length2.GetWindowText( str );
		m_top_mask_length = mult*_tstof( str );
		m_wndEditCtrl_top_radius2.GetWindowText( str );
		m_top_mask_radius = mult*_tstof( str );
		m_top_paste_shape = m_wndComboBox_top_shape3.GetCurSel();
		m_wndEditCtrl_top_width3.GetWindowText( str );
		m_top_paste_width = mult*_tstof( str );
		m_wndEditCtrl_top_length3.GetWindowText( str );
		m_top_paste_length = mult*_tstof( str );
		m_wndEditCtrl_top_radius3.GetWindowText( str );
		m_top_paste_radius = mult*_tstof( str );
		for( int i=0; i<4; i++ )
			if( m_wndRadioBtn_connect[0][i].GetCheck() )
			{
				m_top_flags = i;
				break;
			}

		// inner pad
		m_inner_shape = m_wndComboBox_inner_shape.GetCurSel();
		m_wndEditCtrl_inner_width.GetWindowText( str );
		m_inner_width = mult*_tstof( str );
		m_wndEditCtrl_inner_length.GetWindowText( str );
		m_inner_length = mult*_tstof( str );
		m_wndEditCtrl_inner_radius.GetWindowText( str );
		m_inner_radius = mult*_tstof( str );
		for( int i=0; i<4; i++ )
			if( m_wndRadioBtn_connect[1][i].GetCheck() )
			{
				m_inner_flags = i;
				break;
			}

		// bottom pad
		m_bottom_same_as_top = m_wndCheckBtn_bottom_same_as.GetCheck() && m_padstack_type == 1;
		if( m_bottom_same_as_top )
		{
			m_bottom_shape = m_top_shape;
			m_bottom_width = m_top_width;
			m_bottom_length = m_top_length;
			m_bottom_radius = m_top_radius;
			m_bottom_mask_shape = m_top_mask_shape;
			m_bottom_mask_width = m_top_mask_width;
			m_bottom_mask_length = m_top_mask_length;
			m_bottom_mask_radius = m_top_mask_radius;
			m_bottom_paste_shape = m_top_paste_shape;
			m_bottom_paste_width = m_top_paste_width;
			m_bottom_paste_length = m_top_paste_length;
			m_bottom_paste_radius = m_top_paste_radius;
			m_bottom_flags = m_top_flags;
		}
		else
		{
			m_bottom_shape = m_wndComboBox_bottom_shape.GetCurSel();
			m_wndEditCtrl_bottom_width.GetWindowText( str );
			m_bottom_width = mult*_tstof( str );
			m_wndEditCtrl_bottom_length.GetWindowText( str );
			m_bottom_length = mult*_tstof( str );
			m_wndEditCtrl_bottom_radius.GetWindowText( str );
			m_bottom_radius = mult*_tstof( str );
			m_bottom_mask_shape = m_wndComboBox_bottom_shape2.GetCurSel();
			m_wndEditCtrl_bottom_width2.GetWindowText( str );
			m_bottom_mask_width = mult*_tstof( str );
			m_wndEditCtrl_bottom_length2.GetWindowText( str );
			m_bottom_mask_length = mult*_tstof( str );
			m_wndEditCtrl_bottom_radius2.GetWindowText( str );
			m_bottom_mask_radius = mult*_tstof( str );
			m_bottom_paste_shape = m_wndComboBox_bottom_shape3.GetCurSel();
			m_wndEditCtrl_bottom_width3.GetWindowText( str );
			m_bottom_paste_width = mult*_tstof( str );
			m_wndEditCtrl_bottom_length3.GetWindowText( str );
			m_bottom_paste_length = mult*_tstof( str );
			m_wndEditCtrl_bottom_radius3.GetWindowText( str );
			m_bottom_paste_radius = mult*_tstof( str );
			for( int i=0; i<4; i++ )
				if( m_wndRadioBtn_connect[2][i].GetCheck() )
				{
					m_bottom_flags = i;
					break;
				}
		}
	}

	// position and spacing
	m_wndEditCtrl_pin_x.GetWindowText( str );
	m_x = mult*_tstof( str );
	m_wndEditCtrl_pin_y.GetWindowText( str );
	m_y = mult*_tstof( str );
	m_wndEditCtrl_row_spacing.GetWindowText( str );
	m_row_spacing = mult*_tstof( str );

	m_x_edge = m_wndComboBox_x_edge.GetCurSel();
	m_y_edge = m_wndComboBox_y_edge.GetCurSel();

	// number of pins to add
	if( m_wndRadioBtn_add_pin.GetCheck() )
		m_num_pins = 1;
	else
	{
		m_wndEditCtrl_num_pins.GetWindowText( str );
		m_num_pins = _tstoi( str );
		m_wndEditCtrl_increment.GetWindowText( str );
		m_increment = _tstoi( str );
	}

	// pad and row orientation
	m_pad_orient = m_wndComboBox_pad_orient.GetCurSel();
	m_row_orient = m_wndComboBox_row_orient.GetCurSel();
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnChange()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPin::OnChangeTopPadParam()
{
	if( m_wndCheckBtn_bottom_same_as.GetCheck() )
	{
		CString str;
		m_wndEditCtrl_top_width.GetWindowText( str );
		m_wndEditCtrl_bottom_width.SetWindowText( str );
		m_wndEditCtrl_top_length.GetWindowText( str );
		m_wndEditCtrl_bottom_length.SetWindowText( str );
		m_wndEditCtrl_top_radius.GetWindowText( str );
		m_wndEditCtrl_bottom_radius.SetWindowText( str );
		m_wndEditCtrl_top_width2.GetWindowText( str );
		m_wndEditCtrl_bottom_width2.SetWindowText( str );
		m_wndEditCtrl_top_length2.GetWindowText( str );
		m_wndEditCtrl_bottom_length2.SetWindowText( str );
		m_wndEditCtrl_top_radius2.GetWindowText( str );
		m_wndEditCtrl_bottom_radius2.SetWindowText( str );
		m_wndEditCtrl_top_width3.GetWindowText( str );
		m_wndEditCtrl_bottom_width3.SetWindowText( str );
		m_wndEditCtrl_top_length3.GetWindowText( str );
		m_wndEditCtrl_bottom_length3.SetWindowText( str );
		m_wndEditCtrl_top_radius3.GetWindowText( str );
		m_wndEditCtrl_bottom_radius3.SetWindowText( str );
	}
}

/*=============================================================================

=============================================================================*/

void CDlgAddPin::OnCheckBtnClicked(UINT nCtrlID)
{
}

/*=============================================================================

=============================================================================*/

void CDlgAddPin::OnRadioBtnClicked(UINT nCtrlID)
{
}

/*=============================================================================

=============================================================================*/

void CDlgAddPin::OnEditTextChanged(UINT nCtrlID)
{
}

/*=============================================================================
					Xs{^NbNꂽꍇ̏
=============================================================================*/

void	CDlgAddPin::OnDeltaPosSpin(UINT nCtrlID,NMHDR* pNMHDR, LRESULT* pResult) 
{

	if(IDC_SPIN1<=nCtrlID && nCtrlID<=IDC_SPIN27)
	{
		NM_UPDOWN	*pNMUpDown=(NM_UPDOWN *)pNMHDR;
		UINT		nPos;

		nPos=nCtrlID-IDC_SPIN1;

	}
	else
	{
		TRACE(_T("\r\nERROR:(Unknown ControlID) - CDlgAddPin::OnDeltaPosSpin(nCtrlID=0x%08x)"),nCtrlID);
		ASSERT(FALSE);					/* Debugp({ɂ͗Ȃ͂)	*/
	}
	*pResult = 0;
}

/*-----------------------------------------------------------------------------
							end of DlgAddPin.cpp
-----------------------------------------------------------------------------*/
