// DlgAddPoly.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgAddPoly.h"
#include ".\dlgaddpoly.h"


// CDlgAddPoly dialog

IMPLEMENT_DYNAMIC(CDlgAddPoly, CDialog)

/*=============================================================================
						CDlgAddPoly NX̍\z
=============================================================================*/

CDlgAddPoly::CDlgAddPoly(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAddPoly::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAddPoly)
	//}}AFX_DATA_INIT

	m_width = 10*NM_PER_MIL;	// default
}

/*=============================================================================
						CDlgAddPoly NX̏
=============================================================================*/

CDlgAddPoly::~CDlgAddPoly()
{
}

/*=============================================================================
		  CDlgAddPoly _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgAddPoly::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAddPoly)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO_OPEN, m_wndRadioBtn_open);
	DDX_Control(pDX, IDC_RADIO_CLOSED, m_wndRadioBtn_closed);
	DDX_Control(pDX, IDC_COMBO_ADD_POLY_UNITS, m_wndComboBox_units);
	DDX_Control( pDX, IDC_EDIT_WIDTH, m_wndEditCtrl_width );

	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// entry
		m_wndRadioBtn_open.SetCheck( 1 );
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );
		SetFields();
	}
	else
	{
		// exit
		GetFields();
		m_closed_flag = m_wndRadioBtn_closed.GetCheck();
		if( m_width < 1*NM_PER_MIL || m_width > 999*NM_PER_MIL )
		{
			pDX->PrepareEditCtrl( IDC_EDIT_WIDTH );
			AfxMessageBox(_T("Width out of range (1 to 999 mils)"));
			pDX->Fail();
		}
	}
}

/*=============================================================================

=============================================================================*/

void CDlgAddPoly::Initialize( int units				/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_units = units;
}

/*=============================================================================
					CDlgAddPoly NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgAddPoly, CDialog)
	//{{AFX_MSG_MAP(CDlgAddPoly)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_ADD_POLY_UNITS, OnCbnSelchangeComboAddPolyUnits)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void CDlgAddPoly::GetFields()
{
	CString str;
	if( m_units == MIL )
	{
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * NM_PER_MIL;
	}
	else
	{
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * 1000000.0;
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPoly::SetFields()
{
	CString str;
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_width/NM_PER_MIL );
		m_wndEditCtrl_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_width/1000000.0 );
		m_wndEditCtrl_width.SetWindowText( str );
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgAddPoly::OnCbnSelchangeComboAddPolyUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

/*-----------------------------------------------------------------------------
							end of DlgAddPoly.cpp
-----------------------------------------------------------------------------*/

