// DlgAddText.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgAddText.h"

int gLastHeight = 100*NM_PER_MIL;
int gLastWidth = 10*NM_PER_MIL;

// CDlgAddText dialog

IMPLEMENT_DYNAMIC(CDlgAddText, CDialog)

/*=============================================================================
						CDlgAddText NX̍\z
=============================================================================*/

CDlgAddText::CDlgAddText(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAddText::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAddText)
	//}}AFX_DATA_INIT

	m_x = 0;
	m_y = 0;
	m_fp_flag = FALSE;
}

/*=============================================================================
						CDlgAddText NX̏
=============================================================================*/

CDlgAddText::~CDlgAddText()
{
}

/*=============================================================================
		  CDlgAddText _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgAddText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAddText)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_LIST_LAYER, m_layer_list);
	DDX_Control(pDX, IDC_EDIT_HEIGHT, m_wndEditCtrl_height);
	DDX_Control(pDX, IDC_SET_WIDTH, m_wndPushBtn_set_width);
	DDX_Control(pDX, IDC_DEF_WIDTH, m_wndPushBtn_def_width);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_wndEditCtrl_width);
	DDX_Control(pDX, IDC_EDIT_TEXT, m_text);
	DDX_Control(pDX, IDC_Y, m_wndEditCtrl_y);
	DDX_Control(pDX, IDC_X, m_wndEditCtrl_x);
	DDX_Text( pDX, IDC_EDIT_TEXT, m_str );
	DDX_Check( pDX, IDC_CHECK_MIRROR, m_mirror );
	DDX_Control(pDX, IDC_LIST_ANGLE, m_list_angle);
	DDX_Control(pDX, IDC_RADIO1, m_wndPushBtn_drag);
	DDX_Control(pDX, IDC_RADIO2, m_wndPushBtn_set_position );
	DDX_Control(pDX, IDC_COMBO_ADD_TEXT_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_CHECK_NEGATIVE, m_wndCheckBtn_negative);
	DDX_Check( pDX, IDC_CHECK_NEGATIVE, m_bNegative );
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		// leaving the dialog
		if( m_str.IsEmpty() )
		{
			AfxMessageBox(_T("Invalid text string"));
			pDX->Fail();
		}
		if( m_str.Find(_T('\"')) != -1 )
		{
			AfxMessageBox(_T("Text string can't contain \""));
			pDX->Fail();
		}
		GetFields();
		int ia = m_list_angle.GetCurSel();
		m_angle = ia*90;
		int ilay = m_layer_list.GetCurSel();
		if( ilay <= 0 )
			m_layer = LAY_SILK_TOP;
		else if( ilay == 1 )
			m_layer = LAY_SILK_BOTTOM;
		else if( ilay > 1 )
			m_layer = ilay - 2 + LAY_TOP_COPPER;
	}
}

/*=============================================================================
					CDlgAddText NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgAddText, CDialog)
	//{{AFX_MSG_MAP(CDlgAddText)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SET_WIDTH, OnBnClickedSetWidth)
	ON_BN_CLICKED(IDC_DEF_WIDTH, OnBnClickedDefWidth)
	ON_EN_CHANGE(IDC_EDIT_HEIGHT, OnEnChangeEditHeight)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedSetPosition)
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedDrag)
	ON_CBN_SELCHANGE(IDC_COMBO_ADD_TEXT_UNITS, OnCbnSelchangeComboAddTextUnits)
	ON_LBN_SELCHANGE(IDC_LIST_LAYER, OnLbnSelchangeListLayer)
END_MESSAGE_MAP()

// Initialize dialog
//

/*=============================================================================

=============================================================================*/

void CDlgAddText::Initialize(BOOL fp_flag				/**< ToDo:Add Comment for Doxygen			*/
							,int num_layers				/**< ToDo:Add Comment for Doxygen			*/
							,int drag_flag				/**< ToDo:Add Comment for Doxygen			*/
							,CString * str				/**< ToDo:Add Comment for Doxygen			*/
							,int units					/**< ToDo:Add Comment for Doxygen			*/
							,int layer					/**< ToDo:Add Comment for Doxygen			*/
							,BOOL bMirror				/**< ToDo:Add Comment for Doxygen			*/
							,BOOL bNegative				/**< ToDo:Add Comment for Doxygen			*/
							,int angle					/**< ToDo:Add Comment for Doxygen			*/
							,int height					/**< ToDo:Add Comment for Doxygen			*/
							,int width					/**< ToDo:Add Comment for Doxygen			*/
							,int x						/**< ToDo:Add Comment for Doxygen			*/
							,int y						/**< ToDo:Add Comment for Doxygen			*/ )

{
	m_fp_flag = fp_flag;
	m_num_layers = num_layers;
	m_drag_flag = drag_flag;
	if( str )
		m_str = *str;
	else
		m_str = "";
	m_units = units;
	m_layer = layer;
	m_mirror = bMirror;
	m_bNegative = bNegative;
	m_angle = angle;
	m_height = height;
	m_width = width;
	m_x = x;
	m_y = y;
}

// CDlgAddText message handlers

/*=============================================================================
					CDlgAddText _CAȌ
=============================================================================*/

BOOL	CDlgAddText::OnInitDialog()
{
	CDialog::OnInitDialog();

	// units
	m_wndComboBox_units.InsertString(	0,_T("MIL"));
	m_wndComboBox_units.InsertString(	1,_T("MM"));
	if(	m_units	== MIL )
	{
		m_wndComboBox_units.SetCurSel(0);
		m_unit_mult = NM_PER_MIL;
	}
	else
	{
		m_wndComboBox_units.SetCurSel(1);
		m_unit_mult = 1000000;
	}

	// height and width
	if( m_height == 0 )
	{
		m_height = gLastHeight;
		m_width = gLastWidth;
	}

	// layers
	if( m_fp_flag )
	{
		m_layer_list.InsertString( -1, CFreePcbApp::GetFootprintLayerName(LAY_FP_SILK_TOP));
		m_layer_list.SetCurSel( 0 );
	}
	else
	{
		m_layer_list.InsertString( -1, CFreePcbApp::GetBoardLayerName(LAY_SILK_TOP));
		m_layer_list.InsertString( -1, CFreePcbApp::GetBoardLayerName(LAY_SILK_BOTTOM));
		for( int i=LAY_TOP_COPPER; i<m_num_layers; i++ )
			m_layer_list.InsertString( -1, CFreePcbApp::GetBoardLayerName(i));
		if( m_layer == LAY_SILK_TOP )
			m_layer_list.SetCurSel( 0 );
		else if( m_layer == LAY_SILK_BOTTOM )
			m_layer_list.SetCurSel( 1 );
		else if( m_layer >= LAY_TOP_COPPER )
			m_layer_list.SetCurSel( m_layer -LAY_TOP_COPPER + 2 );
		else
			m_layer_list.SetCurSel( 0 );
	}

	// angles
	m_list_angle.InsertString( -1,_T("0"));
	m_list_angle.InsertString( -1,_T("90"));
	m_list_angle.InsertString( -1,_T("180"));
	m_list_angle.InsertString( -1,_T("270"));
	if( m_angle == 0 )
		m_list_angle.SetCurSel( 0 );
	else if( m_angle == 90 )
		m_list_angle.SetCurSel( 1 );
	else if( m_angle == 180 )
		m_list_angle.SetCurSel( 2 );
	else
		m_list_angle.SetCurSel( 3 );
	if( !m_drag_flag )
	{
		// editing, so set from variables
		m_wndPushBtn_set_position.SetCheck(BST_CHECKED);
		m_wndPushBtn_drag.SetCheck(BST_UNCHECKED);
		m_wndPushBtn_set_width.SetCheck(BST_CHECKED);
		m_wndPushBtn_def_width.SetCheck(BST_UNCHECKED);
		m_wndEditCtrl_x.EnableWindow( 1 );
		m_wndEditCtrl_y.EnableWindow( 1 );
		m_wndEditCtrl_width.EnableWindow( 1 );
	}
	else
	{
		// adding new text
		m_wndPushBtn_drag.SetCheck(BST_CHECKED);
		m_list_angle.SetCurSel( 0 );
		m_wndPushBtn_set_width.SetCheck(BST_UNCHECKED);
		m_wndPushBtn_def_width.SetCheck(BST_CHECKED);
		m_wndEditCtrl_x.EnableWindow( 0 );
		m_wndEditCtrl_y.EnableWindow( 0 );
		m_list_angle.EnableWindow( 0 );
		m_wndEditCtrl_width.EnableWindow( 0 );
	}
	SetFields();
	return TRUE;  // return TRUE unless you set the focus to a control
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnBnClickedSetWidth()
{
	m_wndPushBtn_set_width.SetCheck(BST_CHECKED);
	m_wndPushBtn_def_width.SetCheck(BST_UNCHECKED);
	m_wndEditCtrl_width.EnableWindow( 1 );
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnBnClickedDefWidth()
{
	OnEnChangeEditHeight();
	m_wndPushBtn_set_width.SetCheck(BST_UNCHECKED);
	m_wndPushBtn_def_width.SetCheck(BST_CHECKED);
	m_wndEditCtrl_width.EnableWindow( 0 );
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnEnChangeEditHeight()
{
	if( m_wndPushBtn_def_width.GetCheck() )
	{
		CString str;
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof(str)*m_unit_mult;
		m_width = m_height/10;
		m_width = max( m_width, 1*NM_PER_MIL );
		if( m_units == MIL )
		{
			MakeCStringFromDouble( &str, m_width/NM_PER_MIL );
			m_wndEditCtrl_width.SetWindowText( str );
		}
		else
		{
			MakeCStringFromDouble( &str, m_width/1000000.0 );
			m_wndEditCtrl_width.SetWindowText( str );
		}
	}
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnBnClickedOk()
{
	gLastHeight = m_height;
	gLastWidth = m_width;
	OnOK();
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnBnClickedSetPosition()
{
	m_wndEditCtrl_x.EnableWindow( 1 );
	m_wndEditCtrl_y.EnableWindow( 1 );
	m_list_angle.EnableWindow( 1 );
	m_drag_flag = 0;
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnBnClickedDrag()
{
	m_wndEditCtrl_x.EnableWindow( 0 );
	m_wndEditCtrl_y.EnableWindow( 0 );
	m_list_angle.EnableWindow( 0 );
	m_drag_flag = 1;
}

/*=============================================================================

=============================================================================*/

void CDlgAddText::OnCbnSelchangeComboAddTextUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
	{
		m_units = MIL;
		m_unit_mult = NM_PER_MIL;
	}
	else
	{
		m_units = MM;
		m_unit_mult = 1000000;
	}
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgAddText::GetFields()
{
	CString str;
	double mult;

	if( m_units == MIL )
		mult = NM_PER_MIL;
	else
		mult = 1000000.0;
	m_wndEditCtrl_height.GetWindowText( str );
	m_height = _tstof( str ) * mult;
	m_wndEditCtrl_width.GetWindowText( str );
	m_width = _tstof( str ) * mult;
	m_wndEditCtrl_x.GetWindowText( str );
	m_x = _tstof( str ) * mult;
	m_wndEditCtrl_y.GetWindowText( str );
	m_y = _tstof( str ) * mult;
}

/*=============================================================================

=============================================================================*/

void	CDlgAddText::SetFields()
{
	CString str;
	double mult;
	if( m_units == MIL )
		mult = NM_PER_MIL;
	else
		mult = 1000000.0;
	MakeCStringFromDouble( &str, m_height/mult );
	m_wndEditCtrl_height.SetWindowText( str );
	MakeCStringFromDouble( &str, m_width/mult );
	m_wndEditCtrl_width.SetWindowText( str );
	MakeCStringFromDouble( &str, m_x/mult );
	m_wndEditCtrl_x.SetWindowText( str );
	MakeCStringFromDouble( &str, m_y/mult );
	m_wndEditCtrl_y.SetWindowText( str );
	if( m_layer >= LAY_TOP_COPPER )
		m_wndCheckBtn_negative.EnableWindow( TRUE );
	else
	{
		m_wndCheckBtn_negative.SetCheck(BST_UNCHECKED);
		m_wndCheckBtn_negative.EnableWindow( FALSE );
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgAddText::OnLbnSelchangeListLayer()
{
		int ilay = m_layer_list.GetCurSel();
		if( ilay <= 0 )
			m_layer = LAY_SILK_TOP;
		else if( ilay == 1 )
			m_layer = LAY_SILK_BOTTOM;
		else if( ilay > 1 )
			m_layer = ilay - 2 + LAY_TOP_COPPER;
		SetFields();
}

/*-----------------------------------------------------------------------------
							end of DlgAddText.cpp
-----------------------------------------------------------------------------*/
