// DlgCAD.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgCAD.h"
#include "Gerber.h"
#include "DlgLog.h"
#include "DlgMyMessageBox2.h"
#include "PathDialog.h"
#include "RTcall.h"
#include ".\dlgcad.h"

// CDlgCAD dialog

IMPLEMENT_DYNAMIC(CDlgCAD, CDialog)

/*=============================================================================
						CDlgCAD NX̍\z
=============================================================================*/

CDlgCAD::CDlgCAD(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCAD::IDD, pParent)
	, m_n_x(0)
	, m_n_y(0)
{
	//{{AFX_DATA_INIT(CDlgCAD)
	//}}AFX_DATA_INIT

	m_folder = _T("");

	m_flgNoConfirmOverWrite=FALSE;
}

/*=============================================================================
						CDlgCAD NX̏
=============================================================================*/

CDlgCAD::~CDlgCAD()
{
}
 
/*=============================================================================
				CDlgCAD _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgCAD::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCAD)
	//}}AFX_DATA_MAP

	int			nLayerPos;
	CString		str;
	double		mult;

	DDX_Control(pDX, IDC_EDIT_FOLDER, m_wndEditCtrl_folder);
	DDX_Control(pDX, IDC_EDIT_FILL, m_wndEditCtrl_fill);
	DDX_Control(pDX, IDC_EDIT_MASK, m_wndEditCtrl_mask);
	DDX_Control(pDX, IDC_CHECK_DRILL, m_wndCheckBtn_drill);
	DDX_Control(pDX, IDC_CHECK_TOP_SILK, m_wndCheckBtn_top_silk);
	DDX_Control(pDX, IDC_CHECK_BOTTOM_SILK, m_wndCheckBtn_bottom_silk);
	DDX_Control(pDX, IDC_CHECK_TOP_SOLDER, m_wndCheckBtn_top_solder);
	DDX_Control(pDX, IDC_CHECKBOTTOM_SOLDER_MASK, m_wndCheckBtn_bottom_solder);
	DDX_Control(pDX, IDC_CHECK_TOP_COPPER, m_wndCheckBtn_top_copper);
	DDX_Control(pDX, IDC_CHECK_BOTTOM_COPPER, m_wndCheckBtn_bottom_copper);

	for(nLayerPos=0;nLayerPos<14;nLayerPos++)
		DDX_Control(pDX, IDC_CHECK_INNER1+nLayerPos, m_wndCheckBtn_InnerLayer[nLayerPos]);

	DDX_Control(pDX, IDC_BOARD_OUTLINE, m_wndCheckBtn_outline);
	DDX_Control(pDX, IDC_MOIRES, m_wndCheckBtn_moires);
	DDX_Control(pDX, IDC_LAYER_DESC, m_wndCheckBtn_layer_text);
	DDX_Control(pDX, IDC_COMBO_CAD_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT_CAD_PILOT_DIAM, m_wndEditCtrl_pilot_diam);
	DDX_Control(pDX, IDC_CHECK_CAD_PILOT, m_wndCheckBtn_pilot);
	DDX_Control(pDX, IDC_EDIT_CAD_MIN_SSW, m_wndEditCtrl_min_ss_w);
	DDX_Control(pDX, IDC_EDIT_CAD_THERMALWID, m_wndEditCtrl_thermal_width);
	DDX_Text( pDX, IDC_EDIT_FOLDER, m_folder );
	DDX_Control(pDX, IDC_EDIT_CAD_OUTLINE_WID, m_wndEditCtrl_outline_width);
	DDX_Control(pDX, IDC_EDIT_CAD_HOLE_CLEARANCE, m_wndEditCtrl_hole_clearance);
	DDX_Control(pDX, IDC_EDIT_CAD_ANN_PINS, m_wndEditCtrl_ann_pins);
	DDX_Control(pDX, IDC_EDIT_CAD_ANN_VIAS, m_wndEditCtrl_ann_vias);
	DDX_Control(pDX, IDC_CHECK1, m_wndCheckBtn_thermal_pins);
	DDX_Control(pDX, IDC_CHECK2, m_wndCheckBtn_thermal_vias);
	DDX_Control(pDX, IDC_CHECK3, m_wndCheckBtn_mask_vias);
	DDX_Control(pDX, IDC_CHECK_BD, m_wndCheckBtn_board);
	DDX_Control(pDX, IDC_CHECK_TOP_PASTE, m_wndCheckBtn_top_paste);
	DDX_Control(pDX, IDC_CHECK_BOTTOM_PASTE, m_wndCheckBtn_bottom_paste);
	DDX_Control(pDX, IDC_EDIT_SP_X, m_wndEditCtrl_space_x);
	DDX_Control(pDX, IDC_EDIT_SP_Y, m_wndEditCtrl_space_y);
	DDX_Control(pDX, IDC_EDIT_N_X, m_wndEditCtrl_n_x);
	DDX_Control(pDX, IDC_EDIT_N_Y, m_wndEditCtrl_n_y);
	DDX_Text(pDX, IDC_EDIT_N_X, m_n_x ); 
	DDX_Text(pDX, IDC_EDIT_N_Y, m_n_y );
	DDV_MinMaxUInt(pDX, m_n_x, 1, 99);
	DDV_MinMaxUInt(pDX, m_n_y, 1, 99); 
	DDX_Control(pDX, IDC_EDIT_CAD_SHRINK_PASTE, m_wndEditCtrl_shrink_paste);
	DDX_Control(pDX, IDC_CHECK_90, m_wndCheckBtn_90);
	DDX_Control(pDX, IDC_CHECK_ALL_GERBERS, m_wndCheckBtn_render_all);
	DDX_Control(pDX, IDC_CHECK_MIRROR_BOTTOM, m_wndCheckBtn_mirror_bottom);
	DDX_Control(pDX, IDC_CHECK_SMT_THERMALS, m_wndCheckBtn_smt_thermals);
	DDX_Control(pDX, IDC_CHECK4, m_wndCheckBtn_sm_clearance_for_cutouts);
	DDX_Check(pDX, IDC_CHECK5, m_flgNoConfirmOverWrite);


											/********************************/
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{										/********************************/
		if( m_units == MIL )
			mult = NM_PER_MIL;
		else
			mult = 1000000.0;
		m_wndEditCtrl_fill.GetWindowText( str );
		m_fill_clearance = _tstof( str ) * mult;
		m_wndEditCtrl_mask.GetWindowText( str );
		m_mask_clearance = _tstof( str ) * mult;
		m_wndEditCtrl_pilot_diam.GetWindowText( str );
		m_pilot_diameter = _tstof( str ) * mult;
		m_wndEditCtrl_min_ss_w.GetWindowText( str );
		m_min_silkscreen_width = _tstof( str ) * mult;
		m_wndEditCtrl_thermal_width.GetWindowText( str );
		m_thermal_width = _tstof( str ) * mult;
		m_wndEditCtrl_outline_width.GetWindowText( str );
		m_outline_width = _tstof( str ) * mult;
		m_wndEditCtrl_hole_clearance.GetWindowText( str );
		m_hole_clearance = _tstof( str ) * mult;
		m_wndEditCtrl_ann_pins.GetWindowText( str );
		m_annular_ring_pins = _tstof( str ) * mult;
		m_wndEditCtrl_ann_vias.GetWindowText( str );
		m_annular_ring_vias = _tstof( str ) * mult;
		m_wndEditCtrl_shrink_paste.GetWindowText( str );
		m_paste_shrink = _tstof( str ) * mult;
		m_wndEditCtrl_space_x.GetWindowText( str );
		m_space_x = _tstof( str ) * mult;
		m_wndEditCtrl_space_y.GetWindowText( str );
		m_space_y = _tstof( str ) * mult;
		m_wndEditCtrl_n_x.GetWindowText( str );
		m_n_x = _ttoi( str );
		if( m_n_x < 1 )
		{
			m_n_x = 1;
			m_wndEditCtrl_n_x.SetWindowText(_T("1"));
		}
		m_wndEditCtrl_n_y.GetWindowText( str );
		m_n_y = _ttoi( str );
		if( m_n_y < 1 )
		{
			m_n_y = 1;
			m_wndEditCtrl_n_y.SetWindowText(_T("1"));
		}
		// get flags for Gerbers
		m_flags = 0;
		if( m_wndCheckBtn_outline.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_BOARD_OUTLINE;
		if( m_wndCheckBtn_moires.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_AUTO_MOIRES;
		if( m_wndCheckBtn_layer_text.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_LAYER_TEXT;
		if( m_wndCheckBtn_pilot.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_PILOT_HOLES;
		if( !m_wndCheckBtn_thermal_pins.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_NO_PIN_THERMALS;
		if( !m_wndCheckBtn_thermal_vias.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_NO_VIA_THERMALS;
		if( !m_wndCheckBtn_mask_vias.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_MASK_VIAS;
		if( m_wndCheckBtn_90.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_90_THERMALS;
		if( m_wndCheckBtn_render_all.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_RENDER_ALL;
		if( m_wndCheckBtn_render_all.GetCheck()==BST_CHECKED&& m_wndCheckBtn_mirror_bottom.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_MIRROR_BOTTOM_PNG;
		if( !m_wndCheckBtn_smt_thermals.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_NO_SMT_THERMALS;
		if( !m_wndCheckBtn_sm_clearance_for_cutouts.GetCheck()==BST_CHECKED)
			m_flags |= GERBER_NO_CLEARANCE_SMCUTOUTS;
		if(IsDlgButtonChecked(IDC_CHECK6)==BST_CHECKED)
			m_flags |= GERBER_PLOT_INNER_NEGATIVE;
		// get layers
		m_layers = 0x0;
		for( int i=0; i<23; i++ )
		{
			if( i<(m_num_copper_layers+4) || i>19 )
			{
				switch(i)
				{
					case 0: if( m_wndCheckBtn_top_silk.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 1: if( m_wndCheckBtn_bottom_silk.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 2: if( m_wndCheckBtn_top_solder.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 3: if( m_wndCheckBtn_bottom_solder.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 4: if( m_wndCheckBtn_top_copper.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 5: if( m_wndCheckBtn_bottom_copper.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 6:											/* w(L1)		*/
					case 7:											/* w(L2)		*/
					case 8:											/* w(L3)		*/
					case 9:											/* w(L4)		*/
					case 10:										/* w(L5)		*/
					case 11:										/* w(L6)		*/
					case 12:										/* w(L7)		*/
					case 13:										/* w(L8)		*/
					case 14:										/* w(L9)		*/
					case 15:										/* w(L10)	*/
					case 16:										/* w(L11)	*/
					case 17:										/* w(L11)	*/
					case 18:										/* w(L12)	*/
					case 19:										/* w(L14)	*/
							{
								int		nLayerPos;

								nLayerPos=i-6;		/* 0:w(L1) ... 13:w(L14)	*/
								if(m_wndCheckBtn_InnerLayer[nLayerPos].GetCheck()==BST_CHECKED)
									m_layers |= 1<<i;
							}
							break;
					case 20: if( m_wndCheckBtn_board.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 21: if( m_wndCheckBtn_top_paste.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i;  
							break;
					case 22: if( m_wndCheckBtn_bottom_paste.GetCheck()==BST_CHECKED)
								m_layers |= 1<<i; 
							break;
					default:ASSERT(FALSE); 
							break;
				}
			}
		}
		if( m_wndCheckBtn_drill.GetCheck()==BST_CHECKED)
			m_drill_file = 1;
		else
			m_drill_file = 0;
	}										/********************************/
	else									/* ϐRg[	*/
	{										/********************************/
		// entry
		if(!m_wndComboBox_units.GetCount())		/* First time path only	*/
		{
			m_wndComboBox_units.InsertString( 0,_T("MIL"));
			m_wndComboBox_units.InsertString( 1,_T("MM"));
			if( m_units == MIL )
				m_wndComboBox_units.SetCurSel( 0 );
			else
				m_wndComboBox_units.SetCurSel( 1 );
		}

		// now load saved settings

		if( m_units == MIL )
			mult = NM_PER_MIL;
		else if( m_units == MM )
			mult = 1000000.0;
		else
		{
			ASSERT(FALSE);
			mult = 1.0;
		}
		MakeCStringFromDouble( &str, m_fill_clearance/mult );
		m_wndEditCtrl_fill.SetWindowText( str );
		MakeCStringFromDouble( &str, m_mask_clearance/mult );
		m_wndEditCtrl_mask.SetWindowText( str );
		MakeCStringFromDouble( &str, m_pilot_diameter/mult );
		m_wndEditCtrl_pilot_diam.SetWindowText( str );
		MakeCStringFromDouble( &str, m_min_silkscreen_width/mult );
		m_wndEditCtrl_min_ss_w.SetWindowText( str );
		MakeCStringFromDouble( &str, m_thermal_width/mult );
		m_wndEditCtrl_thermal_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_outline_width/mult );
		m_wndEditCtrl_outline_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_hole_clearance/mult );
		m_wndEditCtrl_hole_clearance.SetWindowText( str );
		MakeCStringFromDouble( &str, m_annular_ring_pins/mult );
		m_wndEditCtrl_ann_pins.SetWindowText( str );
		MakeCStringFromDouble( &str, m_annular_ring_vias/mult );
		m_wndEditCtrl_ann_vias.SetWindowText( str );
		MakeCStringFromDouble( &str, m_paste_shrink/mult );
		m_wndEditCtrl_shrink_paste.SetWindowText( str );
		MakeCStringFromDouble( &str, m_space_x/mult );
		m_wndEditCtrl_space_x.SetWindowText( str );
		MakeCStringFromDouble( &str, m_space_y/mult );
		m_wndEditCtrl_space_y.SetWindowText( str );

		// enable checkboxes for valid gerber layers
		if( m_num_copper_layers < 2 )
			m_wndCheckBtn_bottom_copper.EnableWindow(FALSE);

		for(nLayerPos=0;nLayerPos<14;nLayerPos++)
		{
			if((m_num_copper_layers-nLayerPos)<2)
				m_wndCheckBtn_InnerLayer[nLayerPos].EnableWindow(FALSE);
		}

		for( int i=0; i<23; i++ )
		{
			if( i<(m_num_copper_layers+4) || i>19 )
			{
				if(6<=i && i<=19)
				{
					int		nLayerPos;

					nLayerPos=i-6;
					m_wndCheckBtn_InnerLayer[i-nLayerPos].SetCheck(m_layers & (1<<i));
				}
				else
				{
					switch(i)
					{
						case 0: m_wndCheckBtn_top_silk.SetCheck(m_layers & (1<<i)); break;
						case 1: m_wndCheckBtn_bottom_silk.SetCheck(m_layers & (1<<i)); break;
						case 2: m_wndCheckBtn_top_solder.SetCheck(m_layers & (1<<i)); break;
						case 3: m_wndCheckBtn_bottom_solder.SetCheck(m_layers & (1<<i)); break;
						case 4: m_wndCheckBtn_top_copper.SetCheck(m_layers & (1<<i)); break;
						case 5: m_wndCheckBtn_bottom_copper.SetCheck(m_layers & (1<<i)); break;

						case 20: m_wndCheckBtn_board.SetCheck(m_layers & (1<<i)); break;
						case 21: m_wndCheckBtn_top_paste.SetCheck(m_layers & (1<<i)); break;
						case 22: m_wndCheckBtn_bottom_paste.SetCheck(m_layers & (1<<i)); break;
						default:ASSERT(FALSE);	 
								break;
					}
				}
			}
		}
		m_wndCheckBtn_drill.SetCheck( m_drill_file );
		m_wndCheckBtn_outline.SetCheck( m_flags & GERBER_BOARD_OUTLINE );
		m_wndCheckBtn_moires.SetCheck( m_flags & GERBER_AUTO_MOIRES );
		m_wndCheckBtn_layer_text.SetCheck( m_flags & GERBER_LAYER_TEXT );
		m_wndCheckBtn_thermal_pins.SetCheck( !(m_flags & GERBER_NO_PIN_THERMALS) );
		m_wndCheckBtn_thermal_vias.SetCheck( !(m_flags & GERBER_NO_VIA_THERMALS) );
		m_wndCheckBtn_mask_vias.SetCheck( !(m_flags & GERBER_MASK_VIAS) );
		m_wndCheckBtn_90.SetCheck( m_flags & GERBER_90_THERMALS );
		m_wndCheckBtn_pilot.SetCheck( m_flags & GERBER_PILOT_HOLES );
		m_wndCheckBtn_render_all.SetCheck( m_flags & GERBER_RENDER_ALL );
		m_wndCheckBtn_mirror_bottom.SetCheck( m_flags & GERBER_MIRROR_BOTTOM_PNG );
		m_wndCheckBtn_smt_thermals.EnableWindow( m_bSMT_connect );
		m_wndCheckBtn_smt_thermals.SetCheck( !(m_flags & GERBER_NO_SMT_THERMALS) );
		m_wndCheckBtn_sm_clearance_for_cutouts.SetCheck( !(m_flags & GERBER_NO_CLEARANCE_SMCUTOUTS) );

		CheckDlgButton(IDC_CHECK6,(m_flags & GERBER_PLOT_INNER_NEGATIVE) ? BST_CHECKED:BST_UNCHECKED);

		OnBnClickedThermalPins();
		OnBnClickedCheckCadPilot();
		OnBnClickedRenderAllGerbers();
	}

}

/*=============================================================================
					CDlgCAD NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgCAD, CDialog)
	//{{AFX_MSG_MAP(CDlgCAD)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_GO, OnBnClickedGo)
	ON_CBN_SELCHANGE(IDC_COMBO_CAD_UNITS, OnCbnSelchangeComboCadUnits)
	ON_BN_CLICKED(IDC_CHECK_CAD_PILOT, OnBnClickedCheckCadPilot)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_DEF, OnBnClickedButtonDef)
	ON_BN_CLICKED(IDC_BUTTON_FOLDER, OnBnClickedButtonFolder)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedThermalPins)
	ON_BN_CLICKED(IDC_CHECK2, OnBnClickedThermalVias)
	ON_BN_CLICKED(IDC_CHECK_ALL_GERBERS, OnBnClickedRenderAllGerbers)
	ON_BN_CLICKED(IDC_BUTTON_DONE, OnBnClickedButtonDone)
	ON_BN_CLICKED(IDC_FOLDER_OPEN, OnBnClickedFolderOpen)

//	ON_CONTROL_RANGE(BN_CLICKED ,IDC_CHECK1 ,IDC_CHECKxx ,OnCheckBtnClicked)
//	ON_CONTROL_RANGE(BN_CLICKED ,IDC_RADIO1 ,IDC_RADIOxx ,OnRadioBtnClicked)
//	ON_CONTROL_RANGE(EN_CHANGE  ,IDC_EDIT1  ,IDC_EDITxx ,OnEditTextChanged)

	ON_NOTIFY_RANGE(UDN_DELTAPOS,IDC_SPIN1  ,IDC_SPIN14 ,OnDeltaPosSpin)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgCAD::Initialize(double version, CString * folder		/**< ToDo:Add Comment for Doxygen			*/
						   ,CString * project_folder				/**< ToDo:Add Comment for Doxygen			*/
						   ,CString * app_folder					/**< ToDo:Add Comment for Doxygen			*/
						   ,int num_copper_layers					/**< ToDo:Add Comment for Doxygen			*/
						   ,int units								/**< ToDo:Add Comment for Doxygen			*/
						   ,BOOL bSMTconnect						/**< ToDo:Add Comment for Doxygen			*/
						   ,int fill_clearance						/**< ToDo:Add Comment for Doxygen			*/
						   ,int mask_clearance						/**< ToDo:Add Comment for Doxygen			*/
						   ,int thermal_width						/**< ToDo:Add Comment for Doxygen			*/
						   ,int pilot_diameter						/**< ToDo:Add Comment for Doxygen			*/
						   ,int min_silkscreen_wid					/**< ToDo:Add Comment for Doxygen			*/
						   ,int outline_width						/**< ToDo:Add Comment for Doxygen			*/
						   ,int hole_clearance						/**< ToDo:Add Comment for Doxygen			*/
						   ,int annular_ring_pins					/**< ToDo:Add Comment for Doxygen			*/
						   ,int annular_ring_vias					/**< ToDo:Add Comment for Doxygen			*/
						   ,int shrink_paste						/**< ToDo:Add Comment for Doxygen			*/
						   ,int n_x									/**< ToDo:Add Comment for Doxygen			*/
						   ,int n_y									/**< ToDo:Add Comment for Doxygen			*/
						   ,int space_x								/**< ToDo:Add Comment for Doxygen			*/
						   ,int space_y								/**< ToDo:Add Comment for Doxygen			*/
						   ,int flags								/**< ToDo:Add Comment for Doxygen			*/
						   ,int layers								/**< ToDo:Add Comment for Doxygen			*/
						   ,int drill_file							/**< ToDo:Add Comment for Doxygen			*/
						   ,CArray<CPolyLine> * bd					/**< ToDo:Add Comment for Doxygen			*/
						   ,CArray<CPolyLine> * sm					/**< ToDo:Add Comment for Doxygen			*/
						   ,BOOL * bShowMessageForClearance			/**< ToDo:Add Comment for Doxygen			*/
						   ,CPartList * pl							/**< ToDo:Add Comment for Doxygen			*/
						   ,CNetList * nl							/**< ToDo:Add Comment for Doxygen			*/
						   ,CTextList * tl							/**< ToDo:Add Comment for Doxygen			*/
						   ,CDisplayList * dl						/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_bShowMessageForClearance = *bShowMessageForClearance;
	m_bSMT_connect = bSMTconnect;
	m_version = version;
	m_folder = *folder;
	m_project_folder = *project_folder;
	m_app_folder = *app_folder;
	m_units = units;
	m_fill_clearance = fill_clearance;
	m_mask_clearance = mask_clearance;
	m_thermal_width = thermal_width;
	m_pilot_diameter = pilot_diameter;
	m_min_silkscreen_width = min_silkscreen_wid;
	m_num_copper_layers = num_copper_layers;
	m_flags = flags;
	m_layers = layers;
	m_drill_file = drill_file;
	m_bd = bd;
	m_sm = sm;
	m_pl = pl;
	m_nl = nl;
	m_tl = tl;
	m_dl = dl;
	m_hole_clearance = hole_clearance;
	m_outline_width = outline_width;
	m_annular_ring_pins = annular_ring_pins;
	m_annular_ring_vias = annular_ring_vias;
	m_paste_shrink = shrink_paste;
	m_n_x = n_x; 
	m_n_y = n_y;
	m_space_x = space_x;
	m_space_y = space_y;
}

// CDlgCAD message handlers

/*=============================================================================
						CDlgCAD _CAȌ
=============================================================================*/

BOOL	CDlgCAD::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ

	CSpinButtonCtrl	*pSpinCtrl;

	for(UINT nCtrlID=IDC_SPIN1;nCtrlID<=IDC_SPIN14;nCtrlID++)
	{
		pSpinCtrl=(CSpinButtonCtrl *)GetDlgItem(nCtrlID);
		ASSERT(pSpinCtrl);
		if(pSpinCtrl)
		{
			pSpinCtrl->SetRange(-1,1);
			pSpinCtrl->SetPos(0);
		}
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedGo()
{
	if(UpdateData(TRUE))	/* Get values from control to member variables	*/
	{
		// get CAM folder and create it if necessary

		struct			_stat buf;
		CString			strOutputFilePath;
		CStdioFile		objOutputFile;
		CFileStatus		fs;
		CString			strLogMsg;
		int				nMsgBoxRtn;
		CArray<CString> commands;
		CDlgLog			*pLogDialog;
		
		pLogDialog=((CMainFrame *)AfxGetMainWnd())->GetLogDialog();
		ASSERT(pLogDialog);

//		m_wndEditCtrl_folder.GetWindowText( m_folder );
		if(m_folder.IsEmpty())
		{
			m_folder = m_project_folder + _T("\\CAM");
			m_wndEditCtrl_folder.SetWindowText(m_folder);
		}
		int err = _tstat( m_folder, &buf );
		if( err )
		{
			CString		str;

			str.Format(_T("Folder \"%s\" doesn't exist, create it ?"), m_folder );
			int ret = AfxMessageBox( str, MB_YESNO );
			if( ret == IDYES )
			{
				err = _tmkdir( m_folder );
				if( err )
				{
					str.Format(_T("Unable to create folder \"%s\""), m_folder );
					AfxMessageBox( str, MB_OK );
					return;
				}
			}
			else
				return;
		}

		// warn about copper-copper clearance
		if( m_fill_clearance == 0 && m_bShowMessageForClearance )     
		{
			CDlgMyMessageBox2 dlg;
			CString mess = _T("WARNING: You have set the copper to copper-fill clearance to 0.");
			mess += _T("\nThis will disable automatic generation of clearances for pads and vias in copper areas.");
			mess += _T("\nAre you SURE that you don't need these clearances ?");
			dlg.Initialize( &mess );
			int ret = dlg.DoModal();
			if( ret == IDCANCEL )
				return;
			else
				m_bShowMessageForClearance = !dlg.bDontShowBoxState;
		}

		if( m_hole_clearance < m_fill_clearance )
		{
			m_hole_clearance = m_fill_clearance;
			UpdateData(FALSE);			/* Refrect member variables to dialog controls	*/
		}

		// show log
//		pLogDialog->ShowWindow( SW_SHOW );
//		pLogDialog->UpdateWindow();
		pLogDialog->BringWindowToTop();
		pLogDialog->Clear();
		pLogDialog->UpdateWindow();

		BOOL bError=FALSE;							// Set TRUE, if errors occur
		BOOL bAbort=FALSE;							// Set TRUE, if aborted by user operation

		// create drill file, if requested
		if(m_drill_file)
		{
			strOutputFilePath=m_folder +_T("\\drill_file.drl");

			for(;;)
			{
				if((CFile::GetStatus(strOutputFilePath,fs))			/* Destination file already exist			*/
				&& (!IsNoConfirmOverWrite()))						/* Not allowed to overwriting no confirm	*/
				{
					// Now, confirm overwriting to process output

					nMsgBoxRtn=AfxMessageBox(_T("Output : < ")+strOutputFilePath+_T(" >\r\nFile alreay exist. Overwrite it?")
											,MB_ICONQUESTION|MB_YESNOCANCEL|MB_DEFBUTTON2);
					if(nMsgBoxRtn==IDNO)
					{
						pLogDialog->AddLine(_T("++++++ File: <")+strOutputFilePath+_T("> Output skipped! ++++++\r\n"));
						break;
					}
					else if(nMsgBoxRtn==IDCANCEL)
					{
						bAbort=TRUE;
						break;
					}
				}
				int ok = objOutputFile.Open(strOutputFilePath, CFile::modeCreate | CFile::modeWrite ); 
				if( !ok )
				{
					strLogMsg.Format(_T("ERROR: Unable to open file \"%s\"\r\n"),strOutputFilePath);
					pLogDialog->AddLine(strLogMsg);
					bError = TRUE;
				}
				else
				{
					strLogMsg.Format(_T("Writing file: \"%s\"\r\n"),strOutputFilePath);
					pLogDialog->AddLine(strLogMsg);

					::WriteDrillFile( &objOutputFile, m_pl, m_nl, m_bd, m_n_x, m_n_y, m_space_x, m_space_y );
					objOutputFile.Close();
				}
				break;
//				m_drill_file=1;										// ???? (Not necessary?)
			}
		}
		if(!bAbort)
		{
			// create Gerber files for selected layers

			for( int i=0;!bAbort && i<23; i++ )
			{
				CString strGerberFileName = _T("");
				int layer = 0;

				if( i<(m_num_copper_layers+4) || i>19 )
				{
					switch(i)
					{
						case 0: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("top_silk.grb"); layer=LAY_SILK_TOP; } 
								break;
						case 1: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("bottom_silk.grb"); layer=LAY_SILK_BOTTOM; } 
								break;
						case 2: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("top_solder_mask.grb"); layer=LAY_MASK_TOP; } 
								break;
						case 3: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("bottom_solder_mask.grb"); layer=LAY_MASK_BOTTOM; } 
								break;
						case 4: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("top_copper.grb"); layer=LAY_TOP_COPPER; } 
								break;
						case 5: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("bottom_copper.grb"); layer=LAY_BOTTOM_COPPER; } 
								break;
						case 6:											/* w(L1)		*/
						case 7:											/* w(L2)		*/
						case 8:											/* w(L3)		*/
						case 9:											/* w(L4)		*/
						case 10:										/* w(L5)		*/
						case 11:										/* w(L6)		*/
						case 12:										/* w(L7)		*/
						case 13:										/* w(L8)		*/
						case 14:										/* w(L9)		*/
						case 15:										/* w(L10)	*/
						case 16:										/* w(L11)	*/
						case 17:										/* w(L11)	*/
						case 18:										/* w(L12)	*/
						case 19:										/* w(L14)	*/
								if(m_layers & (1<<i))
								{
									int		nLayerPos;

									nLayerPos=i-6;		/* 0:w(L1) ... 13:w(L14)	*/
									strGerberFileName.Format(_T("inner_copper_%d.grb"),nLayerPos+1);
									layer=LAY_BOTTOM_COPPER+nLayerPos+1;
								}
								break;
						case 20: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("board_outline.grb"); layer=LAY_BOARD_OUTLINE; } 
								break;
						case 21: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("top_paste_mask.grb"); layer=LAY_PASTE_TOP; } 
								break;
						case 22: if( m_layers & (1<<i) )
								{ strGerberFileName=_T("bottom_paste_mask.grb"); layer=LAY_PASTE_BOTTOM; } 
								break;
						default: ASSERT(FALSE); 
							break;
					}
				}
				if(layer)
				{
					// write the gerber file

					strOutputFilePath = m_folder + _T("\\") + strGerberFileName;

					if((CFile::GetStatus(strOutputFilePath,fs))			/* Destination file already exist			*/
					&& (!IsNoConfirmOverWrite()))						/* Not allowed to overwriting no confirm	*/
					{
						// Now, confirm overwriting to process output

						nMsgBoxRtn=AfxMessageBox(_T("Output : < ")+strOutputFilePath+_T(" >\r\nFile alreay exist. Overwrite it?")
												,MB_ICONQUESTION|MB_YESNOCANCEL|MB_DEFBUTTON2);
						if(nMsgBoxRtn==IDNO)
						{
							pLogDialog->AddLine(_T("++++++ File: <")+strOutputFilePath+_T("> Output skipped! ++++++\r\n"));
							continue;
						}
						else if(nMsgBoxRtn==IDCANCEL)
						{
							bAbort=TRUE;
							continue;
						}
					}
					m_pl->SetPinAnnularRing( m_annular_ring_pins );
					m_nl->SetViaAnnularRing( m_annular_ring_vias );
					int ok = objOutputFile.Open( strOutputFilePath, CFile::modeCreate | CFile::modeWrite );
					if( !ok )
					{
						strLogMsg.Format(_T("ERROR: Unable to open file \"%s\"\r\n"),strOutputFilePath);
						pLogDialog->AddLine(strLogMsg);
						bError = TRUE;
					}
					else
					{
						strLogMsg.Format(_T("Writing file: \"%s\"\r\n"),strOutputFilePath);
						pLogDialog->AddLine(strLogMsg);
						CString line;
						line.Format(_T("G04 FreePCB version %5.3f*\n"), m_version );
						objOutputFile.WriteString( line );
						line.Format(_T("G04 %s*\n"), strOutputFilePath );
						objOutputFile.WriteString( line );
						::WriteGerberFile(&objOutputFile						/* K[ot@C̏o̓nh					*/
										 ,m_flags								/* K[oo̓IvV(tO)					*/
										 ,layer									/* K[oo̓CIDԍ						*/
										 ,pLogDialog							/* o߃Oo͂_CAÕ|C^		*/
										 ,m_paste_shrink						/* ToDo:										*/
										 ,m_fill_clearance						/* ToDo:										*/
										 ,m_mask_clearance						/* ToDo:										*/
										 ,m_pilot_diameter						/* KCh̒a							*/
										 ,m_min_silkscreen_width				/* VN̍ŏ							*/
										 ,m_thermal_width						/* T[}h̐							*/
										 ,m_outline_width						/* O`̕								*/
										 ,m_hole_clearance						/* ToDo:										*/
										 ,m_n_x									/* (X)̊ʕt(>1)				*/
										 ,m_n_y									/* c(Y)̊ʕt(>1)				*/
										 ,m_space_x								/* (X)̊ʕtԊu					*/
										 ,m_space_y								/* c(Y)̊ʕtԊu					*/
										 ,m_bd									/* O`̃vbg						*/
										 ,m_sm									/* ToDo:										*/
										 ,m_pl									/* ĩXg									*/
										 ,m_nl									/* lbgXg									*/
										 ,m_tl									/* eLXg`IuWFNg̃Xg				*/
										 ,m_dl									/* ToDo:										*/ );
						objOutputFile.WriteString(_T("M02*\n"));				// end of job
						objOutputFile.Close();
					}
					if( m_flags & GERBER_RENDER_ALL )
					{
						// create command-line to render layer
						int nlines = commands.GetSize();
						commands.SetSize( nlines + 1 );
						CString mirror_str = _T("");
						if((layer == LAY_SILK_BOTTOM)
						|| (layer == LAY_SM_BOTTOM)
						|| (layer == LAY_BOTTOM_COPPER)
						|| (layer == LAY_MASK_BOTTOM)
						|| (layer == LAY_PASTE_BOTTOM))
						{
							if(m_flags & GERBER_MIRROR_BOTTOM_PNG)
								mirror_str = _T("--mirror ");
						}
						CString command_str = m_app_folder + _T("\\GerberRender.exe -r 600 ") + mirror_str
							+ strGerberFileName + _T(" ") + strGerberFileName.Left( strGerberFileName.GetLength()-4 )+_T(".png");
						commands[nlines] = command_str;
					}
				}
			}
		}
		if(bAbort)
			pLogDialog->AddLine(_T("++++++++++ PROCESS ABORTED BY USER ACTION !!! ++++++++++\r\n"));
		else if(bError)
			pLogDialog->AddLine(_T("***** ERRORS OCCURRED DURING CREATION OF GERBER(s) *****\r\n"));
		else
			pLogDialog->AddLine(_T("******** ALL GERBER FILE(s) CREATED SUCCESSFULLY *******\r\n"));

		if( commands.GetSize() != 0 )
		{
			_tchdir(m_folder);				// change current working directory to CAM folder
			pLogDialog->AddLine(_T("********** RENDERING .PNG FILE(s) FOR LAYER(s) *********\r\n"));
			for( int i=0; i<commands.GetSize(); i++ )
			{
				pLogDialog->AddLine(_T("Run: ")+commands[i]+ _T("\r\n")); 
				::RunConsoleProcess(commands[i],pLogDialog);
				pLogDialog->AddLine(_T("\r\n")); 
			}
			pLogDialog->AddLine(_T("*********************** ALL DONE ***********************\r\n")); 
			_tchdir(m_app_folder);			// change back
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnCbnSelchangeComboCadUnits()
{
	UpdateData(TRUE);		/* Get values from control to member variables	*/

	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;

	UpdateData(FALSE);		/* Refrect member variables to dialog controls	*/
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedCheckCadPilot()
{
	if( m_wndCheckBtn_pilot.GetCheck()==BST_CHECKED)
		m_wndEditCtrl_pilot_diam.EnableWindow(TRUE);
	else
		m_wndEditCtrl_pilot_diam.EnableWindow(FALSE);
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedCancel()
{
	OnCancel();
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedButtonDef()
{
		m_folder = m_project_folder + _T("\\CAM");
		m_wndEditCtrl_folder.SetWindowText( m_folder );
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedButtonFolder()
{
	if( m_folder.IsEmpty() )
	{
		m_folder = m_project_folder + _T("\\CAM");
		m_wndEditCtrl_folder.SetWindowText( m_folder );
	}
	CPathDialog dlg(_T("Select Folder"),_T("Set CAM output folder"), m_folder );
	int ret = dlg.DoModal();
	if( ret == IDOK )
	{
		m_folder = dlg.GetPathName();
		m_wndEditCtrl_folder.SetWindowText( m_folder );
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedThermalPins()
{
	if( m_wndCheckBtn_thermal_pins.GetCheck()==BST_CHECKED|| m_wndCheckBtn_thermal_vias.GetCheck()==BST_CHECKED)
		m_wndCheckBtn_90.EnableWindow(TRUE);
	else
		m_wndCheckBtn_90.EnableWindow(FALSE);
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedThermalVias()
{
	OnBnClickedThermalPins();
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedRenderAllGerbers()
{
	m_wndCheckBtn_mirror_bottom.EnableWindow( m_wndCheckBtn_render_all.GetCheck()==BST_CHECKED);	
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedButtonDone()
{
	if(UpdateData(TRUE))		/* Get values from control to member variables	*/
		OnOK();
	else
		Default();
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnBnClickedFolderOpen()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B

	CString		strOutputFolderPath;
	HINSTANCE	hInst;

	GetDlgItemText(IDC_EDIT_FOLDER,strOutputFolderPath);	// Get current output folderpath from edit control
	if(!strOutputFolderPath.IsEmpty())
	{
		hInst=::ShellExecute(AfxGetMainWnd()->GetSafeHwnd()
//							,_T("explore")							/* Command (executable filepath)	*/
							,_T("open")								/* Command (executable filepath)	*/
							,strOutputFolderPath					/* Command paramter string			*/
							,NULL									/* execution folder path name		*/
							,NULL									/* initial folder path name			*/
							,SW_SHOWNORMAL);
		ShowShellExecuteErrors(hInst);
	}
	else
	{
		AfxMessageBox(_T("OutputFolderPath is not specified!"),MB_ICONINFORMATION|MB_OK);
		GetDlgItem(IDC_EDIT_FOLDER)->SetFocus();
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnCheckBtnClicked(UINT nCtrlID)
{
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnRadioBtnClicked(UINT nCtrlID)
{
}

/*=============================================================================

=============================================================================*/

void	CDlgCAD::OnEditTextChanged(UINT nCtrlID)
{
}

/*=============================================================================
					Xs{^NbNꂽꍇ̏
=============================================================================*/

void	CDlgCAD::OnDeltaPosSpin(UINT nCtrlID,NMHDR* pNMHDR, LRESULT* pResult) 
{

	if(IDC_SPIN1<=nCtrlID && nCtrlID<=IDC_SPIN14)
	{
		NM_UPDOWN	*pNMUpDown=(NM_UPDOWN *)pNMHDR;
		UINT		nPos;

		nPos=nCtrlID-IDC_SPIN1;

	}
	else
	{
		TRACE(_T("\r\nERROR:(Unknown ControlID) - CDlgCAD::OnDeltaPosSpin(nCtrlID=0x%08x)"),nCtrlID);
		ASSERT(FALSE);					/* Debugp({ɂ͗Ȃ͂)	*/
	}
	*pResult = 0;
}

/*-----------------------------------------------------------------------------
							end of DlgCAD.cpp
-----------------------------------------------------------------------------*/
