#pragma once
#include "afxwin.h"
#include "DlgLog.h"


// CDlgCAD dialog

/*=============================================================================
					CDlgCAD _CAO NX̐錾
=============================================================================*/

class CDlgCAD : public CDialog
{
	DECLARE_DYNAMIC(CDlgCAD)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgCAD(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgCAD();
	void Initialize(double version
				   ,CString * folder
				   ,CString * project_folder
				   ,CString * app_folder
				   ,int num_copper_layers
				   ,int units
				   ,BOOL bSMTconnect
				   ,int fill_clearance
				   ,int mask_clearance
				   ,int thermal_width
				   ,int pilot_diameter
				   ,int min_silkscreen_wid
				   ,int outline_width
				   ,int hole_clearance
				   ,int annular_ring_pins
				   ,int annular_ring_vias
				   ,int shrink_paste
				   ,int n_x
				   ,int n_y
				   ,int space_x
				   ,int space_y
				   ,int flags
				   ,int layers
				   ,int drill_file
				   ,CArray<CPolyLine> * bd
				   ,CArray<CPolyLine> * sm
				   ,BOOL * bShowMessageForClearance
				   ,CPartList * pl
				   ,CNetList * nl
				   ,CTextList * tl
				   ,CDisplayList * dl);
//				   ,CDlgLog * log);
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgCAD)
	enum { IDD = IDD_CAD };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgCAD)
protected:
	virtual BOOL OnInitDialog();						/**< _CAȌ(WM_INITDIALOGbZ[Wւ̉)	*/
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	BOOL			m_bShowMessageForClearance;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_bSMT_connect;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	double			m_version;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	double			m_file_version;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_num_copper_layers;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_fill_clearance;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_hole_clearance;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_mask_clearance;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_thermal_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_pilot_diameter;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_min_silkscreen_width;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_outline_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_annular_ring_pins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_annular_ring_vias;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_units;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_flags;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_layers;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_drill_file;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	const CArray<CPolyLine> * m_bd;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	const CArray<CPolyLine> * m_sm;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	CPartList		* m_pl; 						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CNetList		* m_nl; 						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CTextList		* m_tl; 						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CDisplayList	* m_dl;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/

	CString			m_folder;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString			m_project_folder;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString			m_app_folder;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_n_x;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_n_y;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_space_x, m_space_y;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int				m_paste_shrink;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL			m_flgNoConfirmOverWrite;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CEdit		m_wndEditCtrl_folder;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_fill;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_mask;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_drill;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_top_silk;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_bottom_silk;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_top_solder;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_bottom_solder;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_top_copper;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_bottom_copper;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_InnerLayer[14];				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_outline;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_moires;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_layer_text;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CComboBox	m_wndComboBox_units;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_pilot_diam;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_pilot;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_min_ss_w;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_thermal_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_outline_width;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_hole_clearance;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_ann_pins;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_ann_vias;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_thermal_pins;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_thermal_vias;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_mask_vias;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_board;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_top_paste;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_bottom_paste;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_n_x;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_n_y;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_space_x;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_space_y;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_shrink_paste;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_90;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_render_all;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_mirror_bottom;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_smt_thermals;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_sm_clearance_for_cutouts;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Attribute(s) - yz
//--------------------------------------
public:
	BOOL	IsNoConfirmOverWrite() const { return(m_flgNoConfirmOverWrite); }
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(DlgCAD)
	afx_msg void OnBnClickedGo();
	afx_msg void OnCbnSelchangeComboCadUnits();
	afx_msg void OnBnClickedCheckCadPilot();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedButtonDef();
	afx_msg void OnBnClickedButtonFolder();
	afx_msg void OnBnClickedThermalPins();
	afx_msg void OnBnClickedThermalVias();
	afx_msg void OnBnClickedRenderAllGerbers();
	afx_msg void OnBnClickedButtonDone();
	afx_msg void OnBnClickedFolderOpen();
	//}}AFX_MSG
	afx_msg void OnCheckBtnClicked(UINT nCtrlID);
	afx_msg void OnRadioBtnClicked(UINT nCtrlID);
	afx_msg void OnEditTextChanged(UINT nCtrlID);
	afx_msg void OnDeltaPosSpin(UINT nCtrlID,NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgCAD.h
-----------------------------------------------------------------------------*/
