// DlgCentroid.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgCentroid.h"


// CDlgCentroid dialog

IMPLEMENT_DYNAMIC(CDlgCentroid, CDialog)

/*=============================================================================
						CDlgCentroid NX̍\z
=============================================================================*/

CDlgCentroid::CDlgCentroid(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCentroid::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCentroid)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgCentroid NX̏
=============================================================================*/

CDlgCentroid::~CDlgCentroid()
{
}

/*=============================================================================
			CDlgCentroid _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgCentroid::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCentroid)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO3, m_wndPushBtn_default);
	DDX_Control(pDX, IDC_RADIO2, m_wndPushBtn_set);
	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT1, m_wndEditCtrl_x);
	DDX_Control(pDX, IDC_EDIT2, m_wndEditCtrl_y);
	DDX_Control(pDX, IDC_COMBO_ANGLE, m_wndComboBox_angle);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		m_wndComboBox_angle.InsertString( 0,_T("0"));
		m_wndComboBox_angle.InsertString( 1,_T("90"));
		m_wndComboBox_angle.InsertString( 2,_T("180"));
		m_wndComboBox_angle.InsertString( 3,_T("270"));
		SetFields();
	}
	else
	{
		// outgoing
		GetFields();
	}
}

/*=============================================================================
					CDlgCentroid NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgCentroid, CDialog)
	//{{AFX_MSG_MAP(CDlgCentroid)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO3, OnBnClickedDefault)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedSet)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelChangeCombo1)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgCentroid::Initialize(CENTROID_TYPE type			/**< ToDo:Add Comment for Doxygen			*/
								,int units					/**< ToDo:Add Comment for Doxygen			*/
								,int x						/**< ToDo:Add Comment for Doxygen			*/
								,int y						/**< ToDo:Add Comment for Doxygen			*/
								,int angle					/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_type = type;
	m_units = units;
	m_x = x;
	m_y = y;
	m_angle = angle;
}

void CDlgCentroid::SetFields()
{
	CString str;
	if( m_type == CENTROID_DEFAULT )
	{
		m_wndPushBtn_default.SetCheck(BST_CHECKED);
		m_wndPushBtn_set.SetCheck(BST_UNCHECKED);
		m_wndComboBox_units.EnableWindow( FALSE );
		m_wndEditCtrl_x.EnableWindow( FALSE );
		m_wndEditCtrl_y.EnableWindow( FALSE );
	}
	else
	{
		m_wndPushBtn_default.SetCheck(BST_UNCHECKED);
		m_wndPushBtn_set.SetCheck(BST_CHECKED);
		if( m_units == MIL ) 
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );
		m_wndComboBox_units.EnableWindow( TRUE );
		m_wndEditCtrl_x.EnableWindow( TRUE );
		m_wndEditCtrl_y.EnableWindow( TRUE );
	}
	m_wndComboBox_angle.SetCurSel( m_angle/90 );
	::MakeCStringFromDimension( &str, m_x, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_x.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_y, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_y.SetWindowText( str );
}

void CDlgCentroid::GetFields()
{
	if( m_wndPushBtn_default.GetCheck() )
		m_type = CENTROID_DEFAULT;
	else
		m_type = CENTROID_DEFINED;
	CString str;
	m_wndEditCtrl_x.GetWindowText( str );
	m_x = ::GetDimensionFromString( str, m_units );
	m_wndEditCtrl_y.GetWindowText( str );
	m_y = ::GetDimensionFromString( str, m_units );
	m_angle = 90 * m_wndComboBox_angle.GetCurSel();
}


// CDlgCentroid message handlers

void CDlgCentroid::OnBnClickedDefault()
{
	m_wndPushBtn_set.SetCheck(0);
	GetFields();
	SetFields();
}

void CDlgCentroid::OnBnClickedSet()
{
	m_wndPushBtn_default.SetCheck(0); 
	GetFields();
	SetFields();
}

void CDlgCentroid::OnCbnSelChangeCombo1()
{
	GetFields();
	int m_sel_units = m_wndComboBox_units.GetCurSel();
	if( m_sel_units == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}
