// DlgEditBoardCorner.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgEditBoardCorner.h"


// DlgEditBoardCorner dialog

IMPLEMENT_DYNAMIC(DlgEditBoardCorner, CDialog)

/*=============================================================================
						DlgEditBoardCorner NX̍\z
=============================================================================*/

DlgEditBoardCorner::DlgEditBoardCorner(CWnd* pParent /*=NULL*/)
	: CDialog(DlgEditBoardCorner::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgEditBoardCorner)
	//}}AFX_DATA_INIT

	m_title_str = NULL;
	m_units = MIL;
	m_x = m_y = 0;
}

/*=============================================================================
						DlgEditBoardCorner NX̏
=============================================================================*/

DlgEditBoardCorner::~DlgEditBoardCorner()
{
}

/*=============================================================================
		DlgEditBoardCorner _CAOf[^̌ƗL`FbN
=============================================================================*/

void	DlgEditBoardCorner::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgEditBoardCorner)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_COMBO_CORNER_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT_X, m_wndEditCtrl_x);
	DDX_Control(pDX, IDC_EDIT_Y, m_wndEditCtrl_y);
	if( !pDX->m_bSaveAndValidate && m_title_str )
	{
		// incoming
		SetWindowText( *m_title_str );
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel(0);
		else
			m_wndComboBox_units.SetCurSel(1);
		SetFields();
	}
	else
	{
		// outgoing
		GetFields();
	}
}

/*=============================================================================

=============================================================================*/

void DlgEditBoardCorner::Init(CString * str			/**< ToDo:Add Comment for Doxygen			*/
							 ,int units				/**< ToDo:Add Comment for Doxygen			*/
							 ,int x					/**< ToDo:Add Comment for Doxygen			*/
							 ,int y					/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_title_str = str;
	m_x = x;
	m_y = y;
	m_units = units;
}

/*=============================================================================
					DlgEditBoardCorner NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(DlgEditBoardCorner, CDialog)
	//{{AFX_MSG_MAP(DlgEditBoardCorner)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_CORNER_UNITS, OnCbnSelchangeComboCornerUnits)
END_MESSAGE_MAP()


// DlgEditBoardCorner message handlers

void DlgEditBoardCorner::OnCbnSelchangeComboCornerUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

void DlgEditBoardCorner::GetFields()
{
	// get x and y values
	CString xstr;
	m_wndEditCtrl_x.GetWindowText( xstr );
	CString ystr;
	m_wndEditCtrl_y.GetWindowText( ystr );
	if( m_units == MIL )
	{
		m_x = my_atof(xstr)*NM_PER_MIL;
		m_y = my_atof(ystr)*NM_PER_MIL;
	}
	else
	{
		m_x = my_atof(xstr)*1000000.0;
		m_y = my_atof(ystr)*1000000.0;
	}
}

void DlgEditBoardCorner::SetFields()
{
	CString str;
	if( m_units == MIL )
	{
		::MakeCStringFromDouble( &str, (double)m_x/NM_PER_MIL );
		m_wndEditCtrl_x.SetWindowText( str );
		::MakeCStringFromDouble( &str, (double)m_y/NM_PER_MIL );
		m_wndEditCtrl_y.SetWindowText( str );
	}
	else
	{
		::MakeCStringFromDouble( &str, (double)m_x/1000000.0 );
		m_wndEditCtrl_x.SetWindowText( str );
		::MakeCStringFromDouble( &str, (double)m_y/1000000.0 );
		m_wndEditCtrl_y.SetWindowText( str );
	}

}
