// DlgExportDsn.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgExportDsn.h"
#include ".\dlgexportdsn.h"

// globals to save options
BOOL g_bVerbose = FALSE;
BOOL g_bInfo = FALSE;
int g_FromToType = 0;

// CDlgExportDsn dialog

IMPLEMENT_DYNAMIC(CDlgExportDsn, CDialog)

/*=============================================================================
						CDlgExportDsn NX̍\z
=============================================================================*/

CDlgExportDsn::CDlgExportDsn(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgExportDsn::IDD, pParent)
	, m_bounds_poly(0)
	, m_signals_poly(0)
	, m_dsn_filepath(_T(""))
{
	//{{AFX_DATA_INIT(CDlgExportDsn)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgExportDsn NX̏
=============================================================================*/

CDlgExportDsn::~CDlgExportDsn()
{
}

/*=============================================================================
			CDlgExportDsn _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgExportDsn::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgExportDsn)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_CHECK_VERBOSE, m_wndCheckBtn_verbose);
	DDX_Control(pDX, IDC_CHECK_INFO, m_wndCheckBtn_info);
	DDX_CBIndex(pDX, IDC_COMBO_BOUNDS, m_bounds_poly);
	DDX_CBIndex(pDX, IDC_COMBO_SIGNALS, m_signals_poly);
	DDX_Control(pDX, IDC_COMBO_BOUNDS, m_wndComboBox_bounds);
	DDX_Control(pDX, IDC_COMBO_SIGNALS, m_wndComboBox_signals);
	DDX_Text(pDX, IDC_EDIT_FILE, m_dsn_filepath);
	DDX_Control(pDX, IDC_CHECK_FROM_TO, m_wndCheckBtn_from_to);
	DDX_Control(pDX, IDC_RADIO_ALL, m_wndRadioBtn_all);
	DDX_Control(pDX, IDC_RADIO_LOCKED, m_wndRadioBtn_locked);
	DDX_Control(pDX, IDC_RADIO_NET_LOCKED, m_wndRadioBtn_net_locked);

	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		if( m_num_polys < 1 )
			m_num_polys = 1;
		for( int i=1; i<=m_num_polys; i++ )
		{
			CString str;
			str.Format(_T("%d"), i );
			m_wndComboBox_bounds.InsertString( i-1, str );
			m_wndComboBox_signals.InsertString( i-1, str );
		}
		m_wndComboBox_bounds.SetCurSel(m_bounds_poly);
		m_wndComboBox_signals.SetCurSel(m_signals_poly);
		m_wndCheckBtn_verbose.SetCheck( m_flags & DSN_VERBOSE );
		m_wndCheckBtn_info.SetCheck( m_flags & DSN_INFO_ONLY );
		if( m_flags & DSN_FROM_TO_MASK )
		{
			m_wndCheckBtn_from_to.SetCheck( 1 );
		}
		else
		{
			m_wndCheckBtn_from_to.SetCheck( 0 );
			m_wndRadioBtn_all.EnableWindow( FALSE );
			m_wndRadioBtn_locked.EnableWindow( FALSE );
			m_wndRadioBtn_net_locked.EnableWindow( FALSE );
		}
		m_wndRadioBtn_all.SetCheck( (m_flags & DSN_FROM_TO_MASK) == DSN_FROM_TO_ALL );
		m_wndRadioBtn_locked.SetCheck( (m_flags & DSN_FROM_TO_MASK) == DSN_FROM_TO_LOCKED );
		m_wndRadioBtn_net_locked.SetCheck( (m_flags & DSN_FROM_TO_MASK) == DSN_FROM_TO_NET_LOCKED );
	}
	else 
	{
		// outgoing 
		m_flags = 0;
		if( m_wndCheckBtn_verbose.GetCheck() )
			m_flags |= DSN_VERBOSE;
		if( m_wndCheckBtn_info.GetCheck() )
			m_flags |= DSN_INFO_ONLY;
		if( m_wndCheckBtn_from_to.GetCheck() )
		{
			if( m_wndRadioBtn_all.GetCheck() )
				m_flags |= DSN_FROM_TO_ALL;
			else if( m_wndRadioBtn_locked.GetCheck() )
				m_flags |= DSN_FROM_TO_LOCKED;
			else
				m_flags |= DSN_FROM_TO_NET_LOCKED;
		}
	}
}

/*=============================================================================
					CDlgExportDsn NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgExportDsn, CDialog)
	//{{AFX_MSG_MAP(CDlgExportDsn)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_CHECK_FROM_TO, OnBnClickedCheckFromTo)
	ON_BN_CLICKED(IDC_RADIO_ALL, OnBnClickedRadioAll)
	ON_BN_CLICKED(IDC_RADIO_LOCKED, OnBnClickedRadioLocked)
	ON_BN_CLICKED(IDC_RADIO_NET_LOCKED, OnBnClickedRadioNetLocked)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgExportDsn::Initialize( CString * dsn_filepath			/**< ToDo:Add Comment for Doxygen			*/
							     ,int num_board_outline_polys		/**< ToDo:Add Comment for Doxygen			*/
								 ,int bounds_poly					/**< ToDo:Add Comment for Doxygen			*/
								 ,int signals_poly					/**< ToDo:Add Comment for Doxygen			*/
								 ,int flags							/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_dsn_filepath = *dsn_filepath;
	m_bounds_poly = bounds_poly;
	m_signals_poly = signals_poly;
	m_num_polys = num_board_outline_polys;
	m_flags = flags;
}
			
// CDlgExportDsn message handlers

/*=============================================================================

=============================================================================*/

void	CDlgExportDsn::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}



/*=============================================================================

=============================================================================*/

void	CDlgExportDsn::OnBnClickedCheckFromTo()
{
	BOOL bFromTo = m_wndCheckBtn_from_to.GetCheck();
	m_wndRadioBtn_all.EnableWindow( bFromTo );
	m_wndRadioBtn_locked.EnableWindow( bFromTo );
	m_wndRadioBtn_net_locked.EnableWindow( bFromTo );
	if( bFromTo )
	{
		m_wndRadioBtn_all.SetCheck( TRUE );
		m_wndRadioBtn_locked.SetCheck( FALSE );
		m_wndRadioBtn_net_locked.SetCheck( FALSE );
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgExportDsn::OnBnClickedRadioAll()
{
	// TODO: Add your control notification handler code here
}

/*=============================================================================

=============================================================================*/

void	CDlgExportDsn::OnBnClickedRadioLocked()
{
	// TODO: Add your control notification handler code here
}

/*=============================================================================

=============================================================================*/

void	CDlgExportDsn::OnBnClickedRadioNetLocked()
{
	// TODO: Add your control notification handler code here
}
