// DlgAddText.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgFpText.h"

int gFpLastHeight = 100*NM_PER_MIL;
int gFpLastWidth = 10*NM_PER_MIL;

// CDlgFpText dialog

IMPLEMENT_DYNAMIC(CDlgFpText, CDialog)

/*=============================================================================
						CDlgFpText NX̍\z
=============================================================================*/

CDlgFpText::CDlgFpText(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFpText::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgFpText)
	//}}AFX_DATA_INIT

	m_x = 0;
	m_y = 0;
}

/*=============================================================================
						CDlgFpText NX̏
=============================================================================*/

CDlgFpText::~CDlgFpText()
{
}

/*=============================================================================
			CDlgFpText _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgFpText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFpText)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_HEIGHT, m_wndEditCtrl_height);
	DDX_Control(pDX, IDC_SET_WIDTH, m_wndPushBtn_set_width);
	DDX_Control(pDX, IDC_DEF_WIDTH, m_wndPushBtn_def_width);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_wndEditCtrl_width);
	DDX_Control(pDX, IDC_EDIT_TEXT, m_text);
	DDX_Control(pDX, IDC_Y, m_wndEditCtrl_y);
	DDX_Control(pDX, IDC_X, m_wndEditCtrl_x);
	DDX_Text( pDX, IDC_EDIT_TEXT, m_str );
	DDX_Control(pDX, IDC_LIST_ANGLE, m_list_angle);
	DDX_Control(pDX, IDC_RADIO1, m_wndPushBtn_drag);
	DDX_Control(pDX, IDC_RADIO2, m_wndPushBtn_set_position );
	DDX_Control(pDX, IDC_COMBO_ADD_TEXT_UNITS, m_wndComboBox_units);
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		// leaving the dialog
		if( m_str.IsEmpty() )
		{
			AfxMessageBox(_T("Invalid text string"));
			pDX->Fail();
		}
		if( m_str.Find(_T('\"')) != -1 )
		{
			AfxMessageBox(_T("Text string can't contain \""));
			pDX->Fail();
		}
		GetFields();
		int ia = m_list_angle.GetCurSel();
		m_angle = ia*90;
	}
}

/*=============================================================================
					CDlgFpText NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgFpText, CDialog)
	//{{AFX_MSG_MAP(CDlgFpText)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SET_WIDTH, OnBnClickedSetWidth)
	ON_BN_CLICKED(IDC_DEF_WIDTH, OnBnClickedDefWidth)
	ON_EN_CHANGE(IDC_EDIT_HEIGHT, OnEnChangeEditHeight)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedSetPosition)
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedDrag)
	ON_CBN_SELCHANGE(IDC_COMBO_ADD_TEXT_UNITS, OnCbnSelchangeComboAddTextUnits)
END_MESSAGE_MAP()

// Initialize dialog
//
/*=============================================================================

=============================================================================*/

void	CDlgFpText::Initialize(BOOL bDrag			/**< ToDo:Add Comment for Doxygen			*/
							  ,BOOL bFixedString	/**< ToDo:Add Comment for Doxygen			*/
							  ,CString *str			/**< ToDo:Add Comment for Doxygen			*/
							  ,int units			/**< ToDo:Add Comment for Doxygen			*/
							  ,int angle			/**< ToDo:Add Comment for Doxygen			*/
							  ,int height			/**< ToDo:Add Comment for Doxygen			*/
							  ,int width			/**< ToDo:Add Comment for Doxygen			*/
							  ,int x				/**< ToDo:Add Comment for Doxygen			*/
							  ,int y				/**< ToDo:Add Comment for Doxygen			*/ )

{
	m_bDrag = bDrag;
	m_bFixedString = bFixedString;
	if( str )
		m_str = *str;
	else
		m_str = "";
	m_units = units;
	m_angle = angle;
	m_height = height;
	m_width = width;
	m_x = x;
	m_y = y;
}

// CDlgFpText message handlers

/*=============================================================================
					CDlgFpText _CAȌ
=============================================================================*/

BOOL	CDlgFpText::OnInitDialog()
{
	CDialog::OnInitDialog();

	// units
	m_wndComboBox_units.InsertString(	0, _T("MIL"));
	m_wndComboBox_units.InsertString(	1, _T("MM"));
	if(	m_units	== MIL )
	{
		m_wndComboBox_units.SetCurSel(0);
		m_unit_mult = NM_PER_MIL;
	}
	else
	{
		m_wndComboBox_units.SetCurSel(1);
		m_unit_mult = 1000000;
	}

	// height and width
	if( m_height == 0 )
	{
		m_height = gFpLastHeight;
		m_width = gFpLastWidth;
	}

	// angles
	m_list_angle.InsertString( -1,_T("0"));
	m_list_angle.InsertString( -1,_T("90"));
	m_list_angle.InsertString( -1,_T("180"));
	m_list_angle.InsertString( -1,_T("270"));
	if( m_angle == 0 )
		m_list_angle.SetCurSel( 0 );
	else if( m_angle == 90 )
		m_list_angle.SetCurSel( 1 );
	else if( m_angle == 180 )
		m_list_angle.SetCurSel( 2 );
	else
		m_list_angle.SetCurSel( 3 );
	if( !m_bDrag )
	{
		// editing, so set from variables
		m_wndPushBtn_set_position.SetCheck(BST_CHECKED);
		m_wndPushBtn_drag.SetCheck(BST_UNCHECKED);
		m_wndPushBtn_set_width.SetCheck(BST_CHECKED);
		m_wndPushBtn_def_width.SetCheck(BST_UNCHECKED);
		m_wndEditCtrl_x.EnableWindow(TRUE);
		m_wndEditCtrl_y.EnableWindow(TRUE);
		m_wndEditCtrl_width.EnableWindow(TRUE);
	}
	else
	{
		// adding new text
		m_wndPushBtn_drag.SetCheck(BST_CHECKED);
		m_list_angle.SetCurSel( 0 );
		m_wndPushBtn_set_width.SetCheck(BST_UNCHECKED);
		m_wndPushBtn_def_width.SetCheck(BST_CHECKED);
		m_wndEditCtrl_x.EnableWindow(FALSE);
		m_wndEditCtrl_y.EnableWindow(FALSE);
		m_list_angle.EnableWindow(FALSE);
		m_wndEditCtrl_width.EnableWindow(FALSE);
	}
	if( m_bFixedString )
		m_text.EnableWindow( FALSE );
	SetFields();
	return TRUE;  // return TRUE unless you set the focus to a control
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::OnBnClickedSetWidth()
{
	m_wndPushBtn_set_width.SetCheck(BST_CHECKED);
	m_wndPushBtn_def_width.SetCheck(BST_UNCHECKED);
	m_wndEditCtrl_width.EnableWindow(TRUE);
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::OnBnClickedDefWidth()
{
	OnEnChangeEditHeight();
	m_wndPushBtn_set_width.SetCheck(BST_UNCHECKED);
	m_wndPushBtn_def_width.SetCheck(BST_CHECKED);
	m_wndEditCtrl_width.EnableWindow(FALSE);
}

void CDlgFpText::OnEnChangeEditHeight()
{
	if( m_wndPushBtn_def_width.GetCheck() )
	{
		CString str;
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof(str)*m_unit_mult;
		m_width = m_height/10;
		m_width = max( m_width, 1*NM_PER_MIL );
		if( m_units == MIL )
		{
			MakeCStringFromDouble( &str, m_width/NM_PER_MIL );
			m_wndEditCtrl_width.SetWindowText( str );
		}
		else
		{
			MakeCStringFromDouble( &str, m_width/1000000.0 );
			m_wndEditCtrl_width.SetWindowText( str );
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::OnBnClickedOk()
{
	gFpLastHeight = m_height;
	gFpLastWidth = m_width;
	OnOK();
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::OnBnClickedSetPosition()
{
	m_wndEditCtrl_x.EnableWindow(TRUE);
	m_wndEditCtrl_y.EnableWindow(TRUE);
	m_list_angle.EnableWindow(TRUE);
	m_bDrag = 0;
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::OnBnClickedDrag()
{
	m_wndEditCtrl_x.EnableWindow(FALSE);
	m_wndEditCtrl_y.EnableWindow(FALSE);
	m_list_angle.EnableWindow(FALSE);
	m_bDrag = 1;
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::OnCbnSelchangeComboAddTextUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
	{
		m_units = MIL;
		m_unit_mult = NM_PER_MIL;
	}
	else
	{
		m_units = MM;
		m_unit_mult = 1000000;
	}
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::GetFields()
{
	CString str;
	double mult;
	if( m_units == MIL )
		mult = NM_PER_MIL;
	else
		mult = 1000000.0;
	m_wndEditCtrl_height.GetWindowText( str );
	m_height = _tstof( str ) * mult;
	m_wndEditCtrl_width.GetWindowText( str );
	m_width = _tstof( str ) * mult;
	m_wndEditCtrl_x.GetWindowText( str );
	m_x = _tstof( str ) * mult;
	m_wndEditCtrl_y.GetWindowText( str );
	m_y = _tstof( str ) * mult;
}

/*=============================================================================

=============================================================================*/

void	CDlgFpText::SetFields()
{
	CString str;
	double mult;
	if( m_units == MIL )
		mult = NM_PER_MIL;
	else
		mult = 1000000.0;
	MakeCStringFromDouble( &str, m_height/mult );
	m_wndEditCtrl_height.SetWindowText( str );
	MakeCStringFromDouble( &str, m_width/mult );
	m_wndEditCtrl_width.SetWindowText( str );
	MakeCStringFromDouble( &str, m_x/mult );
	m_wndEditCtrl_x.SetWindowText( str );
	MakeCStringFromDouble( &str, m_y/mult );
	m_wndEditCtrl_y.SetWindowText( str );
}


