// DlgHole.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgHole.h"

// defines
enum {
	POS_DEFAULT,
	POS_DEFINED,
	POS_DRAG
};

// CDlgHole dialog

IMPLEMENT_DYNAMIC(CDlgHole, CDialog)

/*=============================================================================
						CDlgHole NX̍\z
=============================================================================*/

CDlgHole::CDlgHole(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgHole::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgHole)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgHole NX̏
=============================================================================*/

CDlgHole::~CDlgHole()
{
}

/*=============================================================================
			CDlgHole _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgHole::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgHole)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO2, m_wndRadioBtn_set);
	DDX_Control(pDX, IDC_RADIO1, m_wndRadioBtn_drag);
	DDX_Control(pDX, IDC_RADIO5, m_wndRadioBtn_plated);
	DDX_Control(pDX, IDC_RADIO6, m_wndRadioBtn_unplated);
	DDX_Control(pDX, IDC_COMBO1, m_wndComboBox_units);
	DDX_Control(pDX, IDC_EDIT1, m_wndEditCtrl_x);
	DDX_Control(pDX, IDC_EDIT2, m_wndEditCtrl_y);
	DDX_Control(pDX, IDC_EDIT_DIAMETER, m_wndEditCtrl_w);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		SetFields();
	}
	else
	{
		// outgoing
		GetFields();
	}
}

/*=============================================================================
					CDlgHole NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgHole, CDialog)
	//{{AFX_MSG_MAP(CDlgHole)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelChangeCombo1)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedSet)
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedDrag)
	ON_BN_CLICKED(IDC_RADIO5, OnBnClickedPlated)
	ON_BN_CLICKED(IDC_RADIO6, OnBnClickedUnplated)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgHole::Initialize(int units			/**< ToDo:Add Comment for Doxygen			*/
							,int w				/**< ToDo:Add Comment for Doxygen			*/
							,int x				/**< ToDo:Add Comment for Doxygen			*/
							,int y				/**< ToDo:Add Comment for Doxygen			*/
							,BOOL bPlated		/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_bDrag =  TRUE;
	m_bPlated =  TRUE;
	m_units = units;
	m_w = w;
	m_x = x;
	m_y = y;
}

/*=============================================================================

=============================================================================*/

void	CDlgHole::SetFields()
{
	CString str;
	m_wndRadioBtn_plated.SetCheck( m_bPlated );
	m_wndRadioBtn_unplated.SetCheck( !m_bPlated );
	m_wndRadioBtn_set.SetCheck( !m_bDrag );
	m_wndRadioBtn_drag.SetCheck( m_bDrag );
	m_wndEditCtrl_x.EnableWindow( !m_bDrag );
	m_wndEditCtrl_y.EnableWindow( !m_bDrag );
	if( m_units == MIL ) 
		m_wndComboBox_units.SetCurSel( 0 );
	else
		m_wndComboBox_units.SetCurSel( 1 );
	::MakeCStringFromDimension( &str, m_w, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_w.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_x, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_x.SetWindowText( str );
	::MakeCStringFromDimension( &str, m_y, m_units, FALSE, FALSE, FALSE, 3 );
	m_wndEditCtrl_y.SetWindowText( str );
}

/*=============================================================================

=============================================================================*/

void	CDlgHole::GetFields()
{
	CString str;
	m_bDrag = m_wndRadioBtn_drag.GetCheck();
	m_bPlated = m_wndRadioBtn_plated.GetCheck();
	m_wndEditCtrl_w.GetWindowText( str );
	m_w = ::GetDimensionFromString( str, m_units );
	m_wndEditCtrl_x.GetWindowText( str );
	m_x = ::GetDimensionFromString( str, m_units );
	m_wndEditCtrl_y.GetWindowText( str );
	m_y = ::GetDimensionFromString( str, m_units );
}


// CDlgHole message handlers

/*=============================================================================

=============================================================================*/

void	CDlgHole::OnCbnSelChangeCombo1()
{
	GetFields();
	int m_sel_units = m_wndComboBox_units.GetCurSel();
	if( m_sel_units == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgHole::OnBnClickedSet()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgHole::OnBnClickedDrag()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgHole::OnBnClickedPlated()
{
	GetFields();
	SetFields();
}

/*=============================================================================

=============================================================================*/

void	CDlgHole::OnBnClickedUnplated()
{
	GetFields();
	SetFields();
}

