// DlgImportOptions.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgImportOptions.h"


// CDlgImportOptions dialog

IMPLEMENT_DYNAMIC(CDlgImportOptions, CDialog)

/*=============================================================================
						CDlgImportOptions NX̍\z
=============================================================================*/

CDlgImportOptions::CDlgImportOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgImportOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgImportOptions)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgImportOptions NX̏
=============================================================================*/

CDlgImportOptions::~CDlgImportOptions()
{
}

/*=============================================================================
			CDlgImportOptions _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgImportOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgImportOptions)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_RADIO_REMOVE_PARTS, m_wndRadioBtn_remove_parts);
	DDX_Control(pDX, IDC_RADIO_KEEP_PARTS_NO_CONNECTIONS, m_wndRadioBtn_keep_parts_no_connections);
	DDX_Control(pDX, IDC_RADIO_KEEP_PARTS_AND_CONNECTIONS, m_wndRadioBtn_keep_parts_and_connections);
	DDX_Control(pDX, IDC_RADIO4, m_wndRadioBtn_change_fp);
	DDX_Control(pDX, IDC_RADIO3, m_wndRadioBtn_keep_fp);
	DDX_Control(pDX, IDC_RADIO6, m_wndRadioBtn_remove_nets);
	DDX_Control(pDX, IDC_RADIO5, m_wndRadioBtn_keep_nets);
	DDX_Control(pDX, IDC_CHECK_KEEP_TRACES, m_wndCheckBtn_keep_traces);
	DDX_Control(pDX, IDC_CHECK_KEEP_STUBS, m_wndCheckBtn_keep_stubs);
	DDX_Control(pDX, IDC_CHECK_KEEP_AREAS, m_wndCheckBtn_keep_areas);
	DDX_Control(pDX, ID_SAVE_AND_IMPORT, m_button_save_and_import);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		if( m_flags & IMPORT_PARTS )
		{
			m_wndRadioBtn_remove_parts.EnableWindow( 1 );
			m_wndRadioBtn_keep_parts_no_connections.EnableWindow( 1 );
			m_wndRadioBtn_keep_parts_and_connections.EnableWindow( 1 );
			m_wndRadioBtn_keep_fp.EnableWindow( 1 );
			m_wndRadioBtn_change_fp.EnableWindow( 1 );
			if( m_flags & KEEP_PARTS_AND_CON )
				m_wndRadioBtn_keep_parts_and_connections.SetCheck( TRUE );
			else if( m_flags & KEEP_PARTS_NO_CON )
				m_wndRadioBtn_keep_parts_no_connections.SetCheck( TRUE );
			else
				m_wndRadioBtn_remove_parts.SetCheck( TRUE );
			if( m_flags & KEEP_FP )
				m_wndRadioBtn_keep_fp.SetCheck( TRUE );
			else
				m_wndRadioBtn_change_fp.SetCheck( TRUE );
		}
		else
		{
			m_wndRadioBtn_remove_parts.EnableWindow( 0 );
			m_wndRadioBtn_keep_parts_no_connections.EnableWindow( 0 );
			m_wndRadioBtn_keep_parts_and_connections.EnableWindow( 0 );
			m_wndRadioBtn_keep_fp.EnableWindow( 0 );
			m_wndRadioBtn_change_fp.EnableWindow( 0 );
		}
		if( m_flags & IMPORT_NETS )
		{
			m_wndRadioBtn_keep_nets.EnableWindow( 1 );
			m_wndRadioBtn_remove_nets.EnableWindow( 1 );
			m_wndCheckBtn_keep_traces.EnableWindow( 1 );
			m_wndCheckBtn_keep_stubs.EnableWindow( 1 );
			m_wndCheckBtn_keep_areas.EnableWindow( 1 );
			if( m_flags & KEEP_NETS )
				m_wndRadioBtn_keep_nets.SetCheck( TRUE );
			else
				m_wndRadioBtn_remove_nets.SetCheck( TRUE );
			m_wndCheckBtn_keep_traces.SetCheck( m_flags & KEEP_TRACES );
			m_wndCheckBtn_keep_stubs.SetCheck( m_flags & KEEP_STUBS );
			m_wndCheckBtn_keep_areas.SetCheck( m_flags & KEEP_AREAS );
		}
		else
		{
			m_wndRadioBtn_keep_nets.EnableWindow( 0 );
			m_wndRadioBtn_remove_nets.EnableWindow( 0 );
			m_wndCheckBtn_keep_traces.EnableWindow( 0 );
			m_wndCheckBtn_keep_stubs.EnableWindow( 0 );
			m_wndCheckBtn_keep_areas.EnableWindow( 0 );
		}
	}
	else
	{
		// outgoing
		if( m_flags & IMPORT_PARTS )
		{
			m_flags &= ~(KEEP_PARTS_NO_CON | KEEP_PARTS_AND_CON | KEEP_FP);
			if( m_wndRadioBtn_keep_parts_no_connections.GetCheck() )
				m_flags |= KEEP_PARTS_NO_CON;
			else if( m_wndRadioBtn_keep_parts_and_connections.GetCheck() )
				m_flags |= KEEP_PARTS_AND_CON;
			if( m_wndRadioBtn_keep_fp.GetCheck() )
				m_flags |= KEEP_FP;
		}
		if( m_flags & IMPORT_NETS )
		{
			m_flags &= ~(KEEP_NETS | KEEP_TRACES | KEEP_STUBS | KEEP_AREAS);
			if( m_wndRadioBtn_keep_nets.GetCheck() )
				m_flags |= KEEP_NETS;
			if( m_wndCheckBtn_keep_traces.GetCheck() )
				m_flags |= KEEP_TRACES;
			if( m_wndCheckBtn_keep_stubs.GetCheck() )
				m_flags |= KEEP_STUBS;
			if( m_wndCheckBtn_keep_areas.GetCheck() )
				m_flags |= KEEP_AREAS;
		}
	}
}

/*=============================================================================
				CDlgImportOptions NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgImportOptions, CDialog)
	//{{AFX_MSG_MAP(CDlgImportOptions)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(ID_SAVE_AND_IMPORT, OnBnClickedSaveAndImport)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgImportOptions::Initialize( int flags )
{
	m_flags = flags;
}

// CDlgImportOptions message handlers

/*=============================================================================
				CDlgImportOptions EBhE鎞̏
=============================================================================*/

int		CDlgImportOptions::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ

	LOGFONT		lf;
	CFont		*pFont;

	pFont=CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT));
	ASSERT(pFont);
	pFont->GetLogFont(&lf);
//	lf.lfHeight=-MulDiv(20,GetDC()->GetDeviceCaps(LOGPIXELSY),72);
	lf.lfWeight=FW_BOLD;
	if(!m_gdiBoldFont.CreateFontIndirect(&lf))
	{
		TRACE(_T("Failed to Create CFont Object (Error code=0x%08X)"),::GetLastError());
		return -1;
	}
	m_gdiYellowBrush.CreateSolidBrush(RGB(255,255,  0));

	return 0;
}

/*=============================================================================
				  CDlgImportOptions _CAȌ
=============================================================================*/

BOOL	CDlgImportOptions::OnInitDialog()
{
	CDialog::OnInitDialog();

	if(m_gdiBoldFont.GetSafeHandle())
	{
		CStatic		*pCtrl;

		pCtrl=(CStatic *)GetDlgItem(IDC_TEXT1);
		ASSERT(pCtrl);
		pCtrl->SetFont(&m_gdiBoldFont);
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

/*=============================================================================
			  CDlgImportOptions EBhEj鎞̏
=============================================================================*/

void	CDlgImportOptions::OnDestroy()
{
	CDialog::OnDestroy();

	if(m_gdiBoldFont.GetSafeHandle())
		m_gdiBoldFont.DeleteObject();				/* GDIIuWFNgj	*/
	if(m_gdiYellowBrush.GetSafeHandle())
		m_gdiYellowBrush.DeleteObject();			/* GDIIuWFNgj	*/
}

/*=============================================================================

=============================================================================*/

HBRUSH CDlgImportOptions::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO :   DC ̑ύXĂB
	// TODO :  lgpȂꍇ͕ʂ̃uVԂ܂B

	UINT			nCtlID=pWnd->GetDlgCtrlID();

	if(nCtlID==IDC_TEXT1)										/* Ώ۔͈	*/
	{
		pDC->SetBkMode(TRANSPARENT);			/* eLXg`̔wi͓	*/
		hbr=(HBRUSH)m_gdiYellowBrush.GetSafeHandle();
	}
	return hbr;
}

/*=============================================================================

=============================================================================*/

void	CDlgImportOptions::OnBnClickedSaveAndImport()
{
	m_flags |= SAVE_BEFORE_IMPORT;
	OnOK();
}

/*=============================================================================

=============================================================================*/

void	CDlgImportOptions::OnBnClickedOk()
{
	m_flags &= ~SAVE_BEFORE_IMPORT;
	OnOK();
}

