// DlgImportSes.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgImportSes.h"
#include ".\dlgimportses.h"

// globals to remember options
BOOL g_bSesVerbose = FALSE;

// CDlgImportSes dialog

IMPLEMENT_DYNAMIC(CDlgImportSes, CDialog)

/*=============================================================================
						CDlgImportSes NX̍\z
=============================================================================*/

CDlgImportSes::CDlgImportSes(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgImportSes::IDD, pParent)
	, m_bVerbose(FALSE)
{
	//{{AFX_DATA_INIT(CDlgImportSes)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgImportSes NX̏
=============================================================================*/

CDlgImportSes::~CDlgImportSes()
{
}

/*=============================================================================
			CDlgImportSes _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgImportSes::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgImportSes)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_SES, m_wndEditCtrl_ses_filepath);
	DDX_Check(pDX, IDC_CHECK_VERBOSE, m_bVerbose);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		int dot_pos = m_pcb_filepath.ReverseFind(_T('.'));
		if( dot_pos > 0 )
		{
			m_default_ses_filepath = m_pcb_filepath.Left( dot_pos );
			m_routed_pcb_filepath = m_default_ses_filepath + _T("_routed.fpc");
			m_default_ses_filepath.Append(_T(".ses"));
		}
		if( m_ses_filepath.IsEmpty())
			m_ses_filepath = m_default_ses_filepath;
		m_wndEditCtrl_ses_filepath.SetWindowText( m_ses_filepath );
	}
	else
	{
		// outgoing
		g_bSesVerbose = m_bVerbose;
		m_wndEditCtrl_ses_filepath.GetWindowText( m_ses_filepath );
	}
}

/*=============================================================================
					CDlgImportSes NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgImportSes, CDialog)
	//{{AFX_MSG_MAP(CDlgImportSes)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_DEF, OnBnClickedButtonDef)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnBnClickedButtonBrowse)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgImportSes::Initialize(CString * ses_filepath			/**< ToDo:Add Comment for Doxygen			*/
								 ,CString * pcb_filepath			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_ses_filepath = *ses_filepath;
	m_pcb_filepath = *pcb_filepath;
	m_bVerbose = g_bSesVerbose;
}

// CDlgImportSes message handlers

/*=============================================================================

=============================================================================*/

void	CDlgImportSes::OnBnClickedButtonDef()
{
	m_ses_filepath = m_default_ses_filepath;
	m_wndEditCtrl_ses_filepath.SetWindowText( m_ses_filepath );
}

/*=============================================================================

=============================================================================*/

void	CDlgImportSes::OnBnClickedButtonBrowse()
{
	// force old-style file dialog by setting size of OPENFILENAME struct (for Win98)
	CFileDialog	dlg(TRUE														/*										*/
				   ,_T("ses")													/*										*/
				   , LPCTSTR(m_ses_filepath)									/*										*/
				   , 0															/*										*/
				   ,_T("Session files (*.ses)|*.ses|All Files (*.*)|*.*||")		/*										*/
				   ,NULL);														/*										*/
//				   , OPENFILENAME_SIZE_VERSION_400 );
	dlg.AssertValid();

	// get folder of last ses file
	CString ses_folder;
	if( ses_folder != _T("") )
	{
		ses_folder = m_ses_filepath.Left( m_ses_filepath.ReverseFind(_T('\\'))) + _T("\\");
		dlg.m_ofn.lpstrInitialDir = ses_folder;
	}
	// now show dialog
	int err = dlg.DoModal(); 
	if( err == IDOK )
	{
		m_ses_filepath = dlg.GetPathName();
		m_wndEditCtrl_ses_filepath.SetWindowText( m_ses_filepath );
	}
}
