// DlgLayers.cpp : implementation file
//
// uses global arrays in layers.h
//
#include	"stdafx.h"
#include	"FreePcb.h"
#include	"DlgLayers.h"

// CDlgLayers dialog

IMPLEMENT_DYNAMIC(CDlgLayers, CDialog)

/*=============================================================================
						CDlgLayers NX̍\z
=============================================================================*/

CDlgLayers::CDlgLayers(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLayers::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLayers)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgLayers NX̏
=============================================================================*/

CDlgLayers::~CDlgLayers()
{
}

/*=============================================================================
			CDlgLayers _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgLayers::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLayers)
	//}}AFX_DATA_MAP

	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// on entry
		for( int i=m_nlayers; i<NUM_DLG_LAYERS; i++ )
			GetDlgItem( IDC_CHECK_LAYER_3+i-2 )->EnableWindow( 0 );
	}
	for( int i=0; i<NUM_DLG_LAYERS; i++ )
	{
		if( i>1 )
			DDX_Check( pDX, IDC_CHECK_LAYER_3+i-2, m_vis[i] );
	}
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		// on OK
		for( int i=0; i<NUM_DLG_LAYERS; i++ )
		{
			m_rgb_ptr[i]=m_rgbLayerColor[i];
		}
	}
}

/*=============================================================================
					CDlgLayers NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgLayers, CDialog)
	//{{AFX_MSG_MAP(CDlgLayers)
	//}}AFX_MSG_MAP
	ON_WM_CTLCOLOR()
	ON_CONTROL_RANGE(BN_CLICKED,IDC_BUTTON_LAYER_1,IDC_BUTTON_LAYER_28, OnLayerBtnClicked)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgLayers::Initialize(int nlayers			/**< ToDo:Add Comment for Doxygen			*/
							  ,int vis[]			/**< ToDo:Add Comment for Doxygen			*/
							  ,COLORREF rgb[]		/**< ToDo:Add Comment for Doxygen			*/ )
{
	ASSERT(0<=nlayers && nlayers<CFreePcbApp::MAX_LAYERS);

	m_nlayers = nlayers;
	m_vis = vis;
	m_rgb_ptr = rgb;

	for(int i=0;i<NUM_DLG_LAYERS;i++ )
		m_rgbLayerColor[i]=m_rgb_ptr[i];		/* Copy default edit color from source */
}

// CDlgLayers message handlers

/*=============================================================================

=============================================================================*/
// set color boxes
//
HBRUSH CDlgLayers::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	// TODO:  Change any attributes of the DC here
	// TODO:  Return a different brush if the default is not desired
	if ( pWnd->GetDlgCtrlID() >= IDC_STATIC_LAYER_1 && pWnd->GetDlgCtrlID() <= (IDC_STATIC_LAYER_1+NUM_DLG_LAYERS-1) )
	{
		int i = pWnd->GetDlgCtrlID() - IDC_STATIC_LAYER_1;
		// Set layer color
		pDC->SetTextColor(m_rgbLayerColor[i]);
		pDC->SetBkMode(TRANSPARENT);
		m_brush.DeleteObject();
		m_brush.CreateSolidBrush(m_rgbLayerColor[i]);
		hbr = m_brush;
	}
	return hbr;
}

// handle edit button clicks
//
/*=============================================================================

=============================================================================*/

void	CDlgLayers::OnLayerBtnClicked(UINT nCtrlID)
{
	if(IDC_BUTTON_LAYER_1<=nCtrlID && nCtrlID<=IDC_BUTTON_LAYER_28)
	{
		int		nLayerPos;

		nLayerPos=nCtrlID-IDC_BUTTON_LAYER_1;
		ASSERT(0<=nLayerPos && nLayerPos<=27);
		EditColor(nLayerPos);
	}
	else
	{
		TRACE(_T("\r\nERROR:(Unknown ControlID) - CDlgLayers::OnLayerBtnClicked(nCtrlID=0x%08x)"),nCtrlID);
		ASSERT(FALSE);					/* Debugp({ɂ͗Ȃ͂)	*/
	}
}

// edit color for selected layer
//
/*=============================================================================

=============================================================================*/

void	CDlgLayers::EditColor( int layer )
{
	if(0<=layer && layer<CFreePcbApp::MAX_LAYERS)
	{
		CColorDialog	wndDlg(m_rgbLayerColor[layer],CC_FULLOPEN|CC_ANYCOLOR);

		int ret = wndDlg.DoModal();
		if( ret == IDOK )
		{
			m_rgbLayerColor[layer]=wndDlg.GetColor();
			Invalidate( FALSE );
		}
	}
	else
		ASSERT(FALSE);
}
