// DlgNetlist.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgNetlist.h"
#include "DlgEditNet.h"
#include "DlgSetTraceWidths.h"

/*=============================================================================
	columns for list
=============================================================================*/
enum
{
	 COL_VIS = 0						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_NAME							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_PINS							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_WIDTH							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_VIA_W							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_HOLE_W							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

/*=============================================================================
	sort types
=============================================================================*/
enum
{
	 SORT_UP_NAME = 0					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_NAME						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_PINS						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_PINS						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_WIDTH						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_WIDTH					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_VIA_W						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_VIA_W					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_HOLE_W						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_HOLE_W					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

// global so that it is available to Compare() for sorting list control items
netlist_info nl;

// global callback function for sorting
// lp1, lp2 are indexes to global arrays above
//		
int CALLBACK CompareNetlist( LPARAM lp1, LPARAM lp2, LPARAM type )
{
	int ret = 0;
	switch( type )
	{
		case SORT_UP_NAME:
		case SORT_DOWN_NAME:
			ret = (_tcscmp( ::nl[lp1].name, ::nl[lp2].name ));
			break;

		case SORT_UP_WIDTH:
		case SORT_DOWN_WIDTH:
			if( ::nl[lp1].w > ::nl[lp2].w )
				ret = 1;
			else if( ::nl[lp1].w < ::nl[lp2].w )
				ret = -1;
			break;

		case SORT_UP_VIA_W:
		case SORT_DOWN_VIA_W:
			if( ::nl[lp1].v_w > ::nl[lp2].v_w )
				ret = 1;
			else if( ::nl[lp1].v_w < ::nl[lp2].v_w )
				ret = -1;
			break;

		case SORT_UP_HOLE_W:
		case SORT_DOWN_HOLE_W:
			if( ::nl[lp1].v_h_w > ::nl[lp2].v_h_w )
				ret = 1;
			else if( ::nl[lp1].v_h_w < ::nl[lp2].v_h_w )
				ret = -1;
			break;

		case SORT_UP_PINS:
		case SORT_DOWN_PINS:
			if( ::nl[lp1].ref_des.GetSize() > ::nl[lp2].ref_des.GetSize() )
				ret = 1;
			else if( ::nl[lp1].ref_des.GetSize() < ::nl[lp2].ref_des.GetSize() )
				ret = -1;
			break;
	}
	switch( type )
	{
		case SORT_DOWN_NAME:
		case SORT_DOWN_WIDTH:
		case SORT_DOWN_VIA_W:
		case SORT_DOWN_HOLE_W:
		case SORT_DOWN_PINS:
			ret = -ret;
			break;
	}

	return ret;
}

// CDlgNetlist dialog

IMPLEMENT_DYNAMIC(CDlgNetlist, CDialog)

/*=============================================================================
					CDlgNetlist NX̍\z
=============================================================================*/

CDlgNetlist::CDlgNetlist(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgNetlist::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgNetlist)
	//}}AFX_DATA_INIT

	m_w = 0;
	m_v_w = 0;
	m_v_h_w = 0;
	m_nlist = 0;
}

/*=============================================================================
					CDlgNetlist NX̏
=============================================================================*/

CDlgNetlist::~CDlgNetlist()
{
}

/*=============================================================================
			CDlgNetlist _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgNetlist::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgNetlist)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_LIST_NET, m_wndListCtrl);
	DDX_Control(pDX, IDC_BUTTON_VISIBLE, m_wndPushBtn_visible);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_wndPushBtn_edit);
	DDX_Control(pDX, IDC_BUTTON_DELETE, m_wndPushBtn_delete);
	DDX_Control(pDX, IDC_BUTTON_ADD, m_wndPushBtn_add);
	DDX_Control(pDX, IDC_BUTTON_SELECT_ALL, m_wndPushBtn_select_all);
	DDX_Control(pDX, IDC_BUTTON_NL_WIDTH, m_wndPushBtn_nl_width);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_cancel);
	DDX_Control(pDX, IDC_BUTTON_DELETE2, m_wndPushBtn_delete_single);
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		// update ::nl with visibility data before leaving
		int n_local_nets = ::nl.GetSize();
		for( int iItem=0; iItem<m_wndListCtrl.GetItemCount(); iItem++ )
		{
			int i = m_wndListCtrl.GetItemData( iItem );
			::nl[i].visible = ListView_GetCheckState( m_wndListCtrl, iItem );
		}
	}
}

/*=============================================================================
				CDlgNetlist NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgNetlist, CDialog)
	//{{AFX_MSG_MAP(CDlgNetlist)
	//}}AFX_MSG_MAP
//	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_NET, OnLvnItemchangedListNet)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_NET, OnLvnColumnclickListNet)
	ON_BN_CLICKED(IDC_BUTTON_VISIBLE, OnBnClickedButtonVisible)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnBnClickedButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_ALL, OnBnClickedButtonSelectAll)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnBnClickedButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnBnClickedButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_DELETE2, OnBnClickedButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_NL_WIDTH, OnBnClickedButtonNLWidth)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_NOPINS, OnBnClickedDeleteNetsWithNoPins)
	ON_NOTIFY(NM_CLICK, IDC_LIST_NET, OnNMClickListNet)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::Initialize(CNetList * nlist			/**< ToDo:Add Comment for Doxygen			*/
							   ,CPartList * plist			/**< ToDo:Add Comment for Doxygen			*/
							   ,CArray<int> * w				/**< ToDo:Add Comment for Doxygen			*/
							   ,CArray<int> * v_w			/**< ToDo:Add Comment for Doxygen			*/
							   ,CArray<int> * v_h_w			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_nlist = nlist;
	m_plist = plist;
	m_w = w;
	m_v_w = v_w;
	m_v_h_w = v_h_w;
}

// CDlgNetlist message handlers

/*=============================================================================
					CDlgNetlist _CAȌ
=============================================================================*/

BOOL	CDlgNetlist::OnInitDialog()
{
	CDialog::OnInitDialog();

	// make copy of netlist data so that it can be edited but user can still cancel
	// use global netlist_info so it can be sorted in the list control
	m_nl = &::nl;
	m_nlist->ExportNetListInfo( &::nl );

	// initialize netlist control
	m_item_selected = -1;
	m_sort_type = 0;
	m_visible_state = 1;
	DrawListCtrl();

	// initialize buttons
	m_wndPushBtn_edit.EnableWindow(FALSE);
	m_wndPushBtn_delete_single.EnableWindow(FALSE);
	m_wndPushBtn_nl_width.EnableWindow(FALSE);
	m_wndPushBtn_delete.EnableWindow(FALSE);
	return TRUE;  
}

// draw listview control and sort according to m_sort_type
//

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::DrawListCtrl()
{
	int nItem;
	CString str;
	DWORD old_style = m_wndListCtrl.GetExtendedStyle();
	m_wndListCtrl.SetExtendedStyle( LVS_EX_FULLROWSELECT | LVS_EX_FLATSB | LVS_EX_CHECKBOXES | old_style );
	m_wndListCtrl.DeleteAllItems();
	m_wndListCtrl.InsertColumn( COL_VIS	, _T("Vis")		, LVCFMT_LEFT, 25 );
	m_wndListCtrl.InsertColumn( COL_NAME	, _T("Name")	, LVCFMT_LEFT, 140 );
	m_wndListCtrl.InsertColumn( COL_PINS	, _T("Pins")	, LVCFMT_LEFT, 40 );
	m_wndListCtrl.InsertColumn( COL_WIDTH	, _T("Width")	, LVCFMT_LEFT, 40 );
	m_wndListCtrl.InsertColumn( COL_VIA_W	, _T("Via W")	, LVCFMT_LEFT, 40 );   
	m_wndListCtrl.InsertColumn( COL_HOLE_W, _T("Hole")	, LVCFMT_LEFT, 40 );
	int iItem = 0;
	for( int i=0; i<::nl.GetSize(); i++ )
	{
		if( ::nl[i].deleted == FALSE )
		{
			nItem = m_wndListCtrl.InsertItem( iItem, _T(""));
			m_wndListCtrl.SetItemData( iItem, (LPARAM)i );
			m_wndListCtrl.SetItem( iItem, COL_NAME, LVIF_TEXT, ::nl[i].name, 0, 0, 0, 0 );
			str.Format(_T("%d"), ::nl[i].ref_des.GetSize() );
			m_wndListCtrl.SetItem( iItem, COL_PINS, LVIF_TEXT, str, 0, 0, 0, 0 );
			str.Format(_T("%d"), ::nl[i].w/NM_PER_MIL );
			m_wndListCtrl.SetItem( iItem, COL_WIDTH, LVIF_TEXT, str, 0, 0, 0, 0 );
			str.Format(_T("%d"), ::nl[i].v_w/NM_PER_MIL );
			m_wndListCtrl.SetItem( iItem, COL_VIA_W, LVIF_TEXT, str, 0, 0, 0, 0 );
			str.Format(_T("%d"), ::nl[i].v_h_w/NM_PER_MIL );
			m_wndListCtrl.SetItem( iItem, COL_HOLE_W, LVIF_TEXT, str, 0, 0, 0, 0 );
			ListView_SetCheckState( m_wndListCtrl, nItem, ::nl[i].visible );
		}
	}
	m_wndListCtrl.SortItems( ::CompareNetlist, m_sort_type );
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnLvnColumnclickListNet(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	int column = pNMLV->iSubItem;
	if( column == COL_NAME )
	{
		if( m_sort_type == SORT_UP_NAME )
			m_sort_type = SORT_DOWN_NAME;
		else
			m_sort_type = SORT_UP_NAME;
		m_wndListCtrl.SortItems( ::CompareNetlist, m_sort_type );
	}
	else if( column == COL_WIDTH )
	{
		if( m_sort_type == SORT_UP_WIDTH )
			m_sort_type = SORT_DOWN_WIDTH;
		else
			m_sort_type = SORT_UP_WIDTH;
		m_wndListCtrl.SortItems( ::CompareNetlist, m_sort_type );
	}
	else if( column == COL_VIA_W )
	{
		if( m_sort_type == SORT_UP_VIA_W )
			m_sort_type = SORT_DOWN_VIA_W;
		else
			m_sort_type = SORT_UP_VIA_W;
		m_wndListCtrl.SortItems( ::CompareNetlist, m_sort_type );
	}
	else if( column == COL_HOLE_W )
	{
		if( m_sort_type == SORT_UP_HOLE_W )
			m_sort_type = SORT_DOWN_HOLE_W;
		else
			m_sort_type = SORT_UP_HOLE_W;
		m_wndListCtrl.SortItems( ::CompareNetlist, m_sort_type );
	}
	else if( column == COL_PINS )
	{
		if( m_sort_type == SORT_UP_PINS )
			m_sort_type = SORT_DOWN_PINS;
		else
			m_sort_type = SORT_UP_PINS;
		m_wndListCtrl.SortItems( ::CompareNetlist, m_sort_type );
	}
	*pResult = 0;
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedButtonVisible()
{
	for( int i=0; i<m_wndListCtrl.GetItemCount(); i++ )
	{
		ListView_SetCheckState( m_wndListCtrl, i, m_visible_state );
	}
	for( int i=0; i<::nl.GetSize(); i++ )
	{
		::nl[i].visible = m_visible_state;
	}
	m_visible_state =  1 - m_visible_state;
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedButtonEdit()
{
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel == 0 )
		AfxMessageBox(_T("You have no net selected"));
	else if( n_sel > 1 )
		AfxMessageBox(_T("You have more than one net selected"));
	else
	{
		POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
		if (pos == NULL)
			ASSERT(FALSE);
		int nItem = m_wndListCtrl.GetNextSelectedItem(pos);
		int i = m_wndListCtrl.GetItemData( nItem );

		// prepare and invoke dialog
		CMainFrame		*pMainWnd=NULL;
		CFreePcbDoc		*pDoc=NULL;
//		CFreePcbView	*pView=NULL;

		pMainWnd=(CMainFrame *)AfxGetMainWnd();
		ASSERT_KINDOF(CMainFrame,pMainWnd);
		pDoc=(CFreePcbDoc *)pMainWnd->GetActiveDocument();
		ASSERT_KINDOF(CFreePcbDoc,pDoc);
//		pView=(CFreePcbView *)pMainWnd->GetActiveView();
//		ASSERT_KINDOF(CFreePcbView,pView);

		CDlgEditNet dlg;

		dlg.Initialize( &nl, i, m_plist, FALSE, ListView_GetCheckState( m_wndListCtrl, nItem ),
						MIL, &(pDoc->m_w), &(pDoc->m_v_w), &(pDoc->m_v_h_w) );
		int ret = dlg.DoModal();
		if( ret == IDOK )
		{
			// implement edits into nl and update m_wndListCtrl
			DrawListCtrl();
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedButtonAdd()
{
	// prepare CDlgEditNet
	CMainFrame		*pMainWnd=NULL;
	CFreePcbDoc		*pDoc=NULL;
//	CFreePcbView	*pView=NULL;

	pMainWnd=(CMainFrame *)AfxGetMainWnd();
	ASSERT_KINDOF(CMainFrame,pMainWnd);
	pDoc=(CFreePcbDoc *)pMainWnd->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);
//	pView=(CFreePcbView *)pMainWnd->GetActiveView();
//	ASSERT_KINDOF(CFreePcbView,pView);

	CDlgEditNet dlg;
	dlg.Initialize( &nl, -1, m_plist, TRUE, TRUE,
						MIL, &pDoc->m_w, &pDoc->m_v_w, &pDoc->m_v_h_w );
	// invoke dialog
	int ret = dlg.DoModal();
	if( ret == IDOK )
	{
		// net added, update m_wndListCtrl
		DrawListCtrl();
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedOk()
{
	OnOK();
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedButtonSelectAll()
{
	for( int i=0; i<::nl.GetSize(); i++ )
		m_wndListCtrl.SetItemState( i, LVIS_SELECTED, LVIS_SELECTED );
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedButtonDelete()
{
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel == 0 )
	{
		AfxMessageBox(_T("You have no net(s) selected"));
	}
	else
	{
		// now delete them
		while( m_wndListCtrl.GetSelectedCount() )
		{
			POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
			int i_sel = m_wndListCtrl.GetNextSelectedItem( pos );
			int i = m_wndListCtrl.GetItemData( i_sel );
			::nl[i].deleted = TRUE;
			m_wndListCtrl.DeleteItem( i_sel );
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedButtonNLWidth()
{
	CString str;
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel == 0 )
	{
		AfxMessageBox(_T("You have no net(s) selected"));
		return;
	}
	CMainFrame		*pMainWnd=NULL;
	CFreePcbDoc		*pDoc=NULL;
//	CFreePcbView	*pView=NULL;

	pMainWnd=(CMainFrame *)AfxGetMainWnd();
	ASSERT_KINDOF(CMainFrame,pMainWnd);
	pDoc=(CFreePcbDoc *)pMainWnd->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);
//	pView=(CFreePcbView *)pMainWnd->GetActiveView();
//	ASSERT_KINDOF(CFreePcbView,pView);

	CDlgSetTraceWidths dlg;
	dlg.m_w = &pDoc->m_w;
	dlg.m_v_w = &pDoc->m_v_w;
	dlg.m_v_h_w = &pDoc->m_v_h_w;
	dlg.m_width = 0;
	dlg.m_via_width = 0;
	dlg.m_hole_width = 0;
	if( n_sel == 1 )
	{
		POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
		int iItem = m_wndListCtrl.GetNextSelectedItem( pos );
		int i = m_wndListCtrl.GetItemData( iItem );
		dlg.m_width = ::nl[i].w;
		dlg.m_via_width = ::nl[i].v_w;
		dlg.m_hole_width = ::nl[i].v_h_w;
	}
	int ret = dlg.DoModal();
	if( ret == IDOK )
	{
		POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
		while( pos )
		{
			int iItem = m_wndListCtrl.GetNextSelectedItem( pos );
			int i = m_wndListCtrl.GetItemData( iItem );
			if( dlg.m_width != -1 )
				::nl[i].w = dlg.m_width;
			if( dlg.m_via_width != -1 )
			{
				::nl[i].v_w = dlg.m_via_width;
				::nl[i].v_h_w = dlg.m_hole_width;
			}
			::nl[i].apply_trace_width = dlg.m_apply_trace;
			::nl[i].apply_via_width = dlg.m_apply_via;
			str.Format(_T("%d"), ::nl[i].w/NM_PER_MIL );
			m_wndListCtrl.SetItem( iItem, COL_WIDTH, LVIF_TEXT, str, 0, 0, 0, 0 );
			str.Format(_T("%d"), ::nl[i].v_w/NM_PER_MIL );
			m_wndListCtrl.SetItem( iItem, COL_VIA_W, LVIF_TEXT, str, 0, 0, 0, 0 );
			str.Format(_T("%d"), ::nl[i].v_h_w/NM_PER_MIL );
			m_wndListCtrl.SetItem( iItem, COL_HOLE_W, LVIF_TEXT, str, 0, 0, 0, 0 );
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnBnClickedDeleteNetsWithNoPins()
{
	for( int iItem=m_wndListCtrl.GetItemCount()-1; iItem>=0; iItem-- )
	{
		int i_net = m_wndListCtrl.GetItemData( iItem );
		if( ::nl[i_net].ref_des.GetSize() == 0 )
		{
			::nl[i_net].deleted = TRUE;
			m_wndListCtrl.DeleteItem( iItem );
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgNetlist::OnNMClickListNet(NMHDR *pNMHDR, LRESULT *pResult)
{
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel == 0 )
	{
		m_wndPushBtn_edit.EnableWindow(FALSE);
		m_wndPushBtn_delete_single.EnableWindow(FALSE);
		m_wndPushBtn_nl_width.EnableWindow(FALSE);
		m_wndPushBtn_delete.EnableWindow(FALSE);
	}
	else if( n_sel == 1 )
	{
		m_wndPushBtn_edit.EnableWindow(TRUE);
		m_wndPushBtn_delete_single.EnableWindow(TRUE);
		m_wndPushBtn_nl_width.EnableWindow(FALSE);
		m_wndPushBtn_delete.EnableWindow(FALSE);
	}
	else
	{
		m_wndPushBtn_edit.EnableWindow(FALSE);
		m_wndPushBtn_delete_single.EnableWindow(FALSE);
		m_wndPushBtn_nl_width.EnableWindow(TRUE);
		m_wndPushBtn_delete.EnableWindow(TRUE);
	}
	*pResult = 0;
}

