// DlgPartlist.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgPartlist.h"
#include "DlgAddPart.h"

//global partlist_info so that sorting callbacks will work
partlist_info pl;

// columns for list
enum
{
	 COL_VIS = 0						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_NAME							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_PACKAGE						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_FOOTPRINT						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,COL_VALUE							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

// sort types
enum
{
	 SORT_UP_NAME = 0					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_NAME						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_PACKAGE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_PACKAGE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_FOOTPRINT					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_FOOTPRINT				/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_UP_VALUE						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,SORT_DOWN_VALUE					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

// global callback function for sorting
// lp1, lp2 are indexes to global arrays above
//		
int CALLBACK ComparePartlist( LPARAM lp1, LPARAM lp2, LPARAM type )
{
	int ret = 0;
	switch( type )
	{
		case SORT_UP_NAME:
		case SORT_DOWN_NAME:
			ret = (_tcscmp( ::pl[lp1].ref_des, ::pl[lp2].ref_des ));
			break;

		case SORT_UP_PACKAGE:
		case SORT_DOWN_PACKAGE:
			ret = (_tcscmp( ::pl[lp1].package, ::pl[lp2].package ));
			break;

		case SORT_UP_FOOTPRINT:
		case SORT_DOWN_FOOTPRINT:
			if( ::pl[lp1].shape && ::pl[lp2].shape )
				ret = (_tcscmp( ::pl[lp1].shape->m_name, ::pl[lp2].shape->m_name ));
			else
				ret = 0;
			break;

		case SORT_UP_VALUE:
		case SORT_DOWN_VALUE:
			ret = (_tcscmp( ::pl[lp1].value, ::pl[lp2].value ));
			break;

	}
	switch( type )
	{
		case SORT_DOWN_NAME:
		case SORT_DOWN_PACKAGE:
		case SORT_DOWN_FOOTPRINT:
		case SORT_DOWN_VALUE:
			ret = -ret;
			break;
	}
	return ret;
}

// CDlgPartlist dialog

IMPLEMENT_DYNAMIC(CDlgPartlist, CDialog)

/*=============================================================================
					CDlgPartlist NX̍\z
=============================================================================*/

CDlgPartlist::CDlgPartlist(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPartlist::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPartlist)
	//}}AFX_DATA_INIT
}

/*=============================================================================
					CDlgPartlist NX̏
=============================================================================*/

CDlgPartlist::~CDlgPartlist()
{
}

/*=============================================================================
			CDlgPartlist _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgPartlist::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPartlist)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_LIST1, m_wndListCtrl);
	DDX_Control(pDX, IDC_BUTTON_ADD, m_wndPushBtn_add);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_wndPushBtn_edit);
	DDX_Control(pDX, IDC_BUTTON_DELETE, m_wndPushBtn_delete);
	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		// leaving, get value_vis checkbox states
		for (int iItem=0; iItem<m_wndListCtrl.GetItemCount(); iItem++ )
		{
			int ip = m_wndListCtrl.GetItemData( iItem );
			BOOL iTest = ListView_GetCheckState( m_wndListCtrl, iItem );
			::pl[ip].value_vis = ListView_GetCheckState( m_wndListCtrl, iItem );
		}
		m_plist->ImportPartListInfo( &::pl, 0 );
	}
	DDX_Control(pDX, IDC_CHECK1, m_wndCheckBtn_footprint);
	DDX_Control(pDX, IDC_CHECK2, m_wndCheckBtn_package);
	DDX_Control(pDX, IDC_CHECK3, m_wndCheckBtn_value);
}

/*=============================================================================
					CDlgPartlist NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgPartlist, CDialog)
	//{{AFX_MSG_MAP(CDlgPartlist)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnBnClickedButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnBnClickedButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnBnClickedButtonDelete)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST1, OnLvnColumnClickList1)
	ON_BN_CLICKED(IDC_BUTTON_VAL_VIS, OnBnClickedValueVisible)
	ON_BN_CLICKED(IDC_BUTTON_VAL_INVIS, OnBnClickedValueInvisible)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, OnNMClickList1)
END_MESSAGE_MAP()

/*=============================================================================
					CDlgPartlist _CAȌ
=============================================================================*/

BOOL	CDlgPartlist::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_plist->ExportPartListInfo( &::pl, NULL );
	m_sort_type = SORT_UP_NAME;
	DrawListCtrl();
	m_wndCheckBtn_footprint.EnableWindow(0);
	m_wndCheckBtn_package.EnableWindow(0);
	m_wndCheckBtn_value.EnableWindow(0);
	return TRUE;
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::DrawListCtrl()
{
	// now set up listview control
	int nItem;
	LVITEM lvitem;
	CString str;
	DWORD old_style = m_wndListCtrl.GetExtendedStyle();
	m_wndListCtrl.SetExtendedStyle( LVS_EX_FULLROWSELECT | LVS_EX_FLATSB | LVS_EX_CHECKBOXES | old_style );
	m_wndListCtrl.DeleteAllItems();
	m_wndListCtrl.InsertColumn( COL_VIS		,_T("Value Vis"), LVCFMT_LEFT, 60 );
	m_wndListCtrl.InsertColumn( COL_NAME		,_T("Reference"), LVCFMT_LEFT, 70 );
	m_wndListCtrl.InsertColumn( COL_PACKAGE	,_T("Package")	, LVCFMT_LEFT, 150 );
	m_wndListCtrl.InsertColumn( COL_FOOTPRINT	,_T("Footprint"), LVCFMT_LEFT, 150 );
	m_wndListCtrl.InsertColumn( COL_VALUE		,_T("Value")	, LVCFMT_LEFT, 200 );
	for( int i=0; i<::pl.GetSize(); i++ )
	{
		lvitem.mask = LVIF_TEXT | LVIF_PARAM;
		lvitem.pszText = _T("");
		lvitem.lParam = i;
		nItem = m_wndListCtrl.InsertItem( i, _T(""));
		m_wndListCtrl.SetItemData( i, (LPARAM)i );
		ListView_SetCheckState( m_wndListCtrl, nItem, ::pl[i].value_vis );
		m_wndListCtrl.SetItem( i, COL_NAME, LVIF_TEXT, ::pl[i].ref_des, 0, 0, 0, 0 );
		m_wndListCtrl.SetItem( i, COL_PACKAGE, LVIF_TEXT, ::pl[i].package, 0, 0, 0, 0 );
		if( ::pl[i].shape )
			m_wndListCtrl.SetItem( i, COL_FOOTPRINT, LVIF_TEXT, ::pl[i].shape->m_name, 0, 0, 0, 0 );
		else
			m_wndListCtrl.SetItem( i, COL_FOOTPRINT, LVIF_TEXT, _T(""), 0, 0, 0, 0 );
		m_wndListCtrl.SetItem( i, COL_VALUE, LVIF_TEXT, ::pl[i].value, 0, 0, 0, 0 );
	}
	m_wndListCtrl.SortItems( ::ComparePartlist, m_sort_type );	// resort 
	RestoreSelections();
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::Initialize(CPartList *plist							/**< ToDo:Add Comment for Doxygen			*/
							 ,CMapStringToPtr *shape_cache_map				/**< ToDo:Add Comment for Doxygen			*/
							 ,CFootLibFolderMap *footlibfoldermap			/**< ToDo:Add Comment for Doxygen			*/
							 ,int units										/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_units = units;
	m_plist = plist;
	m_footprint_cache_map = shape_cache_map;
	m_footlibfoldermap = footlibfoldermap;
	m_sort_type = SORT_UP_NAME;
}

// CDlgPartlist message handlers

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::OnBnClickedButtonEdit()
{
	SaveSelections();
	// save value_vis checkbox states
	for (int Item=0; Item<m_wndListCtrl.GetItemCount(); Item++ )
	{
		int ip = m_wndListCtrl.GetItemData( Item );
		::pl[ip].value_vis = ListView_GetCheckState( m_wndListCtrl, Item );
	}
	// edit selected part(s)
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel == 0 )
		AfxMessageBox(_T("You have no part selected"));
	BOOL bMultiple = FALSE;
	if( n_sel > 1 )
		bMultiple = TRUE;

	POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition(); 
	if (pos == NULL)
		ASSERT(FALSE);
	int iItem = m_wndListCtrl.GetNextSelectedItem(pos);
	int i = m_wndListCtrl.GetItemData( iItem );
	CDlgAddPart dlg;
	int multiple_mask = MSK_FOOTPRINT * m_wndCheckBtn_footprint.GetCheck()
					+ MSK_PACKAGE * m_wndCheckBtn_package.GetCheck()
					+ MSK_VALUE * m_wndCheckBtn_value.GetCheck(); 
	if( bMultiple && multiple_mask == 0 )
	{
		AfxMessageBox(_T("To edit multiple parts, please select Footprint, Package or Value"));
		return;
	}
	dlg.Initialize(&::pl
				  ,i
				  ,FALSE
				  ,FALSE
				  ,bMultiple
				  ,multiple_mask
				  ,m_footprint_cache_map
				  ,m_footlibfoldermap
				  ,m_units);
	int ret = dlg.DoModal();
	if( ret == IDOK )
	{
		CString str;
		if( bMultiple )
		{
			// update all selected parts with new package and footprint
			POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
			while( pos )
			{
				int iItem = m_wndListCtrl.GetNextSelectedItem(pos);
				int ip = m_wndListCtrl.GetItemData( iItem );
				if( ip != i )
				{
					if( multiple_mask & MSK_FOOTPRINT )
					{
						::pl[ip].shape = ::pl[i].shape;
						::pl[ip].ref_size = ::pl[i].ref_size;
						::pl[ip].ref_width = ::pl[i].ref_width;
					}
					if( multiple_mask & MSK_PACKAGE )
						::pl[ip].package = ::pl[i].package;
					if( multiple_mask & MSK_VALUE )
						::pl[ip].value = ::pl[i].value;
				}
			}
		}
		DrawListCtrl();
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::OnBnClickedButtonAdd()
{
	SaveSelections();
	// save value_vis checkbox states
	for (int Item=0; Item<m_wndListCtrl.GetItemCount(); Item++ )
	{
		int ip = m_wndListCtrl.GetItemData( Item );
		::pl[ip].value_vis = ListView_GetCheckState( m_wndListCtrl, Item );
	}
	// now add part
	CDlgAddPart dlg;
	dlg.Initialize(&::pl
				  ,-1
				  ,FALSE
				  ,TRUE
				  ,FALSE
				  ,0
				  ,m_footprint_cache_map
				  ,m_footlibfoldermap
				  ,m_units);
	int ret = dlg.DoModal();
	if( ret == IDOK )
	{
		DrawListCtrl();
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::OnBnClickedButtonDelete()
{
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel == 0 )
		AfxMessageBox(_T("You have no part selected"));
	else
	{
		while( m_wndListCtrl.GetSelectedCount() )
		{
			POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
			if (pos == NULL)
				ASSERT(FALSE);
			int iItem = m_wndListCtrl.GetNextSelectedItem(pos);
			int ip = m_wndListCtrl.GetItemData( iItem );
			::pl[ip].deleted = TRUE;
			m_wndListCtrl.DeleteItem( iItem );
		}
	}
}

/*=============================================================================

=============================================================================*/
// set m_sort_type based on column clicked and last sort, 
// then sort the list, then save m_last_sort_type = m_sort_type
//
void	CDlgPartlist::OnLvnColumnClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	int column = pNMLV->iSubItem;
	if( column == COL_NAME )
	{
		if( m_sort_type == SORT_UP_NAME )
			m_sort_type = SORT_DOWN_NAME;
		else
			m_sort_type = SORT_UP_NAME;
		m_wndListCtrl.SortItems( ::ComparePartlist, m_sort_type );
	}
	else if( column == COL_PACKAGE )
	{
		if( m_sort_type == SORT_UP_PACKAGE )
			m_sort_type = SORT_DOWN_PACKAGE;
		else
			m_sort_type = SORT_UP_PACKAGE;
		m_wndListCtrl.SortItems( ::ComparePartlist, m_sort_type );
	}
	else if( column == COL_FOOTPRINT )
	{
		if( m_sort_type == SORT_UP_FOOTPRINT )
			m_sort_type = SORT_DOWN_FOOTPRINT;
		else
			m_sort_type = SORT_UP_FOOTPRINT;
		m_wndListCtrl.SortItems( ::ComparePartlist, m_sort_type );
	}
	else if( column == COL_VALUE )
	{
		if( m_sort_type == SORT_UP_VALUE )
			m_sort_type = SORT_DOWN_VALUE;
		else
			m_sort_type = SORT_UP_VALUE;
		m_wndListCtrl.SortItems( ::ComparePartlist, m_sort_type );
	}
	*pResult = 0;
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::OnBnClickedValueVisible()
{
	SaveSelections();
	POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition();
	while( pos )
	{
		int iItem = m_wndListCtrl.GetNextSelectedItem(pos);
		int ip = m_wndListCtrl.GetItemData( iItem );
		::pl[ip].value_vis = TRUE;
	}
	DrawListCtrl();
	RestoreSelections();
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::OnBnClickedValueInvisible()
{
	SaveSelections();
	POSITION pos = m_wndListCtrl.GetFirstSelectedItemPosition(); 
	while( pos )
	{
		int iItem = m_wndListCtrl.GetNextSelectedItem(pos);
		int ip = m_wndListCtrl.GetItemData( iItem );
		::pl[ip].value_vis = FALSE;
	}
	DrawListCtrl();
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	static int last_n_sel = 0;
	int n_sel = m_wndListCtrl.GetSelectedCount();
	if( n_sel != last_n_sel )
	{
		m_wndCheckBtn_footprint.EnableWindow( n_sel > 1 );
		m_wndCheckBtn_package.EnableWindow( n_sel > 1 );
		m_wndCheckBtn_value.EnableWindow( n_sel > 1 );
	}
	last_n_sel = n_sel;
	*pResult = 0;
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::SaveSelections()
{
	int nItems = m_wndListCtrl.GetItemCount();
	bSelected.SetSize( ::pl.GetSize() );
	for( int iItem=0; iItem<nItems; iItem++ )
	{
		int ip = m_wndListCtrl.GetItemData( iItem );
		if( m_wndListCtrl.GetItemState( iItem, LVIS_SELECTED ) == LVIS_SELECTED )
			bSelected[ip] = TRUE;
		else
			bSelected[ip] = FALSE;
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgPartlist::RestoreSelections()
{

	int nItems = m_wndListCtrl.GetItemCount();
	for( int iItem=0; iItem<nItems; iItem++ )
	{
		int ip = m_wndListCtrl.GetItemData( iItem );
		if( ip < bSelected.GetSize() )
			if( bSelected[ip] == TRUE )
				m_wndListCtrl.SetItemState( iItem, LVIS_SELECTED, LVIS_SELECTED );
	}
	bSelected.SetSize(0);
}

