#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include <afxcoll.h>
#include <afxtempl.h>


// CDlgProjectOptions dialog

/*=============================================================================
				CDlgProjectOptions _CAO NX̐錾
=============================================================================*/

class CDlgProjectOptions : public CDialog
{
	DECLARE_DYNAMIC(CDlgProjectOptions)
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
public:
	CDlgProjectOptions(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgProjectOptions();
	void	Init(BOOL new_flag,
				CString * name,
				CString * path_to_folder,
				CString * lib_folder,
				int num_layers,
				BOOL bSMT_connect_copper,
				int glue_w,
				int trace_w,
				int via_w,
				int hole_w,
				int auto_interval,
				BOOL bAuto_Ratline_Disable,
				int auto_ratline_min_pins,
				CArray<int> * w,
				CArray<int> * v_w,
				CArray<int> * v_h_w );
	CString GetName() const				{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_name; };
	CString GetPathToFolder() const		{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_path_to_folder; };
	CString GetLibFolder() const		{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_lib_folder; };
	int GetNumCopperLayers() const		{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_layers; };
	int GetTraceWidth() const			{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_trace_w; };
	int GetViaWidth() const				{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_via_w; };
	int GetViaHoleWidth() const			{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_hole_w; };
	int GetAutoInterval() const			{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_auto_interval; };
	int GetGlueWidth() const			{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_glue_w; };
	int GetAutoRatlineDisable() const	{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_bAuto_Ratline_Disable; };
	int GetAutoRatlineMinPins() const	{ ASSERT_KINDOF(CDlgProjectOptions,this); return m_auto_ratline_min_pins; };
//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CDlgProjectOptions)
	enum { IDD = IDD_PROJECT_OPTIONS };
	//}}AFX_DATA
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CDlgProjectOptions)
private:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
//--------------------------------------
// _CAO f[^(ϐ)
//--------------------------------------
public:
	BOOL		m_new_project;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_folder_changed;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_folder_has_focus;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_name;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_path_to_folder;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CString		m_lib_folder;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_glue_w;
	int			m_trace_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_via_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_hole_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_auto_interval;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_bAuto_Ratline_Disable;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_auto_ratline_min_pins;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CListCtrl	m_list_menu;						/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<int> *m_w;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<int> *m_v_w;								/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CArray<int> *m_v_h_w;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	int			m_layers;							/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	BOOL		m_bSMT_connect_copper;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
private:
	CEdit		m_wndEditCtrl_name;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_folder;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_lib_folder;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_layers;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_autosave;				/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_wndEditCtrl_auto_interval;		/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_wndCheckBtn_SMT_connect;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CButton		m_check_disable_auto_rats;			/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
	CEdit		m_edit_min_pins;					/**< ToDo:Describe short comment, about this member variable for Doxygen			*/
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
protected:
	//{{AFX_MSG(CDlgProjectOptions)
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedButtonAdd();
	afx_msg void OnBnClickedButtonEdit();
	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnEnChangeEditName();
	afx_msg void OnEnChangeEditFolder();
	afx_msg void OnBnClickedCheckAutosave();
	afx_msg void OnBnClickedButtonLib();
	afx_msg void OnEnSetfocusEditFolder();
	afx_msg void OnEnKillfocusEditFolder();
	afx_msg void OnBnClickedCheckAutoRatDisable();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of DlgProjectOptions.h
-----------------------------------------------------------------------------*/
