// DlgReassignLayers.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgReassignLayers.h"


// CDlgReassignLayers dialog

IMPLEMENT_DYNAMIC(CDlgReassignLayers, CDialog)

/*=============================================================================
					CDlgReassignLayers NX̍\z
=============================================================================*/

CDlgReassignLayers::CDlgReassignLayers(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgReassignLayers::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgReassignLayers)
	//}}AFX_DATA_INIT
}

/*=============================================================================
					CDlgReassignLayers NX̏
=============================================================================*/

CDlgReassignLayers::~CDlgReassignLayers()
{
}

/*=============================================================================
			CDlgReassignLayers _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgReassignLayers::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgReassignLayers)
	//}}AFX_DATA_MAP

	INT		nLayerPos;

	for(nLayerPos=0;nLayerPos<INNER_LAYER_COUNT;nLayerPos++)
		DDX_Control(pDX, IDC_COMBO1+nLayerPos, m_combo[nLayerPos]);

	if(pDX->m_bSaveAndValidate)				/* Rg[ϐ֒l擾	*/
	{
		// outgoing, create layer translation table
		for( int il=0; il<m_old_layers; il++ )
		{
			int sel = m_combo[il].GetCurSel();
			if( sel >= m_new_layers )
				sel = -1;
			new_layer[il] = sel;
		}
	}
	else									/* ϐRg[	*/
	{
		// incoming
		// set up combo boxes, loop through all possible copper layers
		for( int il=0; il<INNER_LAYER_COUNT; il++ ) 
		{
			if( il < m_old_layers )
			{
				// old layer, set combo box to pick from new layers or "delete"
				m_combo[il].EnableWindow( TRUE );
				for( int inew=0; inew<m_new_layers; inew++ )
					m_combo[il].InsertString( inew, CFreePcbApp::GetBoardLayerName(LAY_TOP_COPPER+inew));
				m_combo[il].InsertString( m_new_layers,_T("delete"));
				// initialize combo box to old layer, or delete if old layer > new layers
				if( il < m_new_layers )
					m_combo[il].SetCurSel(il);
				else
					m_combo[il].SetCurSel( m_new_layers );
			}
			else
				// this isn't an old layer, disable combo box
				m_combo[il].EnableWindow( FALSE );
		}
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgReassignLayers::Initialize(int num_old_layers			/**< ToDo:Add Comment for Doxygen			*/
									  ,int num_new_layers			/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_old_layers = num_old_layers;
	m_new_layers = num_new_layers;
}

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgReassignLayers, CDialog)
	//{{AFX_MSG_MAP(CDlgReassignLayers)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDlgReassignLayers message handlers
