// DlgSaveFootprint.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "DlgSaveFootprint.h"
#include "PathDialog.h"

// globals
CString gLastFolderName;	// folder of last footprint imported or saved
CString gLastFileName;		// file name of last footprint imported or saved

// CDlgSaveFootprint dialog

IMPLEMENT_DYNAMIC(CDlgSaveFootprint, CDialog)

/*=============================================================================
					CDlgSaveFootprint NX̍\z
=============================================================================*/

CDlgSaveFootprint::CDlgSaveFootprint(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSaveFootprint::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSaveFootprint)
	//}}AFX_DATA_INIT
}

/*=============================================================================
					CDlgSaveFootprint NX̏
=============================================================================*/

CDlgSaveFootprint::~CDlgSaveFootprint()
{
}

/*=============================================================================
			CDlgSaveFootprint _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgSaveFootprint::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSaveFootprint)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_PREVIEW2, m_preview);
	DDX_Control(pDX, IDC_EDIT_SAVE_NAME, m_wndEditCtrl_name);
	DDX_Control(pDX, IDC_COMBO_LIBS, m_wndComboBox_lib);
	DDX_Control(pDX, IDC_EDIT_AUTHOR, m_wndEditCtrl_author);
	DDX_Control(pDX, IDC_EDIT_SOURCE, m_wndEditCtrl_source);
	DDX_Control(pDX, IDC_EDIT_DESC, m_wndEditCtrl_desc);
	DDX_Control(pDX, IDC_EDIT_FP_SAVE_FOLDER, m_wndEditCtrl_folder);
	DDX_Control(pDX, IDC_STATIC_UNITS, m_static_units);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// incoming
		// draw preview of footprint
		CMetaFileDC m_mfDC;
		CDC * pDC = this->GetDC();
		CRect rw;
		m_preview.GetClientRect( &rw );
		int x_size = rw.right - rw.left;
		int y_size = rw.bottom - rw.top;
		HENHMETAFILE hMF = m_footprint->CreateMetafile( &m_mfDC, pDC, x_size, y_size );
		m_preview.SetEnhMetaFile( hMF );
		ReleaseDC( pDC );
		// initialize other fields
		if( m_units == MM )  
			m_static_units.SetWindowText(_T(" mm"));
		else
			m_static_units.SetWindowText(_T(" mil"));
		m_wndEditCtrl_name.SetWindowText( m_name );
		m_wndEditCtrl_author.SetWindowText( m_footprint->m_author );
		m_wndEditCtrl_source.SetWindowText( m_footprint->m_source );
		m_wndEditCtrl_desc.SetWindowText( m_footprint->m_desc );
		// insert all library file names
		CString		def_lib=m_foldermap->GetLastFolder();
		if(def_lib.IsEmpty())
			def_lib=m_foldermap->GetDefaultFolder();
		m_folder = m_foldermap->GetFolder(def_lib);
		m_wndEditCtrl_folder.SetWindowText(def_lib);
		InitFileList();
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgSaveFootprint::Initialize(CString * name							/**< ToDo:Add Comment for Doxygen			*/
									 ,CShape * footprint						/**< ToDo:Add Comment for Doxygen			*/						 
									 ,int units									/**< ToDo:Add Comment for Doxygen			*/
									 ,LPCTSTR default_file_name					/**< ToDo:									*/
									 ,CMapStringToPtr * shape_cache_map			/**< ToDo:Add Comment for Doxygen			*/
									 ,CFootLibFolderMap * footlibfoldermap		/**< ToDo:									*/ )
//									 ,CDlgLog * log								/**< ToDo:Add Comment for Doxygen			*/ )
{
	CString			last_folder_str;

	m_name = *name;
	m_units = units;
	if( default_file_name != _T(""))
		m_default_filename = default_file_name;
	else
		m_default_filename = gLastFileName;
	m_footprint = footprint;
	m_footprint_cache_map = shape_cache_map;
	m_foldermap = footlibfoldermap;

	last_folder_str=footlibfoldermap->GetLastFolder();
	m_folder = footlibfoldermap->GetFolder(last_folder_str);
}

/*=============================================================================
					CDlgSaveFootprint NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgSaveFootprint, CDialog)
	//{{AFX_MSG_MAP(CDlgSaveFootprint)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_LIBS, OnCbnSelchangeComboLibs)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_FP_BROWSE, OnBnClickedButtonBrowse)
END_MESSAGE_MAP()


// CDlgSaveFootprint message handlers

/*=============================================================================

=============================================================================*/

void	CDlgSaveFootprint::OnCbnSelchangeComboLibs()
{
	int ilib = m_wndComboBox_lib.GetCurSel();
}

/*=============================================================================

=============================================================================*/

void	CDlgSaveFootprint::OnBnClickedOk()
{
	CDlgLog		*pLogDialog;

	pLogDialog=((CMainFrame *)AfxGetMainWnd())->GetLogDialog();
	ASSERT(pLogDialog);

	// update name and other strings
	// check folder name
	m_wndEditCtrl_folder.GetWindowText( m_folder_name );
	if( *m_folder->GetFullPath() != m_folder_name )
	{
		// folder was changed without browsing, regenerate library
		int ret = _tchdir( m_folder_name );
		if( ret == -1 )
		{
			// folder doesn't exist
			CString mess = _T("Folder \"") + m_folder_name + _T("\" doesn't exist\n");
			mess += "Create it ?";
			ret = AfxMessageBox( mess, MB_YESNO );
			if( ret == IDNO )
				return;
			// create it
			ret = _tmkdir( m_folder_name );
			if( ret == -1 )
			{
				// can't create folder
				CString mess = _T("Unable to create folder \"");
				mess += m_folder_name;
				AfxMessageBox( mess );
				return;
			}
		}
		// index folder
		CFootLibFolder * new_folder = new CFootLibFolder;
		CString mess;
		mess.Format(_T("Indexing library folder \"%s\"\r\n"), m_folder_name );
		pLogDialog->AddLine( mess );
		new_folder->IndexAllLibs( &m_folder_name, pLogDialog );
		pLogDialog->AddLine(_T("\r\n"));
		m_foldermap->AddFolder(m_folder_name, new_folder );
		m_folder = m_foldermap->GetFolder(m_folder_name);			// , pLogDialog );
		m_foldermap->SetLastFolder(m_folder_name);
		InitFileList();
	}
	m_wndEditCtrl_name.GetWindowText( m_name );
	m_name.Replace(_T('\"'),_T('\''));			// replace any " with '
	if( m_name.GetLength() > CShape::MAX_NAME_SIZE )
	{
		CString mess;
		mess.Format(_T("Name too long, can't exceed %d characters"),
			CShape::MAX_NAME_SIZE );
		AfxMessageBox( mess );
		return;
	}
	m_footprint->m_units = m_units;
	m_footprint->m_name = m_name;
	m_wndEditCtrl_author.GetWindowText( m_author );
	m_author.Replace(_T('\"'),_T('\''));
	m_footprint->m_author = m_author.Trim();
	m_wndEditCtrl_source.GetWindowText( m_source );
	m_source.Replace(_T('\"'),_T('\''));
	m_footprint->m_source = m_source.Trim();
	m_wndEditCtrl_desc.GetWindowText( m_desc );
	m_desc.Replace(_T('\"'),_T('\''));
	m_footprint->m_desc = m_desc.Trim();

	// get footprint name, file name
	CString file_name;
	m_wndComboBox_lib.GetWindowText( file_name );
	CString file_path = *m_folder->GetFullPath() + _T("\\") + file_name;

	// save file name and folder
	gLastFileName = file_name;
	gLastFolderName = *m_folder->GetFullPath();

	// now check for duplication of existing footprint
	int ilib;
	int offset;
	int ifootprint;
	int next_offset;
	CString fn;
	BOOL footprint_exists = m_folder->GetFootprintInfo( &m_name, &file_path,
		&ilib, &ifootprint, &fn, &offset, &next_offset );
	BOOL same_file = ( fn == file_path );
	BOOL replace = FALSE;
	if( footprint_exists && same_file )
	{
		// footprint name already exists in this file
		CString mess;
		mess.Format(_T("Footprint \"%s\" already exists in file \"%s\"\nOverwrite ?"),
			m_name, fn );
		int ret = AfxMessageBox( mess, MB_OKCANCEL );
		if( ret == IDOK )
		{
			replace = TRUE;
		}
		else
			return;
	}
	else if( footprint_exists && !same_file )
	{
		// footprint name already exists in another file
		CString mess;
		mess.Format(_T("Footprint \"%s\" already exists in another library file \"%s\"\nDo you want to change the name?"),
			m_name, fn );
		int ret = AfxMessageBox( mess, MB_YESNO );
		if( ret == IDYES )
		{
			return;
		}
	}
	// OK, save it

	BOOL file_exists = ( m_folder->SearchFileName( &file_path ) != -1 );
	if( !file_exists )
	{
		// new library file, create it and write footprint
		CStdioFile f;
		BOOL ok = f.Open( file_path, CFile::modeCreate | CFile::modeWrite );
		if( !ok )
		{
			AfxMessageBox(_T("Unable to open file ")+ file_path );
			return;
		}
		m_footprint->WriteFootprint( &f );
		f.Close();
	}
	else if( file_exists && !replace )
	{
		// existing library file, insert new footprint
		int offset;
		// no heading, insert ahead of first footprint or heading in file
		CStdioFile * fin = new CStdioFile( file_path, CFile::modeRead );
		CStdioFile * fout = new CStdioFile(_T("temp.txt"), CFile::modeCreate | CFile::modeWrite );
		CString in_str;
		BOOL bInserted = FALSE;
		// now loop through all lines in file
		while( fin->ReadString( in_str ) )
		{
			in_str.Trim();
			if( !bInserted && (in_str[0] == _T('[') || in_str.Left(5) == _T("name:")) )
			{
				// insert footprint
				m_footprint->WriteFootprint( fout );
				// now copy last line read from source
				fout->WriteString( in_str + _T("\n"));
				bInserted = TRUE;
			}
			else
			{
				// write line
				fout->WriteString( in_str + _T("\n"));
			}
		}
		delete fin;
		delete fout;
		int err = _tremove( file_path );
		if( err )
		{
			CString str = _T("File system error: Unable to modify library file\n");
			str += _T("File could be read-only or you don't have permission to modify it\n");
			str += _T("The modified file has been saved as \"temp.txt\"");
			AfxMessageBox( str );
			return;
		}
		else
		{
			err = _trename(_T("temp.txt"), file_path );
			if( err )
			{
				CString str = _T("File system error: Unable to modify library file\n");
				str += _T("The original file has been deleted but can't be rewritten\n");
				str += _T("The modified file has been saved as \"temp.txt\"");
				AfxMessageBox( str );
				return;
			}
		}
	}
	else
	{
		// replace existing footprint
		CStdioFile * fin = new CStdioFile( file_path, CFile::modeRead );
		CStdioFile * fout = new CStdioFile(_T("temp.txt"), CFile::modeCreate | CFile::modeWrite );
		CString in_str;
		BOOL bDeleted = FALSE;
		BOOL bInserted = FALSE;
		// now loop through all lines in file
		while( fin->ReadString( in_str ) )
		{
			in_str.Trim();
			if( !bDeleted && fin->GetPosition() <= offset )
			{
				// haven't reached footprint, write line
				fout->WriteString( in_str + _T("\n"));
			}
			else if( !bDeleted && next_offset<0 )
			{
				// reached footprint, this is the last footprint in the file
				bDeleted = TRUE;
			}
			else if( !bDeleted && fin->GetPosition() < next_offset )
			{
				// reached footprint, skip lines to next footprint
			}
			else if( !bInserted )
			{
				// we have deleted the original footprint, insert replacement
				bDeleted = TRUE;
				m_footprint->WriteFootprint( fout );
				// if this was the last footprint in the file, we are done
				if( next_offset < 0 )
					break;
				// otherwise, copy last line read from source
				fout->WriteString( in_str + _T("\n"));
				bInserted = TRUE;
			}
			else
			{
				// finished inserting, this was no the last footprint
				// copy subsequent lines
				fout->WriteString( in_str + _T("\n"));
			}
		}
		delete fin;
		delete fout;
		int err = _tremove( file_path );
		if( err )
		{
			CString str = _T("File system error: Unable to modify library file\n");
			str += _T("File could be read-only or you don't have permission to modify it\n");
			str += _T("The modified file has been saved as \"temp.txt\"");
			AfxMessageBox( str );
			return;
		}
		else
		{
			err = _trename(_T("temp.txt"), file_path );
			if( err )
			{
				CString str = _T("File system error: Unable to modify library file\n");
				str += _T("The original file has been deleted but can't be rewritten\n");
				str += _T("The modified file has been saved as \"temp.txt\"");
				AfxMessageBox( str );
				return;
			}
		}
	}
	// now index the file
	m_folder->IndexLib( &file_name );
	OnOK();
}

/*=============================================================================

=============================================================================*/

void	CDlgSaveFootprint::OnBnClickedButtonBrowse()
{
	CDlgLog		*pLogDialog;

	pLogDialog=((CMainFrame *)AfxGetMainWnd())->GetLogDialog();
	ASSERT(pLogDialog);

	CPathDialog dlg(_T("Open Folder")
				,_T("Select footprint library folder")
				,m_folder->GetFullPath());
	int ret = dlg.DoModal();
	if( ret == IDOK )
	{
		CString path_str = dlg.GetPathName();

		m_wndEditCtrl_folder.SetWindowText( path_str );
		m_folder = m_foldermap->GetFolder(path_str);				// , pLogDialog );
		if( !m_folder )
		{
			CFootLibFolder * new_folder = new CFootLibFolder;
			CString mess;
			mess.Format(_T("Indexing library folder \"%s\"\r\n"), path_str );
			pLogDialog->AddLine( mess );
			new_folder->IndexAllLibs( &path_str, pLogDialog );
			pLogDialog->AddLine(_T("\r\n"));
			m_foldermap->AddFolder(path_str, new_folder );
			m_folder = new_folder;
		}
		m_foldermap->SetLastFolder(path_str);
		InitFileList();
	}
}

/*=============================================================================

=============================================================================*/
// initialize file list, selecting the last file name used
// add "user_created.fpl" and last file name if necessary
// uses global gLastFileName

void	CDlgSaveFootprint::InitFileList()
{
	// insert all library names, checking for last file name and "user_created.fpl"
	m_lib_user = -1;
	m_lib_last = -1;
	CString lib_str;
	TCHAR	file_str[_MAX_FNAME];

	// clear combo box
	while( m_wndComboBox_lib.GetCount() != 0 )
		m_wndComboBox_lib.DeleteString(0);

	// now add library files
	int nlibs = m_folder->GetNumLibs();
	for( int ilib=0; ilib<nlibs; ilib++ )
	{
		lib_str = m_folder->GetLibraryFullPath( ilib );
		_tsplitpath( lib_str, NULL, NULL, file_str, NULL );
		_tcscat( file_str, _T(".fpl"));
		m_wndComboBox_lib.InsertString( -1, file_str );
		if( file_str == gLastFileName )
			m_lib_last = ilib;
		if( file_str == _T("user_created.fpl"))
			m_lib_user = ilib;
	}
	// see if the last file name was found
	if( m_lib_last < 0 && gLastFileName != _T("") )
	{
		// no, add last file name to end of list
		m_wndComboBox_lib.InsertString( -1, gLastFileName );
		m_lib_last = m_folder->GetNumLibs();
		// and select it
		m_wndComboBox_lib.SetCurSel( m_lib_last );
	}
	else if( m_lib_last >= 0 ) 
	{
		// yes, select last file name
		m_wndComboBox_lib.SetCurSel( m_lib_last );
	}
	// see if "user_created.fpl" was found
	if( m_lib_user < 0 )
	{
		// file "user_created.fpl" doesn't exist, add name to end of list
		m_wndComboBox_lib.InsertString( -1, _T("user_created.fpl"));
		m_lib_user = m_folder->GetNumLibs();
	}
	// if no last file name, select user_created.fpl
	if( m_lib_last < 0 )
		m_wndComboBox_lib.SetCurSel( m_lib_user );
}
