// DlgValueText.cpp : implementation file
//

#include "stdafx.h"
#include "FreePcb.h"
#include "PartList.h"
#include "DlgValueText.h"


// CDlgValueText dialog

IMPLEMENT_DYNAMIC(CDlgValueText, CDialog)

/*=============================================================================
						CDlgValueText NX̍\z
=============================================================================*/

CDlgValueText::CDlgValueText(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgValueText::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgValueText)
	//}}AFX_DATA_INIT
}

/*=============================================================================
						CDlgValueText NX̏
=============================================================================*/

CDlgValueText::~CDlgValueText()
{
}

/*=============================================================================
			CDlgValueText _CAOf[^̌ƗL`FbN
=============================================================================*/

void	CDlgValueText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgValueText)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT_REF_ID, m_wndEditCtrl_ref_des);
	DDX_Control(pDX, IDC_EDIT_FOOTPRINT, m_wndEditCtrl_value);
	DDX_Control(pDX, IDC_EDIT_CHAR_HEIGHT, m_wndEditCtrl_height);
	DDX_Control(pDX, IDC_COMBO_REF_TEXT_UNITS, m_wndComboBox_units);
	DDX_Control(pDX, IDC_RADIO_SET, m_wndRadioBtn_set);
	DDX_Control(pDX, IDC_RADIO_DEF, m_wndRadioBtn_def);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_wndEditCtrl_width);
	DDX_Control(pDX, IDC_EDIT_DEF_WIDTH, m_wndEditCtrl_def_width);
	DDX_Control(pDX, IDC_CHECK_VISIBLE, m_wndCheckBtn_visible);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		// entry
		m_wndEditCtrl_ref_des.EnableWindow( FALSE );
		m_wndEditCtrl_ref_des.SetWindowText( m_part->ref_des );
		m_wndEditCtrl_value.EnableWindow( FALSE );
		m_wndEditCtrl_value.SetWindowText( m_part->value );
		m_wndComboBox_units.InsertString( 0,_T("MIL"));
		m_wndComboBox_units.InsertString( 1,_T("MM"));
		if( m_units == MIL )
			m_wndComboBox_units.SetCurSel( 0 );
		else
			m_wndComboBox_units.SetCurSel( 1 );
		if( m_width == m_height/10 )
		{
			m_wndRadioBtn_set.SetCheck( FALSE );
			m_wndRadioBtn_def.SetCheck( TRUE );
			m_wndEditCtrl_def_width.EnableWindow( FALSE );
			m_wndEditCtrl_width.EnableWindow( FALSE );
		}
		else
		{
			m_wndRadioBtn_set.SetCheck( TRUE );
			m_wndRadioBtn_def.SetCheck( FALSE );
			m_wndEditCtrl_def_width.EnableWindow( FALSE );
			m_wndEditCtrl_width.EnableWindow( TRUE );
		}
		SetFields();
	}
	else
	{
		// exit
		GetFields();
		if( m_wndRadioBtn_def.GetCheck() )
			m_width = m_def_width;
	}
}

/*=============================================================================

=============================================================================*/

// the calling program should call this to set up dialog
// and provide pointers to variables which will be modified
//
void	CDlgValueText::Initialize(CPartList * plist			/**< ToDo:Add Comment for Doxygen			*/
								 ,cpart * part				/**< ToDo:Add Comment for Doxygen			*/ )
{
	m_plist = plist;
	m_part = part;
	m_vis = part->m_value_vis;
	m_units = part->shape->m_units;
	m_width = m_part->m_value_w;
	m_height = m_part->m_value_size;
	m_def_width = m_height/10;
}

/*=============================================================================
					CDlgValueText NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CDlgValueText, CDialog)
	//{{AFX_MSG_MAP(CDlgValueText)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_SET, OnBnClickedRadioSet)
	ON_EN_CHANGE(IDC_EDIT_CHAR_HEIGHT, OnEnChangeEditCharHeight)
	ON_BN_CLICKED(IDC_RADIO_DEF, OnBnClickedRadioDef)
	ON_CBN_SELCHANGE(IDC_COMBO_REF_TEXT_UNITS, OnCbnSelchangeComboRefTextUnits)
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

// CDlgValueText message handlers

void	CDlgValueText::OnBnClickedRadioSet()
{
	m_wndEditCtrl_width.EnableWindow( TRUE );
}

/*=============================================================================

=============================================================================*/

void	CDlgValueText::OnBnClickedRadioDef()
{
	m_wndEditCtrl_width.EnableWindow( FALSE );

}

/*=============================================================================

=============================================================================*/

void	CDlgValueText::OnEnChangeEditCharHeight()
{
	CString str;
	m_wndEditCtrl_height.GetWindowText( str );
	if( m_units == MIL )
		m_height = _tstof( str ) * NM_PER_MIL;
	else
		m_height = _tstof( str ) * 1000000.0;
	m_def_width = m_height/10;
	if( m_def_width < 1*NM_PER_MIL )
		m_def_width = 1*NM_PER_MIL;
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_def_width/NM_PER_MIL );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_def_width/1000000.0 );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
}

/*=============================================================================

=============================================================================*/

void	CDlgValueText::GetFields()
{
	CString str;
	m_vis = m_wndCheckBtn_visible.GetCheck();
	if( m_units == MIL )
	{
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof( str ) * NM_PER_MIL;
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * NM_PER_MIL;
	}
	else
	{
		m_wndEditCtrl_height.GetWindowText( str );
		m_height = _tstof( str ) * 1000000.0;
		m_wndEditCtrl_width.GetWindowText( str );
		m_width = _tstof( str ) * 1000000.0;
	}
	m_def_width = m_height/10;
}

/*=============================================================================

=============================================================================*/

void	CDlgValueText::SetFields()
{
	CString str;
	m_wndCheckBtn_visible.SetCheck( m_vis );
	if( m_units == MIL )
	{
		MakeCStringFromDouble( &str, m_height/NM_PER_MIL );
		m_wndEditCtrl_height.SetWindowText( str );
		MakeCStringFromDouble( &str, m_width/NM_PER_MIL );
		m_wndEditCtrl_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_def_width/NM_PER_MIL );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
	else
	{
		MakeCStringFromDouble( &str, m_height/1000000.0 );
		m_wndEditCtrl_height.SetWindowText( str );
		MakeCStringFromDouble( &str, m_width/1000000.0 );
		m_wndEditCtrl_width.SetWindowText( str );
		MakeCStringFromDouble( &str, m_def_width/1000000.0 );
		m_wndEditCtrl_def_width.SetWindowText( str );
	}
}

void	CDlgValueText::OnCbnSelchangeComboRefTextUnits()
{
	GetFields();
	if( m_wndComboBox_units.GetCurSel() == 0 )
		m_units = MIL;
	else
		m_units = MM;
	SetFields();
}
