// FreePcb.cpp : Defines the class behaviors for the application. 
//

#include "stdafx.h"
#include "freepcb.h"
#include "resource.h"
#include "DlgShortcuts.h"
#include "afxwin.h"
//#include "QAFDebug.h"
#include <locale.h>

#if _MSC_VER >= 1400					/* Visual C++.NET 2005	(VC8.0)	*/
#if defined _M_IX86
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_IA64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_X64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#else
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;  
#endif

/*=============================================================================

=============================================================================*/
LPCTSTR	CFreePcbApp::s_lpszBoardLayerNames[MAX_LAYERS]= {_T("selection")					/* [ 0]:I						*/
														,_T("background")					/* [ 1]:wi						*/
														,_T("visible grid")					/* [ 2]:Obh					*/
														,_T("highlight")					/* [ 3]:nCCg					*/
														,_T("DRC error")					/* [ 4]:DRCG[					*/
														,_T("board outline")				/* [ 5]:{[hO`				*/
														,_T("rat line")						/* [ 6]:bclg				*/
														,_T("top silk")						/* [ 7]:i(A)ʃVN			*/
														,_T("bottom silk")					/* [ 8]:c(B)ʃVN			*/
														,_T("top sm cutout")				/* [ 9]:							*/
														,_T("bot sm cutout")				/* [10]:							*/
														,_T("thru pad")						/* [11]:							*/
														,_T("top copper")					/* [12]:i(A)ʓp^[		*/
														,_T("bottom copper")				/* [13]:c(B)ʓp^[		*/
														,_T("inner 1")						/* [14]:w(L1)					*/
														,_T("inner 2")						/* [15]:w(L2)					*/
														,_T("inner 3")						/* [16]:w(L3)					*/
														,_T("inner 4")						/* [17]:w(L4)					*/
														,_T("inner 5")						/* [18]:w(L5)					*/
														,_T("inner 6")						/* [19]:w(L6)					*/
														,_T("inner 7")						/* [20]:w(L7)					*/
														,_T("inner 8")						/* [21]:w(L8)					*/
														,_T("inner 9")						/* [22]:w(L9)					*/
														,_T("inner 10")						/* [23]:w(L10)					*/
														,_T("inner 11")						/* [24]:w(L11)					*/
														,_T("inner 12")						/* [25]:w(L12)					*/
														,_T("inner 13")						/* [26]:w(L13)					*/
														,_T("inner 14")						/* [27]:w(L14)					*/
														,_T("inner 15")						/* [28]:w(L15)					*/
														,_T("inner 16")						/* [29]:w(L16)					*/
														,_T("undefined")					/* [30]:							*/
														,_T("undefined")					/* [31]:							*/ };
/*=============================================================================

=============================================================================*/
LPCTSTR	CFreePcbApp::s_lpszFootprintLayerNames[NUM_FP_LAYERS]={_T("selection")				/* [ 0]:							*/
																,_T("background")			/* [ 1]:							*/
																,_T("visible grid")			/* [ 2]:							*/
																,_T("highlight")			/* [ 3]:							*/
																,_T("top silk")				/* [ 4]:							*/
																,_T("centroid")				/* [ 5]:							*/
																,_T("adhesive")				/* [ 6]:							*/
																,_T("thru pad")				/* [ 7]:							*/
																,_T("top mask")				/* [ 8]:							*/
																,_T("top paste")			/* [ 9]:							*/
																,_T("bottom mask")			/* [10]:							*/
																,_T("bottom paste")			/* [11]:							*/
																,_T("top copper")			/* [12]:							*/
																,_T("inner")				/* [13]:							*/
																,_T("bottom")				/* [14]:							*/ };
/*---------------------------------------------------------------------------*/


/////////////////////////////////////////////////////////////////////////////
// CFreePcbApp
/////////////////////////////////////////////////////////////////////////////

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CFreePcbApp, CWinApp)
	//{{AFX_MSG_MAP(CFreePcbApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
	ON_COMMAND(ID_VIEW_FOOTPRINT, OnViewFootprint)
	ON_COMMAND(ID_VIEW_PCB_EDITOR, OnViewPcbEditor)
	ON_COMMAND(ID_FILE_OPENFOOTPRINTEDITOR, OnViewFootprint)
	ON_COMMAND(ID_HELP_GOTOWEBSITE, OnHelpGotoWebsite)
	ON_COMMAND(ID_FILE_MRU_FILE1, OnFileMruFile1)
	ON_COMMAND(ID_FILE_MRU_FILE2, OnFileMruFile2)
	ON_COMMAND(ID_FILE_MRU_FILE3, OnFileMruFile3)
	ON_COMMAND(ID_FILE_MRU_FILE4, OnFileMruFile4)
	ON_COMMAND(ID_HELP_KEYBOARDSHORTCUTS, OnHelpKeyboardshortcuts)
	ON_COMMAND(ID_TOOLS_OPENONLINEAUTOROUTER, OnToolsOpenOnlineAutorouter)
	ON_COMMAND(ID_HELP_FREEROUTINGWEBSITE, OnHelpFreeRoutingWebsite)
	ON_COMMAND(ID_HELP_USERGUIDE_PDF, OnHelpUserGuidePdf)
	ON_COMMAND(ID_HELP_FPCROUTE, OnHelpFpcRoute)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFreePcbApp construction

/*=============================================================================
						CFreePcbApp NX̍\z
=============================================================================*/

CFreePcbApp::CFreePcbApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance

	// set initial view mode
	m_view_mode = PCB;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFreePcbApp object

CFreePcbApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFreePcbApp initialization

/*=============================================================================

=============================================================================*/

BOOL	CFreePcbApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("eebit"));

	CWinApp::LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	if( CWinApp::m_pRecentFileList == NULL)
	{
		AfxMessageBox(_T("NOTE: The recent file list is disabled on your system.\nUse the system policy editor to re-enable."));
	}

	EnableShellOpen();

// #if(_MSC_VER>=1400)				// Visual Studio 2005 (VC 8.0) or later
//	setlocale(LC_CTYPE, "jpn");
	setlocale( LC_ALL, NULL ); 
// #endif

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	CSingleDocTemplate* pDocTemplate;

	pDocTemplate = new CSingleDocTemplate(IDR_MAINFRAME
										 ,RUNTIME_CLASS(CFreePcbDoc)
										 ,RUNTIME_CLASS(CMainFrame)
										 ,RUNTIME_CLASS(CFreePcbView));
	if(!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);

	// load menus
	VERIFY( m_main.LoadMenu( IDR_MAINFRAME ) );
	VERIFY( m_main_drag.LoadMenu( IDR_MAINFRAME_DRAG ) );
	VERIFY( m_foot.LoadMenu( IDR_FOOTPRINT ) );
	VERIFY( m_foot_drag.LoadMenu( IDR_FOOTPRINT_DRAG ) );

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The window has been initialized, so show and update it.
	UINT iShowCmd = GetProfileInt(_T("Settings"),_T("ShowCmd"),SW_SHOW);
	m_pMainWnd->ShowWindow(iShowCmd);
	m_pMainWnd->UpdateWindow();

#if(0)			/* @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	*/
	// set pointers to document and view
	CMainFrame * pMainWnd = (CMainFrame*)AfxGetMainWnd();
	m_Doc = (CFreePcbDoc*)pMainWnd->GetActiveDocument();
	m_View = (CFreePcbView*)pMainWnd->GetActiveView();
//	m_View->InitInstance();

	if( cmdInfo.m_nShellCommand == CCommandLineInfo::FileOpen )
	{
		CString fn = cmdInfo.m_strFileName;
		m_Doc->OnFileAutoOpen( &fn );
	}
#endif			/* @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	*/

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

/*=============================================================================

=============================================================================*/

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

//--------------------------------------
// _CAO f[^(萔)
//--------------------------------------
protected:
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CEdit m_wndProgBuildInfo;
};

/*=============================================================================

=============================================================================*/

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

/*=============================================================================
			_CAOf[^̌ƗL`FbN
=============================================================================*/

void	CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	USES_CONVERSION;

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_EDIT1, m_wndProgBuildInfo);
	if(!pDX->m_bSaveAndValidate)			/* ϐRg[	*/
	{
		CString		strPgmVer,strMscVer,strMfcVer;

		// incoming
#ifdef _DEBUG
//		m_wndProgBuildInfo.SetWindowText(_T("371 Debug: (2008/10/13 00:11:48)"));
		strPgmVer.Format(_T("371 %s: (%s - %s)"),_T("Debug"),A2CT(__DATE__),A2CT(__TIME__));
#else
//		m_wndProgBuildInfo.SetWindowText(_T("371 Release: (2008/10/13 00:11:48)"));
		strPgmVer.Format(_T("371 %s: (%s - %s)"),_T("Release"),A2CT(__DATE__),A2CT(__TIME__));
#endif
		strMscVer.Format(_T("Microsoft Visual C++ Version %d.%02d"),(_MSC_VER)/100,(_MSC_VER)%100);
		strMfcVer.Format(_T("Microsoft Foundation Class (MFC) Version %x.%02x"),(_MFC_VER)/256,(_MFC_VER)%256);
		m_wndProgBuildInfo.SetWindowText(strPgmVer+_T("\r\n")+strMscVer+_T("\r\n")+strMfcVer);
	}
}

/*=============================================================================
					NX̃bZ[W}bv
=============================================================================*/

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*=============================================================================

=============================================================================*/

// App command to run the dialog
void	CFreePcbApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CFreePcbApp message handlers


/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnViewFootprint()
{
	SwitchToView(RUNTIME_CLASS(CFootprintView));
	m_view_mode = FOOTPRINT;
	return;
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnViewPcbEditor()
{	
	SwitchToView(RUNTIME_CLASS(CFreePcbView));
	m_view_mode = PCB;
	return;
}

/*=============================================================================

=============================================================================*/

// switch to a new CView
//
BOOL CFreePcbApp::SwitchToView( CRuntimeClass * pNewViewClass )
{
	// I have no idea what most of this code actually does, but it seems to work
	CMainFrame		*pMainWnd;
	CFreePcbDoc		*pDoc;
	CView			*pOldActiveView;
	CView			*pNewActiveView;

	pMainWnd=(CMainFrame *)AfxGetMainWnd();
	ASSERT_KINDOF(CMainFrame,pMainWnd);
	pOldActiveView=pMainWnd->GetActiveView();
//	ASSERT(pOldActiveView);

	if(pOldActiveView)
		pDoc=(CFreePcbDoc*)pOldActiveView->GetDocument();
	else
		pDoc=(CFreePcbDoc*)pMainWnd->GetActiveDocument();
	ASSERT(pDoc);

	if(pOldActiveView->IsKindOf(pNewViewClass))		/* ɃANeBu */
		return TRUE;
	if(pNewViewClass==RUNTIME_CLASS(CFreePcbView))			// switch to pcb view
	{
		pNewActiveView=pDoc->GetFreePcbView();
		ASSERT(pNewActiveView);
	}
	else if(pNewViewClass==RUNTIME_CLASS(CFootprintView))	// switch to footprint view
	{
		pNewActiveView=pDoc->GetFootprintView();
		if(!pNewActiveView)
		{
			CCreateContext context;

			context.m_pNewViewClass=pNewViewClass;
			context.m_pCurrentDoc  =pDoc;
			pNewActiveView=STATIC_DOWNCAST(CView, pMainWnd->CreateView(&context));
			ASSERT(pNewActiveView);
		}
	}
	else
		ASSERT(FALSE);			/* Unknown runtime class	*/
	if(pNewActiveView)
	{
#if 0
		CMenu m_NewMenu;
		if(pNewViewClass==RUNTIME_CLASS(CFreePcbView))
			m_NewMenu.LoadMenu(IDR_MAINFRAME);
		else
			m_NewMenu.LoadMenu(IDR_FOOTPRINT);
		ASSERT(m_NewMenu);
		// Add the new menu
		pMainWnd->SetMenu(&m_NewMenu);
		m_NewMenu.Detach();
#endif
		if(pNewViewClass==RUNTIME_CLASS(CFreePcbView))
			pMainWnd->SetMenu(&m_main);
		else
			pMainWnd->SetMenu(&m_foot);

		// Exchange view window IDs so RecalcLayout() works.

//		UINT temp = ::GetWindowLong(pOldActiveView->m_hWnd, GWL_ID);
//		::SetWindowLong(pOldActiveView->m_hWnd, GWL_ID, ::GetWindowLong(pNewView->m_hWnd, GWL_ID));
//		::SetWindowLong(pNewActiveView->m_hWnd, GWL_ID, temp);

		if(pOldActiveView)
		{
			pOldActiveView->ShowWindow(SW_HIDE);					// ÂʂB(\)
			pOldActiveView->SetDlgCtrlID(AFX_IDW_PANE_FIRST+1);		// IDύX.
		}
		pNewActiveView->ShowWindow(SW_SHOW);						// Vʂ\
        pNewActiveView->SetDlgCtrlID(AFX_IDW_PANE_FIRST);			// SDÎ
		pNewActiveView->OnInitialUpdate();
		pMainWnd->SetActiveView(pNewActiveView);					// ActiveView̕ύX
		pMainWnd->RecalcLayout();									// c[o[ȂǂύX

		if(pNewViewClass==RUNTIME_CLASS(CFreePcbView))
		{
			// switch to pcb view
			// first, see if we were editing the footprint of the selected part
			CShape		*temp_footprint;

			if(	((CFreePcbView *)pNewActiveView)->m_cursor_mode == CUR_PART_SELECTED 
				&& pDoc->m_wndEditCtrl_footprint
				&& (pDoc->m_footprint_modified || pDoc->m_footprint_name_changed) )
			{
				// yes, make a copy of the footprint from the editor
				temp_footprint = new CShape;
				temp_footprint->Copy( &((CFootprintView *)pOldActiveView)->m_fp );
			}
			if(pOldActiveView)
				pOldActiveView->DestroyWindow();					// destroy old footprint view
			if( !pDoc->m_project_open )
			{
				pDoc->m_project_modified = FALSE;
				pDoc->m_project_modified_since_autosave = FALSE;
				pDoc->OnFileClose();	
			}
			// restore toolbar stuff

			pMainWnd->m_wndMyToolBar.SetLists(&pDoc->m_visible_grid
											 ,&pDoc->m_part_grid
											 ,&pDoc->m_routing_grid
											 ,pDoc->m_visual_grid_spacing
											 ,pDoc->m_part_grid_spacing
											 ,pDoc->m_routing_grid_spacing
											 ,pDoc->m_snap_angle
											 ,pDoc->m_units);
			((CFreePcbView *)pNewActiveView)->m_dlist->SetVisibleGrid( 1, pDoc->m_visual_grid_spacing );
			pMainWnd->SetWindowText( pDoc->m_window_title ); 
			((CFreePcbView *)pNewActiveView)->ShowSelectStatus();
			((CFreePcbView *)pNewActiveView)->ShowActiveLayer();
			if(((CFreePcbView *)pNewActiveView)->m_cursor_mode == CUR_PART_SELECTED 
			&& (pDoc->m_wndEditCtrl_footprint)
			&& (pDoc->m_footprint_modified || pDoc->m_footprint_name_changed) )
			{
				// now offer to replace the footprint of the selected part 
				((CFreePcbView *)pNewActiveView)->OnExternalChangeFootprint( temp_footprint );
				delete temp_footprint;
			}
			pDoc->m_wndEditCtrl_footprint = FALSE;	// clear this flag for next time
		}
		else								// switching to footprint view, create it
		{
			int units = MIL;
			if(((CFreePcbView *)pOldActiveView)->m_cursor_mode == CUR_PART_SELECTED && pDoc->m_wndEditCtrl_footprint )
			{
				((CFootprintView *)pNewActiveView)->InitInstance(((CFreePcbView *)pOldActiveView)->m_sel_part->shape );
				units=((CFreePcbView *)pOldActiveView)->m_sel_part->shape->m_units;
			}
			else
			{
				((CFootprintView *)pNewActiveView)->InitInstance(NULL);
			}
			// restore toolbar stuff

			pMainWnd->m_wndMyToolBar.SetLists(&pDoc->m_fp_visible_grid
											 ,&pDoc->m_fp_part_grid
											 ,NULL
											 ,pDoc->m_fp_visual_grid_spacing
											 ,pDoc->m_fp_part_grid_spacing
											 ,0
											 ,pDoc->m_fp_snap_angle
											 ,units);
			((CFootprintView *)pNewActiveView)->m_dlist->SetVisibleGrid(1
																	  ,pDoc->m_fp_visual_grid_spacing);
		}
		// resize window in case it changed
		CRect client_rect;
		pMainWnd->GetClientRect( client_rect );
		// TODO: replace these constants
		client_rect.top += 24;		// leave room for toolbar
		client_rect.bottom -= 18;	// leave room for status bar
		pNewActiveView->MoveWindow( client_rect, 1 );

		return TRUE;
	}
	return FALSE;
}

/*=============================================================================

=============================================================================*/

int CFreePcbApp::ExitInstance()
{
	return( CWinApp::ExitInstance() );
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnHelpGotoWebsite()
{
    SHELLEXECUTEINFO ShExecInfo;
	CString fn = _T("http://www.freepcb.com");

	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = NULL;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = NULL;
	ShExecInfo.lpFile = fn;
	ShExecInfo.lpParameters = NULL;
	ShExecInfo.lpDirectory = NULL;
	ShExecInfo.nShow = SW_MAXIMIZE;
	ShExecInfo.hInstApp = NULL;

	ShellExecuteEx(&ShExecInfo);
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnFileMruFile1() 
{
	ASSERT( CWinApp::m_pRecentFileList );
	CString str = (*CWinApp::m_pRecentFileList)[0];
	CFreePcbDoc *pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);
	pDoc->OnFileAutoOpen( &str );
	return;
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnFileMruFile2()
{
	ASSERT( CWinApp::m_pRecentFileList );
	CString str = (*CWinApp::m_pRecentFileList)[1];
	CFreePcbDoc *pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);
	pDoc->OnFileAutoOpen( &str );
	return;
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnFileMruFile3()
{
	ASSERT( CWinApp::m_pRecentFileList );
	CString str = (*CWinApp::m_pRecentFileList)[2];
	CFreePcbDoc *pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);
	pDoc->OnFileAutoOpen( &str );
	return;
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnFileMruFile4()
{
	ASSERT( CWinApp::m_pRecentFileList );
	CString str = (*CWinApp::m_pRecentFileList)[3];
	CFreePcbDoc *pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);
	pDoc->OnFileAutoOpen( &str );
	return;
}

/*=============================================================================

=============================================================================*/

BOOL CFreePcbApp::OnOpenRecentFile(UINT nID)
{
	return( CWinApp::OnOpenRecentFile( nID ) );
}

/*=============================================================================

=============================================================================*/

CString CFreePcbApp::GetMRUFile()
{
	CString		str;
	CRecentFileList * pRecentFileList = CWinApp::m_pRecentFileList;

	if((pRecentFileList == NULL)
	|| (pRecentFileList->GetSize()==0))
		str=_T("");
	else
		str = (*CWinApp::m_pRecentFileList)[0];
	return str;
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::AddMRUFile( CString * str )
{
	CRecentFileList * pRecentFileList = CWinApp::m_pRecentFileList;
	if( m_pRecentFileList == NULL )
		return;
	(*CWinApp::m_pRecentFileList).Add( *str );
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnHelpKeyboardshortcuts()
{
	CDlgShortcuts dlg = new CDlgShortcuts;
	dlg.DoModal();
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnToolsOpenOnlineAutorouter()
{
	SHELLEXECUTEINFO	ShExecInfo;
	CFreePcbDoc			*pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);

	CString fn = pDoc->m_app_dir + _T("\\freeroute.jnlp");

	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = NULL;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = NULL;
	ShExecInfo.lpFile = fn;
	ShExecInfo.lpParameters = NULL;
	ShExecInfo.lpDirectory = NULL;
	ShExecInfo.nShow = SW_MAXIMIZE;
	ShExecInfo.hInstApp = NULL;

	ShellExecuteEx(&ShExecInfo);
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnHelpFreeRoutingWebsite()
{
    SHELLEXECUTEINFO ShExecInfo;
	CString fn = _T("http://www.freerouting.net");

	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = NULL;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = NULL;
	ShExecInfo.lpFile = fn;
	ShExecInfo.lpParameters = NULL;
	ShExecInfo.lpDirectory = NULL;
	ShExecInfo.nShow = SW_MAXIMIZE;
	ShExecInfo.hInstApp = NULL;

	ShellExecuteEx(&ShExecInfo);
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnHelpUserGuidePdf()
{
    SHELLEXECUTEINFO ShExecInfo;
	CFreePcbDoc			*pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);

	CString fn = pDoc->m_app_dir + _T("\\..\\doc\\freepcb_user_guide.pdf");

	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = NULL;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = NULL;
	ShExecInfo.lpFile = fn;
	ShExecInfo.lpParameters = NULL;
	ShExecInfo.lpDirectory = NULL;
	ShExecInfo.nShow = SW_MAXIMIZE;
	ShExecInfo.hInstApp = NULL;

	ShellExecuteEx(&ShExecInfo);
}

/*=============================================================================

=============================================================================*/

void	CFreePcbApp::OnHelpFpcRoute()
{
    SHELLEXECUTEINFO ShExecInfo;
	CFreePcbDoc			*pDoc;

	pDoc=(CFreePcbDoc *)((CMainFrame *)GetMainWnd())->GetActiveDocument();
	ASSERT_KINDOF(CFreePcbDoc,pDoc);

	CString fn = pDoc->m_app_dir + _T("\\..\\doc\\fpcroute_user_guide.pdf");

	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = NULL;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = NULL;
	ShExecInfo.lpFile = fn;
	ShExecInfo.lpParameters = NULL;
	ShExecInfo.lpDirectory = NULL;
	ShExecInfo.nShow = SW_MAXIMIZE;
	ShExecInfo.hInstApp = NULL;

	ShellExecuteEx(&ShExecInfo);
}

/*=============================================================================

=============================================================================*/

int CFreePcbApp::DoMessageBox(LPCTSTR lpszPrompt, UINT nType, UINT nIDPrompt)
{
	// show cursor
	CMainFrame * frm = (CMainFrame*)AfxGetMainWnd();
	::ShowCursor( TRUE );
	int ret = CWinApp::DoMessageBox(lpszPrompt, nType, nIDPrompt);
	::ShowCursor( FALSE );
	return ret;
}

/*=============================================================================

=============================================================================*/

LPCTSTR		CFreePcbApp::GetBoardLayerName(int nLayer) /*static*/
{
	if(0<=nLayer && nLayer<MAX_LAYERS)
		return(s_lpszBoardLayerNames[nLayer]);
	else
	{
		ASSERT(FALSE);
		return(NULL);
	}
}

/*=============================================================================

=============================================================================*/

LPCTSTR		CFreePcbApp::GetFootprintLayerName(int nLayer) /*static*/
{
	if(0<=nLayer && nLayer<NUM_FP_LAYERS)
		return(s_lpszFootprintLayerNames[nLayer]);
	else
	{
		ASSERT(FALSE);
		return(NULL);
	}
}

/*=============================================================================

=============================================================================*/

CFreePcbView	*CFreePcbApp::GetFreePcbView()
{
	CMainFrame	*pMainFrame;

	pMainFrame=(CMainFrame *)GetMainWnd();
	ASSERT(pMainFrame);
	if(pMainFrame)
	{
		CFreePcbDoc		*pDoc;

		pDoc=(CFreePcbDoc *)pMainFrame->GetActiveDocument();
		if(pDoc)
			return(pDoc->GetFreePcbView());
	}
	return(NULL);
}

/*=============================================================================

=============================================================================*/

CFootprintView	*CFreePcbApp::GetFootprintView()
{
	CMainFrame	*pMainFrame;

	pMainFrame=(CMainFrame *)GetMainWnd();
	ASSERT(pMainFrame);

	if(pMainFrame)
	{
		CFreePcbDoc		*pDoc;

		pDoc=(CFreePcbDoc *)pMainFrame->GetActiveDocument();
		if(pDoc)
			return(pDoc->GetFootprintView());
	}
	return(NULL);
}

/*=============================================================================
				Show messagebox on shell execution error(s)
=============================================================================*/

void	ShowShellExecuteErrors(HINSTANCE hInst)
{
	if((INT)hInst<=32)
	{
		CString		strErrMsg;

		switch((INT)hInst)
		{
			case 0:						VERIFY(strErrMsg.LoadString(IDS_ERR_SHORT_MEMORY));
										break;
//			case ERROR_FILE_NOT_FOUND:	VERIFY(strErrMsg.LoadString(IDS_ERR_FILE_NOT_FOUND));
//										break;
//			case ERROR_PATH_NOT_FOUND:	VERIFY(strErrMsg.LoadString(IDS_ERR_PATH_NOT_FOUND));
//										break;
			case ERROR_BAD_FORMAT:		VERIFY(strErrMsg.LoadString(IDS_ERR_BAD_FORMAT));
										break;
			case SE_ERR_ACCESSDENIED:	VERIFY(strErrMsg.LoadString(IDS_SE_ERR_ACCESSDENIED));
										break;
			case SE_ERR_ASSOCINCOMPLETE:VERIFY(strErrMsg.LoadString(IDS_SE_ERR_ASSOCINCOMPLETE));
										break;
			case SE_ERR_DDEBUSY:		VERIFY(strErrMsg.LoadString(IDS_SE_ERR_DDEBUSY));
										break;
			case SE_ERR_DDEFAIL:		VERIFY(strErrMsg.LoadString(IDS_SE_ERR_DDEFAIL));
										break;
			case SE_ERR_DDETIMEOUT:		VERIFY(strErrMsg.LoadString(IDS_SE_ERR_DDETIMEOUT));
										break;
			case SE_ERR_DLLNOTFOUND:	VERIFY(strErrMsg.LoadString(IDS_SE_ERR_DLLNOTFOUND));
										break;
			case SE_ERR_FNF:			VERIFY(strErrMsg.LoadString(IDS_SE_ERR_FNF));
										break;
			case SE_ERR_NOASSOC:		VERIFY(strErrMsg.LoadString(IDS_SE_ERR_NOASSOC));
										break;
			case SE_ERR_OOM:			VERIFY(strErrMsg.LoadString(IDS_SE_ERR_OOM));
										break;
			case SE_ERR_PNF:			VERIFY(strErrMsg.LoadString(IDS_SE_ERR_PNF));
										break;
			case SE_ERR_SHARE:			VERIFY(strErrMsg.LoadString(IDS_SE_ERR_SHARE));
										break;
			default:					strErrMsg.Format(_T("Undefined Shell Error - 0x%08x"),(INT)hInst);
										break;
		}
		AfxMessageBox(strErrMsg,MB_ICONEXCLAMATION|MB_OK);
	}
}

/*-----------------------------------------------------------------------------
							end of FreePcb.cpp
-----------------------------------------------------------------------------*/
