// FreePcb.h : main header file for the FREEPCB application
//


#if !defined(AFX_FREEPCB_H__2D973E6F_7601_4C61_8528_D36001F51E5D__INCLUDED_)
#define AFX_FREEPCB_H__2D973E6F_7601_4C61_8528_D36001F51E5D__INCLUDED_

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include	"resource.h"       // main symbols
#include	"layers.h"


#define		USEING_XP_THEME		(1)


#if(USEING_XP_THEME)
#include	<uxtheme.h>
#include	<tmschema.h>

#pragma comment(lib, "uxtheme.lib")
#endif

#define ZOOM_RATIO 1.4

// constants for function key menu (Unit in pixel)
#define FKEY_OFFSET_X		(4)							/**< Offset from screen left to first column function key			*/
#define FKEY_OFFSET_Y		(4)							/**< Offset from bottom of the view client to function key bottom	*/
#define	FKEY_R_W			(70)						/**< Width of the each function key button rectangle on screen		*/
#define FKEY_R_H			(36)						/**< Height of the each function key button rectangle on screen		*/
#define FKEY_STEP			(FKEY_R_W+5)				/**< */
#define FKEY_GAP			(20)						/**< */
#define FKEY_SEP_W			(16)						/**< */


class CFootprintView;

// units for length
enum
{
	NM,		// nanometers
	MM,		// millimeters
	MIL,	// mils (1/1000 inch)
	MM_MIL,	// both mm and mils (for text output)
	NATIVE	// native units (for text output )
};
// conversion factors
#define NM_PER_MIL		(25400)
#define NM_PER_MM		(1000000)

// there are four coordinate systems:
//	WU = window coords
//	screen coords (pixels)
//	PCBU = PCB coords (nanometers)
//	DU = display coords (mils)
//
// conversion factors
#define PCBU_PER_MIL	NM_PER_MIL
#define PCBU_PER_MM		NM_PER_MM

#define PCB_BOUND	(32000*PCBU_PER_MIL)		// boundary

// custom messages
enum
{
	 WM_USER_VISIBLE_GRID = WM_USER +1		/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,WM_USER_PLACEMENT_GRID					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,WM_USER_ROUTING_GRID					/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,WM_USER_SNAP_ANGLE						/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,WM_USER_UNITS							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};
enum
{
	 WM_BY_VALUE							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,WM_BY_INDEX							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	,WM_BY_STRING							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
};

void	ShowShellExecuteErrors(HINSTANCE hInst);

/////////////////////////////////////////////////////////////////////////////
// CFreePcbApp:
// See FreePcb.cpp for the implementation of this class
//
/*==============================================================================

==============================================================================*/

class CFreePcbApp : public CWinApp
{
public:
	enum
	{
		 PCB = 1							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
		,FOOTPRINT							/**< ToDo:Describe short comment, about this enum constant value for Doxygen					*/
	};
//--------------------------------------
// Construction/Destruction - y\z/Łz
//--------------------------------------
	CFreePcbApp();
//--------------------------------------
// f[^o(ϐ)
//--------------------------------------
public:
enum
{
		MAX_LAYERS=32					/**<  {[h̍ő僌C		*/
};

	CMenu				m_main;								// main menus
	CMenu				m_main_drag;
	CMenu				m_foot;
	CMenu				m_foot_drag;
protected:
	static LPCTSTR		s_lpszBoardLayerNames[MAX_LAYERS];
	static LPCTSTR		s_lpszFootprintLayerNames[NUM_FP_LAYERS];

	int					m_view_mode;						// FOOTPRINT or PCB
//--------------------------------------
// Override(s) - yz֐z
//--------------------------------------
	//{{AFX_VIRTUAL(CFreePcbApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL
//--------------------------------------
// Attribute(s) - yz
//--------------------------------------
public:

	int		GetViewMode() const { return(m_view_mode); }		// FOOTPRINT or PCB
	CString GetMRUFile();
	void AddMRUFile( CString * str );

	static LPCTSTR		GetBoardLayerName(int nLayer);
	static LPCTSTR		GetFootprintLayerName(int nLayer);

	class CFreePcbView		*GetFreePcbView();			/**< Get 'CFreePcbView' class object pointer for current active document.	*/
	class CFootprintView	*GetFootprintView();		/**< Get 'CFootprintView' class object pointer for current active document.	*/
//--------------------------------------
// Implementation(s) - yz
//--------------------------------------
	BOOL SwitchToView( CRuntimeClass * pNewViewClass );
	int DoMessageBox(LPCTSTR lpszPrompt, UINT nType, UINT nIDPrompt);
//--------------------------------------
// Generated message map function(s)
//--------------------------------------
public:
	BOOL OnOpenRecentFile(UINT nID);
	//{{AFX_MSG(CFreePcbApp)
	afx_msg void OnViewFootprint();
	afx_msg void OnViewPcbEditor();
	afx_msg void OnHelpGotoWebsite();
	afx_msg void OnFileMruFile1();
	afx_msg void OnFileMruFile2();
	afx_msg void OnFileMruFile3();
	afx_msg void OnFileMruFile4();
	afx_msg void OnHelpKeyboardshortcuts();
	afx_msg void OnToolsOpenOnlineAutorouter();
	afx_msg void OnHelpFreeRoutingWebsite();
	afx_msg void OnHelpUserGuidePdf();
	afx_msg void OnHelpFpcRoute();
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
/*-----------------------------------------------------------------------------
							end of FreePcb.h
-----------------------------------------------------------------------------*/
#endif // !defined(AFX_FREEPCB_H__2D973E6F_7601_4C61_8528_D36001F51E5D__INCLUDED_)
